Windows Media Services

Windows Media Services enables you to stream multimedia content over networks that range from low-bandwidth, dial-up Internet connections to high-bandwidth, local area networks. When you install Windows Media Services, you can choose Windows Media Services in the Windows Components Wizard to install the Windows Media component services and Windows Media Administrator. Click Details and select only Windows Media Services Admin to install only Windows Media Administrator. Install only Windows Media Administrator if you want to remotely administer a Windows Media server.

This documentation provides information about using Windows Media component services to stream Windows Media content. This documentation is also provided in .doc format in the SystemDrive\SystemRoot\system32\Windows Media\docs\print directory and can be viewed with Microsoft WordPad or Microsoft Word.

Note

  • The names of companies, products, people, characters, and/or data mentioned herein are fictitious and are in no way intended to represent any real individual, company, product, or event, unless otherwise noted.

© 1996-1999 Microsoft Corporation. All rights reserved.


Getting started

When you employ Windows Media Services on your Web site, you see that it works similarly to a Web server. You also see how it can add capabilities to your Web site, such as offering radio and television programs, slide show presentations, file transfers, movies, and multimedia shows.

As an administrator of Windows Media Services, you are responsible for configuring the server in order to make content available to your users, and for determining the method by which you provide that content. The following diagram illustrates, generally, how ASF content is provided to users.

It is recommended that you dedicate a separate NTFS volume for storing on-demand content. For best results, this volume should be on a separate physical disk. NTFS volumes are more efficient than FAT16 partitions, in terms of storage space used and disk-read operations. An NTFS volume also permits use of access control list (ACL) checking on your content files.

Note

  • The Windows Media Tools applications listed for the Windows Media Tools computer can be downloaded from the Windows Media Technologies page at the Microsoft Web site.


Using the Internet or an intranet

Windows Media Services is a product that can be used to provide content to both Internet and intranet users. However, you do several things differently depending on your target audience.

If you decide to provide content to the Internet, be aware of the following issues:

  • Most of the Internet is not multicast-enabled, so you must provide unicast alternatives for any multicast content.
  • Internet bandwidth is not reliable. Internet traffic fluctuates greatly, and the type of connection a user obtains can differ with each connection.
  • Networks that use a proxy server may need special configuration to provide Internet client access to the Windows Media server.
  • If you use a Web server program in conjunction with Windows Media Services (that is, they share the same computer), verify that they are not using conflicting HTTP ports and that all links can be resolved when accessed by an Internet client.

If you decide to provide content to an intranet, be aware of the following issues:

  • Some of your system components may be separated by a firewall.
  • To provide multicast content, your network must have multicast-enabled routers.
  • Consider how many administrators you will have for your server, and whether you will need remote administrators.
  • Consider how users will access your content.


Concepts

Windows Media Services offers the ability to provide multimedia content to a large number of clients using ASF, .wma, .MP3 and .wav formats.

Each client can render content as it is being received over the network without downloading the content first due to the use of data streaming. Streaming greatly reduces the wait time and storage requirements on the client. It also permits presentations of unlimited length, as well as live broadcasts.

This section provides an overview of key Windows Media Services concepts and the components used to create, deliver, and play back streaming media.

Note

  • ASF is the suggested format for streaming. If you choose to stream .wav or .MP3 files, understand that server performance can be significantly affected. Also, features such as adding images and script commands are not available.


ASF overview

Windows Media Services uses ASF, an open standard that supports data delivery over a variety of networks and protocols. ASF is used to arrange, organize and synchronize multimedia data for streaming over networks. ASF is a file format; however, it can be used to specify the format of live presentations as well. While ASF is optimized for sending multimedia streams over networks, it is equally suited for local playback as well.

Any compression-decompression algorithm (codec) can be used to encode ASF streams. Information stored in the ASF stream can be used to aid the client in determining which codec is needed to decompress the stream. In addition, ASF streams can be carried over any underlying network transmission protocol.

Windows Media Audio, which has a .wma file extension, is an audio-only ASF file compressed with the Windows Media Audio codec. This type of media differs from .asf files only in its extension. Windows Media server can stream .wma files, and you can announce .wma files (called .wax files) using the program manager. Microsoft created .wma files for use with clients that play audio only.


Windows Media Audio overview

Windows Media Audio files are audio-only .asf files compressed with the Windows Media Audio codec and renamed with a .wma extension. The Windows Media Tools and Windows Media server do not create Windows Media Audio content. Instead, to convert ASF content to Windows Media Audio content, rename the file's extension from .asf to .wma. All .wma files have their own stream redirector files called .wax files. These .wax files function exactly like ASF stream redirector files (.asx files) except that .wax files are designed to announce Windows Media Audio content. You create a .wax file by renaming an .asx file with a .wax extension.


MP3 overview

Windows Media Services streams .mp3 files just as it streams .asf and .wma files. This means you can place .mp3 files in the virtual root directory (SystemDrive\ASFRoot) or any unicast publishing point, and users will be able to stream the .mp3 files instead of downloading them. You can also use .mp3 files as the source for a multicast either by transcoding the .mp3 file into an .asf file using Windows Media Encoder or making the station use an .mp3 file located in a publishing point.

Using .mp3 files in a playlist

If you reference an .mp3 file in an .asx file playlist using an HTTP URL, the link to the .mp3 file requires an .asf extension. Notice the HTTP reference to file2.mp3 in the following playlist:

<ASX version = "3.0">
<Entry><Ref href = "mms://server/file1.asf" /> </Entry>
<Entry><Ref href =  "http://server/file2.mp3?ext=.asf" /> </Entry>
<Entry><Ref href =  "mms://server/file3.mp3" /> </Entry> </asx>

The HTTP reference to the .mp3 file requires that ?ext=.asf be added to the end of the file name so that Windows Media Player is used to play the .mp3 file.


Understanding unicast vs. multicast streaming

Windows Media Services uses the terms unicast and multicast when describing how clients receive data packets from a Windows Media server.

About unicast

A unicast is a point-to-point connection between the client and server. Point-to-point means that each client receives a distinct stream from the server. A unicast stream is sent to only the client that requested it.

Unicast streams can be distributed to a client in one of two ways:

  • On-demand
  • Broadcast

About multicast

A multicast is a content stream delivered over a multicast-enabled network; all clients on the network share the same stream. The biggest advantage of streaming ASF content in this manner is that it saves network bandwidth.

You can extend a multicast to areas of your network that are not multicast-enabled by setting up Windows Media servers on each segment of your network—this is called server distribution. As part of a multicast from a server, you can distribute a single stream (of that multicast) to other Windows Media servers on other segments of the network. The servers subsequently provide the stream to their network segment via unicast or multicast; this is known as re-distribution. By chaining one server to another, you can overcome routers that are not multicast-enabled. This model also works for getting through a firewall.

The Windows Media Services administrator must create three items to support a multicast: a station, program, and stream. The station serves as the reference point for clients that want to connect to the stream. The program organizes content items that are going to be broadcast over the station. The stream is the actual content. Once these all are created, Windows Media Administrator creates an .asx file that links clients to the correct IP address for the station; this file is also called an announcement. You can link to the announcement file from a Web page, place it in a public share point on the network, or send it to clients via e-mail.


Understanding on-demand vs. broadcast streaming

Windows Media Services uses the terms on-demand and broadcast when describing the client/server relationship. An on-demand stream affords the user an active means of controlling playback, while a broadcast stream provides a passive user experience.


On-demand streaming overview

On-demand is one of the ways in which a user receives streaming information from a Windows Media server. An on-demand connection is an active connection between the client and server. In an on-demand connection, the user initiates the client connection to the server by selecting the content item. The content is carried from the server to the client in an ASF stream. If the file is indexed, the user can start, stop, rewind, fast-forward, or pause the stream. On-demand connections offer the most control of the stream, but they can quickly use up the bandwidth of a network because each client has its own connection to a server.

An example of an on-demand unicast is when a user requests a stored .asf file. The client connects to the server to receive a specific piece of content, and the content is streamed only to a single client. The client uses the name of the server and the name of the .asf file to identify the URL of the .asf file.

On Demand Unicast


Broadcast streaming overview

Broadcast refers to a passive user experience of receiving a stream. During a broadcast, the client receives the stream, but does not control the stream. For example, the user cannot pause, fast-forward, or rewind the stream. There are two types of broadcasts—unicast and multicast—both of which are passive.

Broadcast unicast

In a broadcast unicast, the stream is accessed by the client from an alias on a publishing point. The user can click a link in a Web page or otherwise be provided the URL to the alias, and connect to the stream. Each user who connects to the stream has his or her own connection and stream of data coming from the server.

For example, Windows Media Encoder sends a content stream to a broadcast publishing point on the Windows Media server. All publishing points have an alias—the alias for the broadcast publishing point in this example is TV1. The client uses TV1 to identify the path to the stream source. Because the ASF stream of the television station can be identified by a publishing point, the URL reference to the ASF stream is similar to that of a stored .asf file. However, instead of identifying the name of an .asf file, you identify the publishing point alias—TV1. Thus, in this example, the user uses the following path to access the stream—mms://Server1/TV1.

Broadcast multicast

In a broadcast multicast, the passive client receives a multicast ASF stream by monitoring a specific IP address (similar to receiving a signal from a radio or TV station over a distinct frequency). The advantage of a multicast is that a single stream can provide ASF content to many clients across the network. This preserves network bandwidth, and can be extremely useful for low bandwidth local area networks.

To use multicast broadcasting on a network, the network routers must support multicasting. However, whether or not your network routers support multicasts, you can use Windows Media Services to multicast over the local segment of your local area network.


Understanding publishing point vs. station content

Windows Media Services uses the terms publishing points and stations when describing how the server provides content to a client.

A publishing point is used to access unicast content. A publishing point is a virtual directory that stores content you have made available to clients on your server. In Windows Media Administrator you have two types of publishing points that you can use to provide content to your clients.

  • On-demand unicast publishing points are used to provide .asf files.
  • Broadcast unicast publishing points are used to provide live ASF streams.

When creating publishing points, you can set limits on the number of clients that can access the publishing point at a given time, and on the amount of bandwidth that can be used by that publishing point. These limits are useful in managing the amount of bandwidth that the publishing point consumes. If you find that a publishing point is in high demand, consider providing its content through a multicast station to save bandwidth.

A station is used to access multicast content. A station consists of at least one program and stream. A station without associated programs and streams has no content. Because stations are multicast, the stream is shared among all clients that want to access it; the number of clients has no impact on the network or the stream. Thus, there is no need to limit the number of clients that can access the streams.


Announcing ASF content

You can make it easy for users to request and receive ASF content by providing an announcement, an .asx file for your ASF content. An announcement is a specially formatted text file, saved with an .asx extension, designed to be distributed to clients via e-mail, placed on a server for UNC access, or linked to from a Web page to be downloaded. No matter how you make the .asx file accessible, all the user has to do to access ASF content is run the .asx file.

Windows Media Services uses announcements for live streams, .asf files, and .wma files. Announcements for .wma files are called .wax files. Announcements are not used for file transfers.


Using playlists

A playlist is a set of pointers to multiple .asf files or ASF streams. Each file or stream is referenced by a URL. Windows Media Services supports two types of playlists—client-side and server-side.


Understanding Windows Media Services protocols

The following diagram depicts how protocols are used to communicate between the components of a Windows Media Services system.

Windows Media Protocols

Notice that you can connect all of the components via HTTP, allowing them to communicate even if they are separated by a firewall.

Clients that connect to a multicast do not use a protocol; they receive the data as it streams over the multicast IP address and do not need to negotiate a connection.

Note

  • The Windows Media Tools applications listed for the Windows Media Tools computer can be downloaded from the Windows Media Technologies page at the Microsoft Web site.


MMS protocol overview

The MMS protocol is used to access unicast content from a Windows Media publishing point. MMS is the default method of connecting to the Windows Media Unicast service. If viewers are going to type a URL in Windows Media Player to connect to content rather than access the content through a hyperlink, they must use MMS protocol and have a reference for the stream.

When connecting to a publishing point using the MMS protocol, protocol rollover is used to get the best connection. Protocol rollover starts by trying to connect the client to the server via MMSU. MMSU is the MMS protocol combined with UDP data transport. If the MMSU connection is unsuccessful, then the server attempts to use MMST. MMST is the MMS protocol combined with TCP data transport.

If you are connecting to an indexed .asf file and want to be able to fast-forward, rewind, pause, start, and stop the stream, you must use MMS. You cannot fast-forward or rewind with UNC paths.

When you connect to a publishing point from a stand-alone Windows Media Player, you must specify the URL to the unicast content. If your content is being published on-demand over the Home publishing point, the URL is composed of the server name and .asf file name. For example:

mms://windows_media_server/sample.asf

Where windows_media_server is the name of the Windows Media server and sample.asf is the name of the .asf file you want to stream.

If you have live content to publish via broadcast unicast, the URL is composed of the server name and publishing point alias. For example:

mms://windows_media_server/LiveEvents

Where windows_media_server is the name of the Windows Media server and LiveEvents is the name of the publishing point.


MSBD protocol overview

The MSBD protocol is used to distribute streams between Windows Media Encoder and the Windows Media server components, and to transfer streams between servers. MSBD is a connection-oriented protocol, optimized for use with streaming media. MSBD is useful in testing client server connectivity and ASF content quality, but should not be used as the main method of receiving ASF content. Windows Media Encoder can support a maximum of 15 MSBD clients; a Windows Media server can support a maximum of 5 MSBD clients.


HTTP overview

You can configure your Windows Media server to use the HTTP protocol to stream content. Using HTTP streaming helps to overcome firewalls as obstacles because most firewalls allow HTTP to pass through. HTTP streaming can also be used to stream content from Windows Media Encoder through a firewall to the Windows Media server and can be used to connect Windows Media servers that are separated by a firewall. If you are running Windows Media Services on the same computer as a Web server, such as Microsoft Internet Information Services (IIS), be sure there is not a conflict on port 80.


Using rollover

Sometimes Microsoft Windows Media Player cannot connect to the Windows Media server and access a unicast because of network problems, server maintenance, or other reasons. When you use the MMS protocol to publish your .asf file, protocol rollover is automatic from MMS protocol over UDP (MMSU) to MMS protocol over TCP and finally to HTTP. When attempting to connect to the stream source, Windows Media Player tries each protocol in turn until a connection to the source is made. This ensures that Windows Media Player can reach the data.

Use of the REF tag in an .asx file shows how protocol rollover works. The REF tag can be used to specify different protocols to reach the same source. For example, if the first REF tag specifies the MMS protocol and the second REF tag specifies the HTTP link, clients that cannot connect by using MMS (because they are behind a firewall) automatically can try to connect using HTTP. Windows Media Player performs this type of rollover automatically when you specify the MMS protocol as you create a unicast publishing point.

URL rollover also can be used to specify different Windows Media servers that contain the same content. For example, if the first REF tag specifies an .asf file on a server called hound1 and the second REF tag specifies a copy of the file on hound2, Windows Media Player can reach the file using either server. If hound1 is too busy or fails, Windows Media Player automatically connects to hound2.


Windows Media components overview

Microsoft Windows Media Technologies provides a tightly integrated set of services and tools used to produce, administer, broadcast, and receive rich multimedia presentations streamed over the Internet and corporate intranets. This section contains details about the Windows Media server components. The other components that comprise the Windows Media Technologies family are Windows Media Tools and Windows Media Player.


Windows Media server components

The Windows Media server components consist of the Windows Media component services and Windows Media Administrator.

Windows Media component services

The Windows Media component services are a set of services running on Microsoft Windows 2000 Server. These services broadcast audio and video content via unicast and multicast to clients. The component services are the Windows Media Monitor, Program, Station, and Unicast services.

Windows Media Administrator

Windows Media Administrator is a set of Web pages that runs in a Microsoft Internet Explorer version 5 browser window and manages the Windows Media component services. With Windows Media Administrator, you can control the local server, or you can attach to and control one or more remote Windows Media servers. To manage multiple servers, add the servers to the server list, and then connect to the server you want to manage.

You can run Windows Media Administrator on Microsoft Windows 2000 Server, Microsoft Windows 2000 Professional, Microsoft Windows 98, or Microsoft Windows NT 4 with Service Pack 4 (SP4) or later. It is possible to run Windows Media Administrator in Internet Explorer 4.01, or on Microsoft Windows 95, but these are not supported platforms.


Windows Media Services client software

Client software, called Windows Media Player, receives and renders streams from a Windows Media server. Windows Media Services uses Windows Media Player to render ASF streams that can include video content, audio content, images, URLs, and scripts. For a client to receive multicast file transfers, Nsfile.ocx must be configured and installed on the client computer. Nsfile.ocx is not installed as part of Windows Media Player. To download the file transfer control, go to the Microsoft Web site.

Clients are available for the Microsoft Windows, Apple Macintosh, and UNIX operating systems.

Upgrading client software from NetShow Player version 2.0

If you do not wish to support Microsoft NetShow Player version 2.0, you can use fupgrade.asf to inform Windows Media Services clients that they must upgrade from NetShow Player 2.0 to Microsoft Windows Media Player to receive the selected content. When Windows Media Services is installed, fupgrade.asf is placed in the Home publishing point (the default is SystemDrive\ASFRoot). When NetShow Player clients connect to a publishing point on the Windows Media server, fupgrade.asf streams to the client in place of the requested stream. This .asf file explains to users that they must upgrade their client and launches a browser on the client computer that connects to the Microsoft Web site where the latest version of Windows Media Player can be downloaded.

Upgrading earlier versions of Windows Media Player

Earlier versions of Windows Media Player cannot play new content that uses a new codec, multiple bit rate encoding, or digital rights management. However, when an earlier client connects to the Windows Media server, fupgrade.asf plays and prompts the user to download the latest version of Windows Media Player from the Windows Media Player Web site. If users download the latest Windows Media Player, they can play all ASF content including multiple bit rate and protected content.

Note

  • If you want to disable the upgrade feature so that users will not be prompted to upgrade their clients, rename or delete fupgrade.asf and then restart the services.


Windows Media Tools

The following tools and utilities are available for Windows Media Services to produce and modify the content that is streamed by a Windows Media server:

  • Windows Media Encoder is a tool that can convert both live and stored audio and video content to an ASF stream, which then can be streamed over a network by a Windows Media server. To provide added depth to your content stream, you can add script commands. These script commands can be used to go to a specific Web site, initiate page flips, provide rating information, or create an e-mail message. Once a content stream is created, it can be written to an .asf file for playback later.
  • Windows Media Author is a tool that Microsoft co-developed with Digital Renaissance, Incorporated. This tool is used to assemble, synchronize, and compress audio and image files into a single .asf file. The content that Windows Media Author creates is called illustrated audio because it resembles a slide show put to a sound track. Windows Media Author also can add script commands and URLs to .asf files.
  • Windows Media Presenter for Microsoft PowerPoint 97 is an add-in tool for use with PowerPoint that, along with Windows Media Encoder, helps you turn a PowerPoint presentation into an ASF stream.
  • Windows Media Publish to ASF for Microsoft PowerPoint 97 is an add-in tool that turns your PowerPoint presentation with narrations into an .asf file.
  • Windows Media Plug-In for Adobe Premiere provides easy compression and conversion of your video files into ASF from within Adobe Premiere. For more information, see Adobe Premiere Help.
  • Windows Media ASF Indexer is a tool that edits the start and stop time of .asf files and indexes them. It also can be used to provide markers, properties, and script commands to an .asf file.
  • VidToAsf and WavToAsf are conversion utilities that run from the command-line of your server. They are used to convert existing sound and movie files to the ASF format.
  • ASFCheck and ASFChop are file utilities that run from the command line of your server. ASFCheck is used to verify the format of the .asf file and repair the file if possible. ASFChop can be used to add properties, markers, indexes, and script commands to the .asf file and to delete sections of time from the .asf file. For more information about creating .asx files, see ASX Metafile Reference.

Note

  • To obtain the complete set of Windows Media Tools mentioned in the preceding list, download Windows Media Tools from the Windows Media Technologies page at the Microsoft Web site.


PowerPoint 2000 Presentation Broadcasting

Microsoft PowerPoint 2000 includes the Presentation Broadcasting feature, which allows users to broadcast streaming PowerPoint presentations in real time to network users. In addition to slides, presenters can broadcast video and audio simultaneously to deliver a live multimedia show online. The PowerPoint 2000 Presentation Broadcasting feature combines the functionality of PowerPoint, Microsoft Outlook, Windows Media Services, and Windows Media Player.

To support PowerPoint 2000 Presentation Broadcasting, Windows Media Services installs the On-line Presentation Broadcast service. This service allows you to use the Presentation Broadcasting feature of Microsoft PowerPoint 2000 to broadcast streaming PowerPoint presentations in real time over an intranet using a Windows Media server. If you plan to use the Presentation Broadcasting feature to broadcast a presentation to more than 15 users or if you plan to include video with your presentation, you need to use Windows Media Services to broadcast the presentation.


Preparing the network for PowerPoint 2000 Presentation Broadcasting

To enable the On-line Presentation Broadcast service on your network and scale it to audiences with more than 15 users, it is recommended that you provide two servers that reside on the same Windows 2000 domain:

  • A Microsoft Windows 2000 Server for file sharing. PowerPoint slides will reside in a file share on this server and be accessed by users during the presentation broadcast.
  • A Windows 2000 Server with Windows Media Services installed. This server will stream the presentation audio and video via unicast or multicast and optionally distribute the PowerPoint slides via multicast.

On the server running Windows Media Services, perform the following:

  • Configure the On-line Presentation Broadcast service to log on with a domain user name and password. For more information, see To configure the On-line Presentation Broadcast service on the Windows Media server.
  • Add the domain user account that the On-line Presentation Broadcast service uses for log on to the NetShow Administrators group and the Administrators group.

On the server used for file sharing, perform the following:

  • Give the domain user account used by On-line Presentation Broadcast service Read access to the shared folder where the PowerPoint .asd files are stored.

Note

  • If a Windows 2000 domain is not available, then create a domain user account on both the Windows Media Server and the server for file sharing. Confirm that the user account passwords on each server are identical and add the On-line Presentation Broadcast service to the NetShow Administrators group and the Administrators group on the server running Windows Media Services. Then, configure the service on the Windows Media server to startup with a specific user name and the password you just created. For more information, see To configure the On-line Presentation Broadcast service on the Windows Media server.


To configure the On-line Presentation Broadcast service on the Windows Media server

  1. Log on to the computer running Windows Media Services, using an account with administrative privileges.
  2. In Control Panel, double-click Administrative Tools, and then double-click Services.
  3. In Services, right-click the On-line Presentation Broadcast service and then click Properties.
  4. In On-line Presentation Broadcast Properties, click the Log On tab.
  5. Under Log On As in On-line Presentation Broadcast Properties, select the This Account option.
  6. Type in the domain user account name and password for the service to use to log on.

Notes

  • You must confirm the network is properly configured for On-line Presentation Broadcasting. For more information, see Preparing the network for PowerPoint 2000 Presentation Broadcasting.
  • If you change the password for the account you use to log on to the computer running Windows Media Services, you must also change the password in this dialog for the On-line Presentation Broadcast service.
  • If you select Manual as the Startup Type option for the On-line Presentation Broadcast service (the default option), the service starts automatically when a user starts the service, and it does not use system resources when it is not needed.


Learning more about PowerPoint 2000 Presentation Broadcasting

To learn more about Presentation Broadcasting in PowerPoint 2000 and how to configure PowerPoint, read the MSDN Article at the Microsoft Web site.

For more information about using the Broadcast Presentation feature of PowerPoint 2000, see the Office 2000 resource kit documentation at the Microsoft Web site.


Resources

After Windows Media Services is installed, you can find information about using its features and on preparing content from several sources:

  • Windows Media Services Help. Complete online documentation is available with Windows Media Services. You can open the documentation from Windows Media Administrator. Microsoft Word files, available in .doc format for convenient printing, are in the SystemDrive\SystemRoot\system32\Windows Media\docs\print directory. The printable documents are identical to the online documentation and should be printed in the following order: srvr_admin1.doc, srvr_admin2.doc, srvr_admin3.doc, srvr_admin4.doc, and srvr_admin5.doc.
  • Windows Media Technologies Web page. The Windows Media Technologies page at the Microsoft Web site provides overviews, samples, and up-to-date information for all Windows Media Technologies users. An item that may be of particular interest to you is the Windows Media Technologies Software Development Kit (SDK), which provides samples, guides, and reference information for developers.


Windows Media Server Components

Windows Media server components consist of the Windows Media component services, a group of services that are used to send audio and video content via unicast and multicast to clients, and Windows Media Administrator.

This overview explains how the Web-based Windows Media Administrator is used to control Windows Media component services and stream Windows Media content. The documentation includes the following sections:

Windows Media Administrator
How Windows Media Administrator can be used to administer any Windows Media server on which you have administrative rights.
Unicasts
How Windows Media server components can be configured to deliver on-demand and live unicast streams to clients, and how these clients can be monitored.
Multicasts
How Windows Media server components can be configured to conserve bandwidth by delivering a multicast stream to clients, and how these clients can be monitored.
Windows Media event monitors
How Windows Media server system activity, including client connections, server status and limits, and administrative functions, can be monitored.
Windows Media performance counters
How the customized Microsoft Windows Media performance counters in Windows Media Performance Monitor can be used to measure Windows Media server performance and efficiency.
Information logs
How information about the clients that view a unicast or multicast can be saved to a log.
Windows Media administration and security
How the built-in security features in Windows Media server components that integrate fully with Microsoft Windows 2000 Server can be used to control access to Windows Media content.


Windows Media Administrator

Windows Media Administrator is a set of Web pages that run in a Microsoft Internet Explorer 5 browser window. It is used to control any Windows Media server that you have administrative rights to in the Microsoft Windows domain. If you want to remotely administer other Windows Media servers, you must be a member of the NetShow Administrators group or an administrator on the remote computer.

If you administer Windows Media server components remotely, Windows Media Administrator uses distributed Component Object Model (DCOM) to communicate with the Windows Media server components. If you want to administer a Windows Media server that is not in the same Windows domain or that is separated from Windows Media Administrator by a firewall, you must open a port on your firewall that distributed DCOM can use to communicate.

Windows Media Administrator is installed with Windows Media server components. You can run Windows Media Administrator on Microsoft Windows 2000 Server or, Windows 2000 Professional.


How to. . .

This section lists the procedures that are commonly performed while running Windows Media Administrator. Use the procedures to quickly accomplish a task. This procedure list precedes the overview information that explains Windows Media Administrator in more detail. If you want to learn more about Windows Media Administrator, continue past the procedures and read the overview information.


To start Windows Media Administrator

  • Click Start, point to Programs, point to Administrative Tools, and then click Windows Media.


To connect to a Windows Media server

  • In the Windows Media Administrator menu frame, click the down arrow to display the server list, and then click the server to which you want to connect.

Note

  • If the server you want is not displayed, or no servers are displayed, add the server to the list.


To add a server to the server list

  • In the Windows Media Administrator menu frame, click Add Server, and then type the server name in the Server box.


To remove a server from the server list

  • Click the server name in the list, and then click Remove Server.

    Windows Media Administrator is disconnected from the server, and the server name is removed from the server list.


To edit the port that the Windows Media Unicast service uses for HTTP streaming

  1. Start Registry Editor.
  2. In Registry Editor, use the tree view to navigate through the following path:

    HKEY_LOCAL_MACHINE\System\CurrentControlSet\Services\nsunicast\Parameters.

  3. Double-click the key HTTPPort.

    DWORD Editor appears.

  4. In the DWORD Editor dialog box, select Decimal.

    Data must read 80.

  5. Type the number of the port that you want HTTP streaming to use.

Note

  • Your ability to make changes to the registry by using Registry Editor depends on your access permissions. Incorrectly editing the registry can severely damage your system. Before making changes to the registry, back up any valued data on the computer.


To edit the port that the Windows Media Station service uses for HTTP streaming

  1. Start Registry Editor.
  2. In Registry Editor, use the tree view to navigate through the following path:

    HKEY_LOCAL_MACHINE\System\CurrentControlSet\Services\nsstation\Parameters.

  3. Double-click the key HTTPPort.

    DWORD Editor appears.

  4. In the DWORD Editor dialog box, select Decimal.

    Data must read 80.

  5. Type the number of the port that you want HTTP streaming to use.

Note

  • Your ability to make changes to the registry by using Registry Editor depends on your access permissions. Incorrectly editing the registry can severely damage your system. Before making changes to the registry, back up any valued data on the computer.


To enable HTTP streaming for Windows Media server components that share a server with IIS 5.0

  1. Read the information in Using Windows Media server components and IIS on the same server.
  2. Assign an IP address to a Microsoft Internet Information Services (IIS) Web site. For more information, see To assign an IP address to an IIS Web site.
  3. Disable socket pooling for the IIS Web site. For more information, see To disable socket pooling for an IIS Web site.
  4. Enable HTTP streaming for Windows Media server components. You can enable HTTP streaming for unicast or multicast streaming.
  5. Edit the registry to make the Windows Media component services depend on the World Wide Web Publishing Service. For more information, see To edit the registry so that the Windows Media Unicast service depends on the Web server.
  6. Restart your computer.

Note

  • Windows Media server components cannot stream ASF content via HTTP when IIS 3.0 or earlier is installed on the server because the IIS Web site binds to port 80 on all available IP addresses. To enable HTTP streaming for one of the Windows Media component services, Web sites running under IIS 4.0 or later must not be configured to use all unassigned IP addresses.


To assign an IP address to an IIS Web site

  1. In Microsoft Internet Information Services (IIS), select the Windows Media server computer.
  2. Right-click Default Web Site, and then on the pull-down menu, click Properties.

    The Default Web Site Properties dialog box appears.

  3. In the Default Web Site Properties dialog box, select the Web Site tab.
  4. On the Web Site tab, in the IP Address dialog box, type the IP address that you want IIS to use.
  5. Repeat steps 2 through 4 for any additional Web sites that you run under IIS, including the administration Web site.

Note

  • Windows Media server components cannot stream ASF content via HTTP when IIS 3.0 or earlier is installed on the server because the IIS Web site binds to port 80 on all available IP addresses. To enable HTTP streaming for one of the Windows Media server components, Web sites running under IIS 4.0 or later must not be configured to use all unassigned IP addresses.


To disable socket pooling for an IIS 5.0 Web site

  1. At the command prompt, type cd SystemDrive\inetpub\adminscripts.
  2. At the SystemDrive\Inetpub\AdminScripts command prompt, type

    cscript adsutil.vbs set w3svc/disablesocketpooling true.

    The command prompt will reply:

    disablesocketpooling : (BOOLEAN)  TRUE


To edit the registry so that the Windows Media Unicast service depends on the Web server

  1. Start Registry Editor (Click Start, click Run, and then type regedt32).
  2. To update the Windows Media Unicast service, in Registry Editor, use the tree view to navigate through the following path:

    HKEY_LOCAL_MACHINE\System\CurrentControlSet\Services\nsunicast.

  3. Double-click the key DependOnService.

    The Multi-String Editor opens.

  4. Type W3SVC at the end of the list of services.

    W3SVC is the setting that makes Windows Media server components dependent on Microsoft Internet Information Services (IIS).

  5. Restart the computer.

Notes

  • You must set Windows Media component services to be dependent on the Web service so that the Web service can bind to port 80. If you do not set this dependency, then Windows Media server components might bind to port 80 first, and the Web server will not function properly. These steps are specific to using Windows Media Services with IIS 4.0 or later. If you use Windows Media Services with a different Web server, check the documentation for that server for instructions on setting dependencies.
  • Your ability to make changes to the registry by using Registry Editor depends on your access permissions. Incorrectly editing the registry can severely damage your system. Before making changes to the registry, back up any valued data on the computer.


To create a new MIME type in IIS

  1. In Internet Services Manager, select the server computer.
  2. Right-click Default Web Site, and then on the pull-down menu, click Properties.

    The Default Web Site Properties dialog box appears.

  3. Click the HTTP Headers tab.
  4. Under MIME Map, click File Types.

    The File Types dialog box appears.

  5. Click New Type.
  6. In the File Type dialog box, for Associated Extension, type ASF, and for Content Type (MIME), type video/x-ms-asf.
  7. In the File Types dialog box, click New Type.
  8. In the File Type dialog box, for Associated Extension, type ASX, and for Content Type (MIME), type video/x-ms-asf.
  9. Restart the server.

Note

  • This procedure assumes that Windows Media server components and Microsoft Internet Information Services (IIS) do not share a server computer. If you install Windows Media server components after you install IIS, Multipurpose Internet Mail Extensions (MIME) types for IIS are created automatically. Creating the MIME types for the Default Web Site affects all Web sites. These instructions can be used to create the MIME types for any Web sites on the server.


To back up Windows Media Services programs

  1. Archive the .nsp file for the program to a backup directory.

    The .nsp file for the program is not archived by default and must be saved manually. For more information, see To save a program.

  2. Run Microsoft Windows Backup.

Note

  • This procedure is required to back up Windows Media Services programs. Other Windows Media server data can be backed up by running Windows backup only.


To restore Windows Media Services programs

  1. Verify that you have performed the steps in To back up Windows Media Services programs.
  2. Run Microsoft Windows Restore.

    The following files will not be restored:

    %SystemRoot%\system32\Windows Media\Server\ASDB\mdsas.mdb
%SystemRoot%\system32\Windows Media\Server\ASDB\mdsas.ldb
  3. In Microsoft Windows 2000 Server Computer Management, stop any Windows Media component services that are running.
  4. Delete all files in the following directories:
    %SystemRoot%\system32\Windows Media\Server\ASDB
%SystemRoot%\system32\Windows Media\Server\ASDB\NSP
  5. Copy the file Mdsas.1st to the ASDB directory and rename it to Mdsas.mdb.
    Copy "%SystemRoot%\system32\Windows Media\Server\mdsas.1ST" "%SystemRoot%\system32\Windows Media\Server\ASDB\mdsas.mdb"
  6. In the Services console, restart the Windows Media component services.
  7. Using Windows Media Administrator, restore the previously archived .nsp file for the program data. For more information, see To restore a saved program.


Starting Windows Media Administrator

When you start Windows Media Administrator, it tries to connect to the Windows Media server on the local computer. If Windows Media Administrator is on a computer that does not contain Windows Media server components, you must add a Windows Media server to the server list. This method is also used to change Windows Media Administrator connections between Windows Media servers.


Using Windows Media server components with firewalls

If you have problems communicating through your firewall, you can open different ports on it. Consult your firewall vendor and the following table to decide if you need to adjust your firewall to accept ASF streams from Windows Media Services. This table is designed from the perspective of a client inside a firewall that is receiving ASF streams from a Windows Media server outside the firewall. Port In is the port that the server uses to get past the firewall. Port Out is the port that Microsoft Windows Media Player uses to communicate with the server.

Protocol | Port In | Port Out
MMS (multicast) | IP address 224.0.0.1— 239.255.255.255 | 1— 65000
MMS-UDP (unicast) | 1755 (TCP) | 1024— 5000 (UDP)
MMS-TCP (unicast) | 1755 (TCP) | 1755 (TCP)
HTTP | 80 |
MSBD(1) | 7007 (TCP) or any port that you create for communications between the server and Windows Media Encoder that does not use DCOM | 7007 (TCP)
DCOM (2) | 135 (TCP) |
(1) Except when one Windows Media server is distributing a stream from another Windows Media server and that server is already using port 7007. The first connection would be on port 7007, but the next connection would be on a random port in the range from 1024 through 5000.
(2) Distributed Component Object Model (DCOM) dynamically allocates one port per communication. To enable all DCOM communication to pass through the firewall, allocate ports equal to the number of simultaneous DCOM communications through the firewall. For each communication, open the UDP and TCP ports corresponding to the port numbers that will be used. In addition, open TCP/UDP 135, which is used for RPC End Point Mapping. Then create the registry key, "HKEY_LOCAL_MACHINES\Software\Microsoft\Rpc\Internet" and identify the ports that have been reserved in this key.

The following example restricts the DCOM port range to 10 ports:

Named Value: Ports
Type: REG_MULTI_SZ
Setting: Range of port. Can be multiple lines such as:
3001-3010
135

Named Value: PortsInternetAvailable
Type: REG_MULTI_SZ
Setting:"Y"

Named Value: UseInternetPorts
Type: REG_MULTI_SZ
Setting:"Y"

Note

  • A computer outside the firewall must be able to access a computer inside the firewall using its IP address. Address translation and proxy use are not allowed.


Configuring a Windows Media server with a firewall

When you install Windows Media server components, the default setup enables MMS streaming for the unicast and station services. MMS uses either UDP or TCP, depending on which protocol is specified; Windows Media Administrator uses DCOM to communicate with Windows Media server components. This means that you can stream ASF content to anyone on your intranet via unicast. To stream ASF content over your intranet, your network routers must be multicast-enabled; otherwise, a multicast stream cannot pass beyond the local segment from which it originated.


Scenario 1: Windows Media server and clients are inside a firewall

A firewall separates the corporate local area network from the Internet in this typical corporate network scenario.


Scenario 2: Windows Media server and clients are outside a firewall

If you want to allow clients on the Internet to stream ASF content from a Windows Media server, place that server outside the corporate firewall. If you place the Windows Media server inside the corporate firewall, you must open a specific port on your firewall to allow clients on the Internet to communicate with the server. In the scenario shown in the preceding diagram, clients can communicate with the Windows Media server using the standard Windows Media Services protocols.


Scenario 3: Windows Media server and clients are separated by a firewall

If you want to stream content to clients that are behind a firewall, you must stream it through an open port on the firewall. You can change the port that the Windows Media server uses to deliver MMS streams (usually port 1755), or you can switch the Windows Media server to use HTTP streaming. The default for HTTP streaming is port 80. For more information, see Using HTTP streaming.

Configuring Windows Media Player when Windows Media server and clients are separated by a firewall

By default, Windows Media Player uses the proxy settings configured in your Web browser to access ASF streams from behind a firewall. If Internet Explorer 5 is configured to automatically detect the network proxy, Windows Media Player will also use auto-detection to find the proxy information after you install it. If auto-detection is successful, Windows Media Player will use the same proxy server as the Web browser to access content from behind a firewall. If auto-detection cannot determine the browser proxy settings, you must manually configure the proxy settings in Windows Media Player.

If the server used as the proxy agent is changed, Windows Media Player cannot establish a connection to the new proxy server. If it has been at least one week since Windows Media Player ran auto-detection to find browser proxy settings, the next time Windows Media Player is used to stream, it will again run auto-detection to find and configure the new proxy settings.

If you want Windows Media Player to run auto-detection prior to the seven-day interval, select No proxy and then select Use browser proxy settings for HTTP streaming on the Advanced playback settings tab in Windows Media Player. If you still encounter problems with auto-detection, select Use proxy and configure the proxy to be used.


Using HTTP streaming

HTTP streaming is useful for delivering a stream through a firewall because HTTP streaming usually uses port 80 and most firewalls do not block port 80. Windows Media server components is configured to use MMS streaming by default. However, you can configure Windows Media server components to use HTTP streaming. HTTP streaming is the suggested method for streaming ASF content through a firewall.

Two services are included in the Windows Media server components—the Windows Media Unicast service and the Windows Media Station service. If you change Windows Media server components to use HTTP streaming, you must select which of these services will use it; the Windows Media Unicast and Windows Media Station services cannot bind to the same port, so they must be configured differently.


Changing the port to which the HTTP service binds

The HTTP service in IIS, by default, attempts to bind to port 80. If Windows Media server components share a server computer with a Web server and Windows Media server components are enabled for HTTP streaming, Windows Media server components and the Web server can conflict when binding to port 80.

Changing the port to which the HTTP service binds can solve port conflicts, but it also can defeat the purpose of using the HTTP service. Be aware that most incoming HTTP data attempts to enter through port 80. If this data cannot enter through port 80, then it is lost.


Using Windows Media server components and IIS on the same server

Windows Media server components and Microsoft Internet Information Services (IIS) can coexist on a computer when you use their default values: the Windows Media Unicast service binds to port 1755, the Windows Media Station service binds to port 7007, and IIS binds to port 80.

The Windows Media Unicast or Windows Media Station service must have an IP address available on port 80 to stream ASF content via HTTP. Windows Media server components cannot stream ASF content via HTTP when IIS 3.0 or earlier is installed on the server because IIS binds to port 80 on all available IP addresses. However, with IIS 4.0 or later, you can specify an IP address that IIS can use when it binds to port 80 to serve HTTP streams; the Windows Media Unicast or Windows Media Station service can then use another available IP address to stream ASF content via HTTP. To enable HTTP streaming for the Windows Media Unicast or Windows Media Station service, Web sites running under IIS 4.0 or later must not be configured to use all unassigned IP addresses.

To use HTTP streaming when Windows Media server components and IIS 4.0 or later are installed on the same computer, you require the following:

  • At least two IP addresses bound to your network card.
  • Unique Domain Name Server (DNS) A resource records for the Windows Media server IP address and the IIS server IP address.

Note

  • You can enable HTTP streaming for the Windows Media Unicast service or Windows Media Station service on the Server Properties page in Windows Media Administrator.


Defining Windows Media MIME types in IIS

Multipurpose Internet Mail Extension (MIME) types must be defined on a Web server so that the server will know what to do when it receives requests for unknown file extensions, such as .asf and .asx. Without this record, the Web server cannot interpret a file.


Running Windows Backup with Windows Media Services

When the Windows Media Program service is running, the program database is locked for exclusive use and cannot be accessed by Microsoft Windows Backup. When you restore the system after running Microsoft Windows Backup, the following program configuration files will not be restored:

%SystemRoot%\system32\Windows Media\Server\ASDB\mdsas.mdb
%SystemRoot%\system32\Windows Media\Server\ASDB\mdsas.ldb

To back up and restore your program configuration information correctly, perform the following procedures:

  • To back up Windows Media Services programs
  • To restore Windows Media Services programs


Unicasts

A unicast connection is a point-to-point connection between a client and a server in which the client receives a distinct stream. This section shows you how to use Windows Media Administrator to create and manage unicast publishing points and to administer and monitor unicast publishing point events and clients.


How to. . .

This section lists the procedures that are most commonly performed in creating and managing unicasts. Use the procedures to quickly accomplish a task. This procedure list precedes the overview information that explains unicasts in more detail. If you want to learn more about unicasts, continue past the procedures and read the overview information.


To configure and access on-demand .asf files

  1. Open Microsoft Windows Media Player.
  2. On the File menu, click Open.
  3. In the Open dialog box, type mms://Windows_Media_server/file.asf and then click OK.

    Windows Media Player buffers and plays file.asf.

Note

  • Windows Media server components is installed ready to stream on-demand content. The default Home publishing point is SystemDrive\ASFRoot.


To configure and access broadcast (live) unicast streams

  1. Open Microsoft Windows Media Player.
  2. On the File menu, click Open.
  3. In the Open dialog box, type the URL for the broadcast unicast publishing point alias (mms://Windows_Media_server/publishing_point_alias) and then click OK.

    Windows Media Player buffers and plays the stream from the broadcast unicast publishing point.

Note

  • A live content stream is generated by Windows Media Encoder, a remote station, or a remote unicast publishing point, and propagated through a broadcast unicast publishing point. Windows Media Player connects to the broadcast unicast publishing point to access the content.


To create an on-demand unicast publishing point using QuickStart

  1. In the Windows Media Administrator menu frame, click Unicast Publishing Points.

    The Unicast Publishing Points page appears.

  2. Make sure the Use wizard to create new on-demand unicast publishing point check box is selected, click On-Demand, and then click New.

    Configure and Publish Unicast On-Demand Streams QuickStart Wizard appears.

  3. On the Select a publishing point screen, select Create a publishing point.
  4. On the Create a new publishing point screen, type an alias for the new on-demand unicast publishing point in the Alias box. In the Path box, type the path to the on-demand unicast publishing point directory on a local drive or on a separate computer.
  5. On the Locate target .asf file screen, enter the path to the .asf file that you want to publish. Specify the name and extension of the .asf file.
  6. On the Select publishing method screen, select the desired publishing protocol. Then, select the publishing options that Microsoft Windows Media Player uses to access your on-demand unicast.

    For more information about publishing protocols, see Understanding Windows Media Services protocols.

    By default, Windows Media server components creates an announcement in the on-demand unicast publishing point that you are creating. For more information about announcements, see Announcing your unicast with an .asx file.

    For more information about other publishing options, see Publishing a unicast stream.

  7. On the Ready to publish screen, review the list of options that you have selected. To edit any of these, click Back once or more to return to the appropriate on-demand unicast publishing point information.
  8. If you do not plan to send the .asx file to users in an e-mail message, save it to an accessible directory. Save any .htm files created by the publishing methods you selected to directories that users can access either directly or via a Web server.

Note

  • On the Publishing complete screen, you can test the stream from your on-demand unicast publishing point. Click Test URL, Test .asx, Test .htm w/<HREF>, or Test .htm w/<OBJECT> to begin streaming the on-demand unicast publishing point content in Windows Media Player.


To create a broadcast unicast publishing point using QuickStart

  1. In the Windows Media Administrator menu frame, click Unicast Publishing Points.

    The Unicast Publishing Points page appears.

  2. Make sure the Use wizard to create new broadcast unicast publishing point check box is selected, click Broadcast, and then click New.

    Configure and Publish Unicast Broadcast Streams QuickStart Wizard appears.

  3. On the Select a publishing point screen, select Create a broadcast publishing point.
  4. On the Specify source screen, select the source for your broadcast content.
  5. On the New broadcast publishing point to a (the source for your broadcast content that you selected) screen, type an alias for the new broadcast unicast publishing point in the Alias box. Then type the path in the Path box. If Windows Media Encoder is the source for the broadcast, verify the value in the Port box is correct.

    By default, the path from a broadcast unicast publishing point to sources from Windows Media Encoder or a remote Windows Media station uses the MSBD protocol; the path from a broadcast unicast publishing point to sources from a remote unicast publishing point uses the MMS protocol. For examples of how these types of paths are used, see Using broadcast unicast publishing points.

    You also can connect your broadcast unicast publishing point to any of these broadcast content sources by using HTTP. For more information about using the HTTP protocol, see Setting and administering HTTP streaming and distribution.

  6. On the Select publishing method screen, select the desired publishing protocol. Then, select the publishing options that Microsoft Windows Media Player uses to access the live content from your broadcast unicast publishing point.

    For more information about publishing protocols, see Understanding Windows Media Services protocols.

    By default, Windows Media server components creates an announcement. For more information about announcements, see Announcing your unicast with an .asx file.

    For more information about other publishing options, see Publishing a unicast stream.

  7. On the Ready to publish screen, review the list of options that you have selected. To edit any of these, click Back once or more to return to the appropriate on-demand unicast publishing point information.
  8. If you do not plan to send the .asx file to users in an e-mail message, save it to an accessible directory. Save any .htm files created by the publishing methods you selected to directories that users can access either directly or via a Web server.

Note

  • On the Publishing complete screen, you can test the stream from your on-demand unicast publishing point. Click Test URL, Test .asx, Test .htm w/<HREF>, or Test .htm w/<OBJECT> to begin streaming the on-demand unicast publishing point content in Windows Media Player.


To create an on-demand unicast publishing point using the advanced method

  1. In the Windows Media Administrator menu frame, click Unicast Publishing Points.

    The Unicast Publishing Points page appears.

  2. On the Unicast Publishing Points page, make sure that the Use wizard to create new on-demand publishing point check box is not selected.
  3. Click On-Demand and then click New.

    The New Unicast On-Demand Publishing Point page appears.

  4. In the Alias box, type the name of the new on-demand publishing point.
  5. In the Directory path box, type the path to the physical directory where the .asf files can be stored.
  6. (Optional) To restrict the number of clients that can connect to this publishing point, in Maximum clients, choose Limit to from the pull-down menu and then type the maximum number of clients.
  7. (Optional) To limit the maximum network bandwidth that the publishing point can deliver, in Maximum bandwidth, choose Limit to from the pull-down menu and then type the maximum value in the Kbits/sec box.


To create a broadcast unicast publishing point using the advanced method

  1. In the Windows Media Administrator menu frame, click Unicast Publishing Points.

    The Unicast Publishing Points page appears.

  2. On the Unicast Publishing Points page, make sure that the Use wizard to create new broadcast publishing point check box is not selected.
  3. Click Broadcast and then click New.

    The New Broadcast Publishing Point page appears.

  4. In the Alias dialog box, type the name of the new broadcast publishing point.
  5. In the Path type dialog box, choose the Windows Media component that will provide the live stream—Windows Media Encoder, a remote publishing point, or a remote station.
  6. In the URL dialog box, type the path to the source you identified in the Path type dialog box.

    You must use MSBD as the protocol for the URL.

  7. If you chose Windows Media Encoder as the Path type, in the Port box, type the port that the encoder is using to deliver the source.
  8. (Optional) To restrict the maximum number of clients that can connect to this publishing point, choose Limit to from the pull-down menu and then type the maximum number of clients.
  9. (Optional) To restrict the maximum amount of network bandwidth that the publishing point can deliver, choose Limit to from the pull-down menu and then type the maximum value in the Kbits/sec box.


To enable HTTP streaming for the Windows Media Unicast service

  1. Quit any application or stop any service bound to port 80.
  2. In the Windows Media Administrator menu frame, click Server Properties.

    The Server Properties page appears.

  3. On the Configure Server - Server Properties page, select the HTTP Streaming and Distribution tab.
  4. Select the Enable HTTP streaming for Windows Media Unicast service option.
  5. Click Apply.

    A message appears, notifying you that you must restart the computer that hosts Windows Media server components before any changes can take effect.

  6. Click OK in the message box and then restart the computer that hosts Windows Media server components.

Note

  • If you choose to enable HTTP streaming for the Windows Media Unicast service, Windows Media Administrator configures HTTP streaming to use port 80. If you enable HTTP streaming and use port 80, you cannot run Windows Media server components and an HTTP server on the same computer (unless you configure Windows Media Services to depend on the Web services; for more information, see To edit the registry so that the Windows Media Unicast service depends on the Web server). The Windows Media server components and HTTP service compete for use of that port.


To disable HTTP streaming for the Windows Media Unicast service

  1. In the Windows Media Administrator menu frame, click Server Properties.

    The Server Properties page appears.

  2. On the Configure Server - Server Properties page, select the HTTP Streaming and Distribution tab.
  3. Select the Do not enable HTTP streaming or Distribution option.
  4. Click Apply.

    A message appears, notifying you that you must restart the computer that hosts Windows Media server components for any changes to take affect.

  5. Click OK in the message box and then restart the computer that hosts Windows Media server components.

Note

  • By default, HTTP streaming is disabled. This procedure assumes HTTP streaming is enabled for the Windows Media server components.


To create an announcement file for an on-demand unicast

  1. Open a text editor (such as Microsoft Notepad) and copy and paste the following syntax into a new document:
    <asx version = "3.0">
  <title>title</title>
  <entry>
    <ref href = "mms://server_name/directory_path/file.asf"/>
  </entry>
</asx>
  2. Use the information in the following table to edit the syntax, replacing the sample information with your own.
    Replace | With
    Title | The title that you want to appear in Microsoft Windows Media Player as the Show title when the .asf file is rendered.
    Mms | Http, but only if Windows Media server components is configured to use HTTP streaming.
    Server_name | The name of the Windows Media server on which the on-demand unicast publishing point you want to reference exists.
    Directory_path | The path to the on-demand unicast publishing point that you want to reference (if not the Home publishing point).
    File.asf | The name of the .asf file in the on-demand unicast publishing point that you want to announce.

  3. Save the document as a plain text file with an .asx extension in a shared directory or on an HTTP server.

    The announcement file is ready to be used. It can be attached to an e-mail message, used as the object of an HREF on a Web page, or stored on a local server.

Notes

  • Announcement (.asx) files are created automatically when you use the QuickStart wizard to create an on-demand unicast publishing point. For more information, see step 6 in To create an on-demand unicast publishing point using QuickStart.
  • This procedure assumes that you have created an on-demand unicast publishing point without using a QuickStart wizard, and want to announce a stored .asf file.


To create an announcement file for a broadcast unicast

  1. Open a text editor (such as Microsoft Notepad), and copy and paste the following syntax into a new document:
    <asx version = "3.0">
  <title>title</title>
  <entry>
    <ref href = "mms://server_name/pubpoint"/>
  </entry>
</asx>
  2. Use the information in the following table to edit the syntax, replacing the sample information with your own.
    Replace | With
    Title | The title that you want to appear in Microsoft Windows Media Player as the Show title when the stream is rendered.
    Mms | Http, but only if Windows Media server components are configured to use HTTP streaming.
    Server_name | The name of the Windows Media server on which the broadcast unicast publishing point that you want to reference exists.
    Pubpoint | The alias of the broadcast unicast publishing point.

  3. Save the document as a plain text file with an .asx extension in a shared directory or on an HTTP server.

    The announcement file is ready to be used. It can be attached to an e-mail message, used as the object of an HREF on a Web page, or stored on a local server.

Notes

  • Announcement (.asx) files are created automatically when you use a QuickStart wizard to create a broadcast unicast publishing point. For more information, see step 6 in To create a broadcast unicast publishing point using QuickStart.
  • This procedure assumes that you have created a new broadcast unicast publishing point without using a QuickStart wizard and want to announce a live stream.


To edit an on-demand unicast publishing point

  1. In the Windows Media Administrator menu frame, click Unicast Publishing Points.

    The Unicast Publishing Points page appears.

  2. Click the on-demand publishing point that you want to update in the list, and then click On-Demand.
  3. Click Properties.
  4. To rename the publishing point alias, type a new name in the Alias box.
  5. To specify a new location for your on-demand publishing point, change the Directory path by typing the new location or use the Browse button to find the new location. You can also type a UNC path to a remote location if the directory you are referencing exists on another computer.
  6. To make this on-demand unicast publishing point the new Home publishing point, select the Home option.
  7. To set limits on the number of clients that access your publishing point, select Limit to for Maximum clients and enter a value in the clients box. To set a limit on the total bandwidth consumed by unicasts streamed from this publishing point, select Limit to for Maximum bandwidth, and enter a value in the Kbits/sec box.

    For more information about setting limits on clients and bandwidth, see Controlling client connections and bandwidth usage.

Note

  • Setting another publishing point as a new Home publishing point deletes the current Home publishing point. If you give a publishing point an alias and then select the Home option, the alias you use is replaced by the alias Home. If you change the Home publishing point, the .asf files in the old Home publishing point are no longer published and not available for streaming.


To edit a broadcast unicast publishing point

  1. In the Windows Media Administrator menu frame, click Unicast Publishing Points.

    The Unicast Publishing Points page appears.

  2. Click the broadcast unicast publishing point that you want to update in the list, and then click Broadcast.
  3. Click Properties.
  4. To rename the broadcast publishing point alias, type a new name in the Alias box.
  5. If the remote broadcast is delivering a stream from a new source, type the updated URL in the URL box. If Windows Media Encoder is streaming the remote broadcast from a new location, verify that the stream from Windows Media Encoder is from the default port (7007). If it is not from the default port, type the port number in the Port box.
  6. To set limits on the number of clients that access your broadcast publishing point, select Limit to for Maximum clients and enter a value in the clients box. To set a limit on the total bandwidth consumed by your broadcast, select Limit to for Maximum bandwidth and enter a value in the Kbits/sec box.

    For more information about setting limits on clients and bandwidth, see Controlling client connections and bandwidth usage.


To remove a unicast publishing point

  1. In the Windows Media Administrator menu frame, click Unicast Publishing Points.

    The Unicast Publishing Points page appears.

  2. Click either the On-Demand or Broadcast unicast publishing point that you want to remove from the list of publishing points.
  3. Depending on which type of unicast publishing point you choose to remove, click On-Demand or Broadcast, and then click Delete.

Note

  • You cannot remove the Home on-demand unicast publishing point.


To control the number of client connections to a Windows Media server

  1. In the Windows Media Administrator menu frame, click Server Properties.

    The Configure Server - Server Properties page appears. The content on the General tab appears by default.

  2. Select Limit to for Maximum clients and type a value for the maximum number of client connections in the Clients box.
  3. Click Apply to save your changes.

Note

  • A Windows Media server can impose a limit on the maximum number of client connections that is lower than the value that you enter. For more information, see Calculating the maximum number of effective client connections.


To control the total amount of bandwidth streamed by a Windows Media server

  1. In the Windows Media Administrator menu frame, click Server Properties.

    The Configure Server - Server Properties page appears. The content on the General tab appears by default.

  2. Select Limit to for Maximum bandwidth and type a value for the maximum bandwidth that can be streamed by the Windows Media server in the Kbits/sec box.
  3. Click Apply to save your changes.

Note

  • The upper limit for maximum bandwidth must not exceed 85 percent of the capacity of the network card. The value also can affect the number of client connections to the server. For more information, see Calculating the maximum number of effective client connections.


To limit the bandwidth that any .asf file can consume

  1. In the Windows Media Administrator menu frame, click Server Properties.

    The Configure Server - Server Properties page appears. The content on the General tab appears by default.

  2. Select Limit to for Maximum file bitrate.
  3. Type a value for the maximum amount of bandwidth that any one piece of ASF content can consume as it is streamed by the Windows Media server in the Kbits/sec box.
  4. Click Apply to save your changes.

Note

  • A Windows Media server does not stream any ASF content that exceeds the value of the Maximum file bitrate that you set with this procedure.


To specify maximum client connections per second

  1. From the Run dialog box, type regedit32 to open the system registry editor.
  2. Navigate to HKEY_LOCAL_MACHINE\ SYSTEM\ CurrentControlSet\ Services\ nsunicast\ Parameters\.
  3. From the Edit menu, point to New, then click DWORD value. New Value #1 appears in the registry key listing.
  4. Click New Value #1, then from the Edit menu, click Rename and rename the value to MaxConnectionsPerSecond.
  5. From the Edit menu, click Modify.
  6. Under Value data, type the desired maximum number of client connections per second. The default value is 25.
  7. Under Base, select Decimal. Click OK.


To view unicast publishing point client connections to a Windows Media server

  1. In the Windows Media Administrator menu frame, click Publishing Point Clients.

    The Publishing Point Clients page appears.

  2. Select the Enable client monitoring check box.

    All clients currently connected to the server are displayed in the Publishing Point Clients list after the interval specified by Auto-refresh. The default auto-refresh interval is 30 seconds.

    The number of client-to-server connections is displayed above the list, for example:

    There are 5 connection(s).

Note

  • On this page you can sort the list of clients connected to the server, specify a period of time before this list is refreshed, and terminate client connections to the server. For more information, see Managing unicast publishing point clients.


To terminate unicast publishing point client connections to a Windows Media server

  1. In the Windows Media Administrator menu frame, click Publishing Point Clients.

    The Publishing Point Clients page appears.

  2. To view the list of clients connected to the server, follow the procedure in To view unicast publishing point client connections to a Windows Media server.
  3. To terminate a client connection to the server, click the client in the list, and then click Terminate Selection.
  4. To terminate all client connections to the server, click Select All, and then click Terminate Selection.


Streaming unicasts with Windows Media Administrator

Unicast content can be multimedia content stored as an .asf file, a live ASF stream generated by Windows Media Encoder, or a station sent from a remote Windows Media server.

Streaming unicast content involves the following tasks:

  • Creating multimedia content, either stored as an .asf file or as a live stream, from Windows Media Encoder. It is recommended that you dedicate a separate NTFS volume for storing on-demand content. For best results, this volume should be on a separate physical disk. NTFS volumes are more efficient than FAT16 partitions, in terms of storage space used and disk-read operations. An NTFS volume also permits use of access control list (ACL) checking on your content files.
  • Creating and managing unicast publishing points. For unicasts for which the source is a stored .asf file, an on-demand unicast publishing point is used to store the .asf content. For unicasts for which the source is a live content stream, a broadcast unicast publishing point is used to direct the client to the source of the stream. Windows Media Administrator is used to create and manage these unicast publishing points.

    For more information about on-demand and broadcast unicast publishing points, see Understanding on-demand vs. broadcast streaming.

  • Configuring the Windows Media server components. You can control the number of clients that can connect to a Windows Media server, the amount of network bandwidth the server consumes, and the amount of bandwidth a stream can consume. Use Windows Media Administrator to configure these settings.

Note

  • The user account that you log on with to administer Windows Media server components must have Write rights to the physical directories that serve as publishing points; otherwise, you cannot create publishing points or store ASF content there. The account used by Windows Media Services (NetShowServices by default) must have Read rights to these directories in order to stream the ASF content. The account used by Windows Media server components is selected during Windows Media server components setup. You must have administrative rights to modify access privileges for the account used by Windows Media Services. For more information, see Administering Windows Media server components.


Unicast management tools overview

Windows Media Administrator provides the following pages to help you manage your unicast:

  • Unicast Publishing Points. Use the Unicast Publishing Points page to create, edit, and remove on-demand and broadcast unicast publishing points. When you create unicast publishing points, you define the maximum number of clients that can connect at one time and the maximum bandwidth limit (the maximum aggregate bandwidth of all streams served from the unicast publishing point).
  • Server Properties. Use the tabs on the Server Properties page to perform the following tasks:
    • Use the General tab to limit client connections to the server, server aggregate bandwidth, and the maximum bandwidth consumed by a stream.
    • Use the Publishing Point Security tab to authenticate a player, using a pre-installed or custom authentication mechanism.
    • Use the Distribution Authentication tab to enter the information that the unicast server must provide to pass proxy checks when it is attempting to securely distribute content to another Windows Media server.
    • Use the Publishing Point Logging tab to enable Windows Media Unicast service logging, to specify how frequently you want to generate a new log, and to specify the location of the log file.
    • Use the HTTP Streaming and Distribution tab to configure the Windows Media Unicast service to stream using HTTP, allowing Microsoft Windows Media Player to receive a stream through a firewall.
  • Publishing Point Events. Use the Publishing Point Events page to monitor the Windows Media Unicast service for Client, Server, Administrative, and Alert events.
  • Publishing Point Clients. Use the Publishing Point Clients page to view client connections to the server in real-time and to log off clients.


Using unicast publishing points

Creating and managing a publishing point properly is essential to successfully propagating a unicast, either a stored .asf file from an on-demand unicast publishing point or a live stream from a broadcast unicast publishing point. This section provides links to the publishing point topics in this document.

  • How to. . .
  • Introducing unicast publishing points
  • Using on-demand unicast publishing points
  • Using broadcast unicast publishing points
  • Creating unicast publishing points with Windows Media Administrator
  • Announcing your unicast with an .asx file
  • Editing unicast publishing point properties
  • Distributing ASF streams from a Windows Media server
  • Configuring the server for your unicast
  • Managing unicast publishing point clients
  • Troubleshooting your unicast

Note

  • Windows Media Services is designed to be an open, extensible platform that helps you develop companion applications and custom user interfaces, as well as integrate Windows Media Services technology with other software products. Windows Media Technologies Software Development Kit (SDK) describes the rich set of functionality exposed to developers by the Windows Media Services platform. Download Windows Media Technologies SDK from the Windows Media Technologies page at the Microsoft Web site.


Introducing unicast publishing points

With Windows Media Services, you use unicast publishing points to publish—that is make available—ASF files and streams on Windows Media server to Microsoft Windows Media Player. There are two types of unicast publishing points—on-demand and broadcast.

On-demand unicast publishing points

On-demand unicast publishing points are pointers to directories on a Windows Media server. The .asf files in the directory and its subdirectories are available for publishing. Windows Media server components is installed ready to stream on-demand content. No configuration is necessary. To play sample on-demand content immediately, follow the steps in To configure and access on-demand .asf files

To play your own on-demand unicast content, copy your .asf file to the Home publishing point directory, which is defined during installation of Windows Media server components. To find the path to the Home publishing point, in the Windows Media Administrator menu frame, click Unicast Publishing Points. In the On-Demand Unicast Publishing Points list, locate the <Home> unicast publishing point alias and add your .asf file to the Home publishing point specified under Path.

Broadcast unicast publishing points

Broadcast unicast publishing points are used to publish live streams generated from Windows Media Encoder, a remote Windows Media station, or a remote unicast publishing point. Windows Media Player is used to access the broadcast unicast publishing point and, thus, the live stream. During installation, Windows Media server components are not configured to deliver live streams; you must create a broadcast unicast publishing point in order to do this. To quickly create a broadcast unicast publishing point, follow the steps in To configure and access broadcast (live) unicast streams.

A broadcast unicast publishing point is defined by an alias and a path to the broadcast unicast publishing point directory. Broadcast unicast publishing points have maximum client and maximum bandwidth properties, so you can restrict the number of clients that can connect to the publishing point and the size of the stream to be published.


Using on-demand unicast publishing points

Like other Internet services, such as HTTP and FTP, Windows Media Services uses a virtual directory called an on-demand unicast publishing point to stream an .asf file.

Internet services have a Home directory, which is the root directory for that service. The Windows Media server installation creates a Home directory called the Home publishing point, which is the root directory for the Windows Media Unicast service. The default Home publishing point is SystemDrive\ASFRoot.

The default Home publishing point is used strictly as an on-demand unicast publishing point. It does not have an alias; therefore, the name of the server computer represents the Home publishing point when used in a command path that is typed into Microsoft Windows Media Player. For example, to stream zanzibar.asf from the Home publishing point (to which the physical path is SystemDrive\ASFRoot) of a server called Maps, type this command when you open zanzibar.asf in Windows Media Player:

mms://Maps/zanzibar.asf

To help organize your ASF content for users, you can stream .asf files from subdirectories within the Home publishing point directory. In this scenario, you select the existing Home publishing point, but publish the file forecast.asf from the subdirectory Weather:

mms://Maps/Weather/forecast.asf

You also can create new on-demand unicast publishing points to help you organize your content. To create additional on-demand unicast publishing points, use the Unicast Publishing Points page to create an alias and specify a path to the new unicast publishing point directory. You can place .asf files in a directory on any local drive; on a separate computer, mapping a drive to that directory; or on a separate server, sharing the directory on that server. Then you can create an on-demand unicast publishing point for that content.

Note

  • You can create only one Home publishing point on a Windows Media server. Like HTTP server virtual directories, on-demand unicast publishing points allow you to secure stored .asf files by restricting access to the directories where the content exists. For more information on securing ASF content with unicast publishing points, see Setting up unicast publishing point security.


Using broadcast unicast publishing points

Broadcast unicast publishing points are used to organize live streams. For broadcast unicast publishing points, you create pointers to live streams from Windows Media Encoder, a remote Windows Media station, or a remote unicast publishing point. The following table lists an example of each type. For the examples, the Windows Media server is called Maps.

Type | Alias | Path | To play the ASF stream, type:
Windows Media Encoder | Hockey | msbd://encoder:7007 | mms://Maps/Hockey
Remote station | Squash | msbd://remote_server/station1 | mms://Maps/Squash
Remote on-demand unicast publishing point | Shooting | mms://remote_server/alias1 | mms://Maps/Shooting/file.asf
Remote broadcast unicast publishing point | Skating | mms://remote_server/alias2 | mms://Maps/Skating

Like on-demand unicast publishing points, broadcast unicast publishing points create a one-to-one stream from the server to the client. To create a broadcast unicast publishing point for:

  • A stream from Windows Media Encoder. Create an alias, and then create a path that points to Windows Media Encoder using the following syntax: protocol://encoder_machine_name(:portnumber).

    Use MSBD protocol, and the name of the computer running Windows Media Encoder as the encoder name. The port number is required only if you have changed the default port (7007) used by Windows Media Encoder. For example, to point to a computer named Zanzibar using port 1480, type msbd://Zanzibar:1480.

  • A stream from a remote Windows Media station. Create an alias, and then create a path that points to the station using the following syntax: protocol://machine_name/stationname.

    Use MSBD protocol, the name of the computer running Windows Media server components as the machine name, and the name of the Windows Media station as the station name. For example, to point to a computer named StationServer that is streaming a station called Station1, type: msbd://stationserver/station1.

    When clients are unable to receive a stream via multicast, the Windows Media server uses unicast publishing points that reference a station to provide unicast connections to the stream. For more information, see Creating unicast rollover for a multicast station.

  • A remote on-demand unicast publishing point. Create an alias and a path that points to the on-demand unicast publishing point using the following syntax: protocol://servername/pubpointalias.

    Use MMS protocol. Use the name of the Windows Media server streaming the on-demand unicast publishing point as the server name, and then the unicast publishing point alias. For example, to point to a computer called UnicastServer that contains the on-demand unicast publishing point hounds, type: mms://unicastserver/hounds. To reference an .asf file located in the remote on-demand publishing point, you must specify the name of the .asf file in the URL for the broadcast publishing point. The on-demand unicast publishing point alias only references a directory, not an ASF stream. For example, you create a broadcast publishing point on server1 named canine. To use the broadcast publishing point canine to play an .asf file, dogs.asf, that is stored in the remote on-demand publishing point, hounds, you would use the URL mms://server1/canine/dogs.asf.

  • A remote broadcast unicast publishing point. Create an alias and a path that to the broadcast unicast publishing point by using the following syntax: protocol://servername/pubpointalias.

    Use MMS protocol. Use the name of the Windows Media server streaming the on-demand unicast publishing point as the server name, and then the broadcast unicast publishing point alias. For example, to point to a computer called UnicastServer that contains the broadcast unicast publishing point cows, type: mms://unicastserver/cows.


Creating unicast publishing points with Windows Media Administrator

The Windows Media Administrator Unicast Publishing Points page is separated into on-demand and broadcast unicast publishing points panels. In each panel, you can select a QuickStart wizard that guides you through the creation of these unicast publishing points. The QuickStart wizard also automatically creates an announcement, an .asx file that directs Microsoft Windows Media Player to the on-demand .asf file that you want to publish, or to the broadcast unicast publishing point that is streaming live content. It then lets you save the announcement to a directory that you choose. You also can select other announcement options in the wizard, such as creating a HTML file that contains a hypertext reference (HREF) to your announcement.

To create unicast publishing points using a QuickStart wizard, use the following procedures:

  • To create an on-demand unicast publishing point using QuickStart
  • To create a broadcast unicast publishing point using QuickStart

The user account that you log on with to administer Windows Media server components must have Write rights to the physical directories that serve as publishing points; otherwise, you cannot create publishing points or store ASF content there. The account used by the Windows Media component services (NetShowServices by default) must have Read rights to these directories in order to stream the ASF content. The account used by Windows Media component services is selected during Windows Media server components setup. You must have administrative rights to modify access privileges for the account used by Windows Media component services. For more information, see Administering Windows Media server components.

If you know how to create unicast publishing points, and you want to enter the information without being prompted, before you proceed, clear the Use wizard check box for the type of unicast publishing point you are creating. If you create a unicast publishing point without using the QuickStart wizard, and you want to announce your content, see Publishing a unicast stream. You also must keep in mind the subjects in the following Advanced Topics sections when you create a publishing point without using a QuickStart wizard.


Creating new unicast publishing points--advanced topics

Windows Media Services Banner Art

Creating new unicast publishing points—advanced topics

When you create a new unicast publishing point, the alias you choose must be unique to on-demand and broadcast unicast publishing points. If you try to create a broadcast unicast publishing point named Paris, and you already have an on-demand unicast publishing point with the same name, Windows Media Administrator asks you if you want to replace the existing on-demand unicast publishing point with the new broadcast unicast publishing point.

When you create a new unicast publishing point without using the QuickStart wizard, Windows Media Administrator gives you the option of setting the maximum client and maximum bandwidth limits for the publishing point. These options are different from the options that can be set on the General tab in the Configure Server - Server Properties page, which are system-wide. For more information, see Controlling client connections and bandwidth usage.


Creating an on-demand unicast publishing point--advanced topics

Windows Media Services Banner Art

Creating an on-demand unicast publishing point—advanced topics

You cannot have more than one Home on-demand unicast publishing point on a server. If you want to change the Home on-demand unicast publishing point from the default (SystemDrive\ASFRoot), type the path to your new Home publishing point in the Directory path box, click the Home option and then click OK. The Home alias appears in the On-Demand Unicast Publishing Points list with its path pointing to the new unicast publishing point directory.

Make sure that a directory that you specify as a new on-demand unicast publishing point exists on the server that you are administering. Windows Media Administrator does not verify that a directory for a new unicast publishing point exists.


Creating a broadcast unicast publishing point--advanced topics

Windows Media Services Banner Art

Creating a broadcast unicast publishing point—advanced topics

There are two ways to create broadcast unicast publishing points—via the Unicast Publishing Points page or the Multicast Stations page. Use the Unicast Publishing Points page to create a publishing point for a live stream.

To create a broadcast publishing point, you create an alias for the path to a live stream, such as a Windows Media Encoder (for example, msbd://encoder:port), a station (for example, mms://station_name), or another broadcast unicast publishing point (for example, mms://server/pub_pt_alias). Once the broadcast unicast publishing points exist, users can access the live streams by using Microsoft Windows Media Player to connect to the publishing points. For example, you create a broadcast unicast publishing point with the alias, Lobby. To access the content of this broadcast unicast publishing point, from Windows Media Player, type mms://server/Lobby. For more information, see To create a broadcast unicast publishing point using QuickStart.

If you use Stations QuickStart wizard, then when you specify that you want to create a multicast and distribution station, the wizard automatically creates the broadcast unicast publishing point for you. For more information on using the Stations QuickStart wizard to create a broadcast unicast publishing point, see To create a multicast station using QuickStart.


Announcing your unicast with an .asx file

A user can connect to unicast content (either on-demand or broadcast) by typing the path to the stored .asf file or broadcast unicast publishing point in the Open dialog box in Microsoft Windows Media Player. However, users do not always know how to access this content, or even that it exists.

An .asx file points to ASF content, either in the form of .asf files stored in a unicast publishing point, or a broadcast unicast publishing point that is streaming live content. These .asx files provide the information that Microsoft Windows Media Player needs to connect to the unicast content on a server. They are needed so that Windows Media Player can connect to an .asf file or a live stream from a Web page that does not contain an embedded player.

To make it easier for users to access your ASF content, you can provide an announcement, an .asx file, that gives Windows Media Player the information it needs to connect to a Windows Media server and receive ASF content. An announcement file can be sent in an e-mail message, used as a link reference on a Web page, or stored as a stand-alone file on a hard disk drive. Users can either double-click the .asx file to open Windows Media Player, or click Open to open the .asx file with Windows Media Player. The player then extracts the path to the ASF content, and plays it.

When you create a unicast publishing point using a QuickStart wizard, an .asx file that points to the ASF stream is created automatically.

Announcement files can be more robust. For example, you can create rollover URLs—paths to the same .asf file using different protocols or to the same .asf file hosted on different servers—or playlists—paths to multiple .asf files in a specific order.


Publishing a unicast stream

When you choose a publishing method on the Select publishing method screen in QuickStart, the wizard creates the .htm file or copies the HTML code to the Microsoft Windows clipboard, so that you can paste the code into an HTML page. The wizard creates an .asx file that points to the publishing point automatically, The following publishing methods provide the Web syntax that links to the .asx file.

Creating an .htm file with an <HREF> tag that links to an .asx file

When you select this announcement option in a QuickStart wizard, Windows Media Administrator creates an .htm file that contains the HTML syntax required to link Microsoft Windows Media Player to your .asx announcement.

Creating an .htm file with <EMBED> and <OBJECT> tags for Windows Media Player

When you select this announcement option in a QuickStart wizard, Windows Media Administrator creates an .htm file that connects an embedded Microsoft Windows Media Player ActiveX control to your .asx announcement.

The advantages of using this publishing option is that Windows Media Player is not started as an external application. Instead, the content stream is played in the browser frame after the Web page is rendered. This syntax is compatible with most standard browsers.

Copying <HREF> and/or <EMBED> and <OBJECT> syntax to the Windows Clipboard

If you select one of the .htm announcement options in a QuickStart wizard, you can copy the selected HTML syntax to the Windows clipboard for later retrieval to a text editor by selecting the Copy <HREF> syntax or Copy <OBJECT> and <EMBED> syntax check boxes in the wizard. You also can create these files from scratch by using a text editor, such as Microsoft Notepad.


Editing unicast publishing point properties

You edit on-demand and broadcast unicast publishing points by changing the unicast publishing point alias, the path to the on-demand unicast publishing point directory, or the URL to the remote broadcast unicast publishing point.

Properties of the on-demand unicast Home publishing point can be edited like those of any other on-demand unicast publishing point, except for the following:

  • You cannot change the alias for the on-demand unicast Home publishing point; it always is known as Home.
  • You can specify that another on-demand unicast publishing point be the new Home publishing point; however, it will replace the existing Home publishing point, and the alias assigned to the publishing point that you are changing will become Home.
  • You cannot remove the Home on-demand unicast publishing point.

You also can set limits on the number of clients that access your unicast publishing point and the total bandwidth consumed by the content streaming from your publishing point. For more information about setting these limits, see Controlling client connections and bandwidth usage.


Distributing ASF streams from a Windows Media server

Windows Media Services allows you to distribute an ASF stream between Windows Media servers. Stream distribution can originate from your unicast server and be received by another unicast server, a multicast server, or any combination of these. Distribution of ASF content using the Windows Media Unicast service solves the following problems:

  • Distributes a stream past a firewall and into an organization where the stream can then be unicast or multicast.
  • Provides streams to large numbers of clients, using one Windows Media server to branch the stream to other Windows Media servers, which then can handle the mass of clients.

Distribution of your ASF content from a Windows Media server involves two basic steps:

  1. To distribute an .asf file from your Windows Media server, create an on-demand unicast publishing point. To distribute a live stream generated by Windows Media Encoder, a Windows Media station, or a remote unicast publishing point, create a broadcast unicast publishing point.
  2. On the target Windows Media server, create a station, program and stream to receive your distributed content.


Configuring the server for your unicast

Each Server Property tab in Windows Media Administrator exposes certain Windows Media server components properties.

The General tab lets you set system-wide server properties for the maximum number of clients that can connect to the Windows Media server, the maximum aggregate bandwidth, and the maximum file bit rate that the server can stream. For more information, see Controlling client connections and bandwidth usage.

The Publishing Point Security tab lets you choose an authentication mechanism to be used by Windows Media server components and enables access control list (ACL) checking. For more information, see Setting up unicast publishing point security.

The Distribution Authentication tab lets you enter the information that streams must provide to pass proxy checks. For more information, see Creating distribution authentication.

The Publishing Point Logging tab lets you log information on any unicast activity generated by clients that connect to your unicast publishing points. You can choose how often logs are generated and where the logs are stored. For more information, see Logging unicast client information.

The HTTP Streaming and Distribution tab lets you configure the Windows Media Unicast service to stream using HTTP, allowing Microsoft Windows Media Player to receive a stream through a firewall. For more information, see Setting and administering HTTP streaming and distribution.


Controlling client connections and bandwidth usage

The General tab in Windows Media Administrator controls the limits on the number of client connections and bandwidth usage on the server. The limits you set are system-wide. They affect any ASF stream delivered by the server. The following table describes the server properties you can set.

Property | Description
Maximum clients | This limits the number of clients that can be connected to the server at any given time. Minimum = 0; Maximum = No Limit.
Maximum bandwidth | This limits the amount of bandwidth that the server streams (aggregate bandwidth) and is measured in kilobits per second (Kbps). The upper limit must not exceed 85 percent of the capacity of the network card. Minimum = 1; Maximum = No Limit.
Maximum file bitrate | This limits the amount of bandwidth at which any one file can be streamed, and is measured in kilobits per second (Kbps). Minimum = 1 Kbps; Maximum = No Limit. The server does not attempt to stream any ASF content larger than the value of the Maximum file bitrate; this includes live ASF streams.


Calculating the maximum number of effective client connections

Windows Media server components limits the number of client connections to the smaller of the following two values:

  • The value you enter for Current value when you limit the Maximum clients on the General tab

    or

  • the maximum number of effective client connections that are possible.

For example, you can set the Maximum clients limit to 500, but Windows Media server components can impose a lower limit, based on the Maximum bandwidth value that you select and the average rate at which clients connect to a Windows Media server.

To calculate the maximum number of effective client connections to your Windows Media server, you first must determine the average rate at which clients stream content from the server. This rate can be difficult to determine because the average can be skewed by a high number of slow client-to-server connections or a moderate number of fast client-to-server connections; therefore, you probably can only estimate this value. For simplicity, the following example assumes that all of your clients connect at 28.8 Kbps, and that the average rate at which clients stream content from the server has been estimated as 24 Kbps.

The maximum number of effective client connections can be calculated by dividing the value you enter for the Maximum bandwidth on the General tab by the average rate at which clients stream content from the server:

max effective connections = max bandwidth / avg stream rate

Therefore, if you set the Maximum bandwidth on the General tab to 5000 Kbps, the maximum effective client connections possible is:

max effective connections = 5000 / 24 = 208

If you limit Maximum clients to 500 and Maximum bandwidth to 5000 Kbps, and these clients stream ASF content from the server at an average rate of 24 Kbps, Windows Media server components effectively limit the number of client connections to 208, instead of the value of 500 that you chose. If you want to increase the number of effective client connections, you must consider the tradeoff imposed by increasing the maximum bandwidth limit on the Windows Media server. The maximum bandwidth limit must not exceed 85 percent of the capacity of the network card.


Configuring the client connection rate in a Windows Media server

A server running Windows Media Services processes client connection requests at a rate of 25 per second. Processing client connection requests uses system resources (CPU cycles and memory) and, depending on your computer hardware configuration, may adversely affect server performance and the quality of the media streams to clients connected to your server.

The value for the number of client connection requests processed per second is set to 25 because a computer that meets the minimum system requirements for a Windows Media server can process 25 connection requests per second without impacting the quality of streams being delivered to connected clients. If you are using a computer with multiple processors and a large amount of memory, your computer may be able to process a greater number of connections per second, but it is recommended that you carefully evaluate the use of your computer's CPU and memory before deciding to increase this value. When a server is delivering content to many users, the number of connection requests it can handle may decrease due to resource constraints.

When a connection request is sent from a client to a Windows Media server, the request is placed in a connection queue. After connection requests are received by the server and placed in a queue, they are then processed. If the rate of clients attempting to connect to the server exceeds the client connection rate for processing these connection requests, the queue becomes full. The value for the number of client connection requests placed in the queue is equal to twenty times the value of client connections per second, or 500 by default. This value is set to twenty times the connection rate because Windows Media Player is set to wait 20 seconds before attempting to connect using a failover URL. All requests in the queue get processed within the 20 second wait period.

The server keeps a count of clients placed in the queue. Once the maximum allowed number of requests has been placed in the queue, the server stops listening for connection requests. Any client that attempts to connect is immediately sent a message that the server is unavailable, so the user making the request does not wait in a queue before being informed that the connection request was unsuccessful. Each time this occurs, a Windows Media log entry is made with the error code 503. A Windows 2000 Server Application Event Log entry is also made with the message:

Windows Media Services has reached its maximum pending
connections value of <X>, but this entry is only made
when the server stops listening and a log entry has not
been made in the preceding minute.
Please refer to the documentation to learn how to set
this value to match your network and server conditions.

Here, <X> is a variable, and the number displayed is the value you have set, or 500 by default. The server then checks every 2.5 seconds to see if the queue is full. If clients have been processed out of the queue, the server again begins to listen for connection requests.


Determining optimal settings for client connection rate

If the log entries described in Configuring the client connection rate in a Windows Media server do not appear in your server logs, you do not need to modify the settings for client connection rate. However, if you experience difficulty with client connections, you can modify the rate by defining a custom value for MaxConnectionsPerSecond in the system registry.

The value you set depends on the hardware you have and your client load. Different rates work better for different systems. To find the value that works best for you, gradually increase or decrease the connection value until there is a balance between connection success and server performance.

Note

  • It is important to understand that there is no value for client connection rate that is appropriate for all servers, even if the computers have identical resources. The impact the client connection rate has on stream quality for already connected clients depends on the available resources at the time the requests are processed. A server with multiple CPUs and large amounts of memory can support more clients, but if the utilization of system resources is at a high percentage, increasing the connection rate may degrade stream quality for connected clients. A lower end server may be able to handle 50 connections per second because the server load is lower. When determining the value for connection rate, you must consider resource utilization at the time the requests are being processed. The number of client requests a server can process without affecting stream quality varies depending on the number of clients currently receiving content from that server.


Setting and administering HTTP streaming and distribution

You can unicast ASF streams using HTTP with Windows Media server components. The major advantage of enabling HTTP streaming on a Windows Media server is that it allows a client to receive streams across a network firewall. HTTP streaming is disabled by default.

Windows Media server components cannot stream ASF content via HTTP when Microsoft Internet Information Services (IIS) 3.0 or earlier is installed on the server because IIS binds to port 80 on all available IP addresses. However, with IIS 4.0 or later, you can specify an IP address that IIS can use when it binds to port 80 to serve HTTP streams; the Windows Media Unicast or Windows Media Station service can then use another available IP address to stream ASF content via HTTP. For more information about using Windows Media Services and IIS on the same computer to stream ASF content via HTTP through port 80, see Using Windows Media server components and IIS on the same computer.

It is possible to configure HTTP streaming to use a different port, allowing you to run Windows Media server components and another HTTP service (such as IIS) on the same computer. Generally, this configuration is reserved for server-to-server communications, where you distribute a unicast stream from one Windows Media server through a firewall to another Windows Media server, which then delivers the stream to one or more clients. This reserves port 80 for direct server-to-client connections. For more information about configuring HTTP streaming to use a different port, see Using HTTP streaming.


Managing unicast publishing point clients

Client connections to a unicast publishing point on Windows Media server components can be monitored in real-time using the Publishing Point Clients page in Windows Media Administrator. Client connections also can be terminated on that page. To view unicast connections between a server and its clients, use the following steps:

  1. In the Windows Media Administrator menu frame, click Publishing Point Clients.

    The Publishing Point Clients page appears.

  2. Select the Enable client monitoring check box.

    All clients currently connected to the server are displayed in the Publishing Point Clients list after the interval specified by Auto-refresh. The default auto-refresh interval is 30 seconds.

    The number of client-to-server connections appears above the list, for example:

    There are 5 connection(s).

Note

  • Monitoring more than 100 clients can adversely affect the performance of your server.

The Publishing Point Clients page displays the following information about the unicast client-to-server connection.

Column label | Description
Client ID | A number that identifies the connected client computer.
Client IP Address | The client computer IP address.
Port | The port used by the client computer.
Status | The status of a unicast to the client computer. Status is Streaming when the unicast is streaming, and Open when the unicast finishes streaming.
Filename | The source of the unicast sent to the client computer, either an .asf file name or an ASF stream alias.

On the Publishing Point Clients page, you can sort the list of clients connected to the server, specify a period of time before this list is refreshed, and log off clients connected to the server.

Sorting the list of publishing point clients

Windows Media server components identifies clients by assigning them Client IDs—numerical values in ascending order as clients connect to the server: the first client to connect is given the Client ID 0, the second client to connect receives Client ID 1, and so on. By default, the list of publishing point clients is displayed by Client ID. By double-clicking the appropriate column heading, you also can sort the list of clients in the display by Port, Status, or Filename.

Refreshing the list of publishing point clients

By default, the unicast Publishing Point Clients list is refreshed every 30 seconds. You can edit the time interval at which the list is refreshed by entering a new value for Auto-refresh. You also can disable Auto-refresh, and you can click Refresh to refresh the list of clients manually.

Terminating a publishing point client connection

  • Log off a client connected to the server by clicking the desired client in the Publishing Point Clients list, and then clicking Terminate Selection.
  • Log off all clients connected to the server by clicking Select All, and then clicking Terminate Selection.

A Media Player Error message appears on the client computer, stating that the connection to the server has been lost.


Troubleshooting your unicast

Some common problems that can occur with publishing points are listed in the following table.

Problem | Possible solution
When users connect to the broadcast unicast publishing point, they do not receive any content | On the server that hosts the publishing point, find out what type of source (for example, Windows Media Encoder, remote station, or publishing point) the publishing point uses, and then verify that that source is working. Verify that the path for the alias is correct. Verify that the maximum client limit has not been exceeded. Verify that the live source content does not exceed the maximum bandwidth limit. Verify that the user has access privileges to the broadcast unicast publishing point. Verify that the Windows Media Unicast service is running.
When users connect to an on-demand publishing point, they do not receive the correct content. | Verify that the path to the on-demand publishing point directory is correct. Verify that the .asf file that the client is trying to access exists in the source directory.


Multicasts

Windows Media server components can be configured to multicast streams to clients without using a lot of network bandwidth. Stations are used to multicast streams to clients. Without stations, streams are delivered via unicast, meaning that each client that receives an ASF stream has a distinct connection to the server.

A station contains all the information needed to deliver ASF content to Microsoft Windows Media Player or to another Windows Media server in a usable manner. Station QuickStart wizard is provided to help you define this information. If you are familiar with station characteristics, use the Multicast Stations page in Windows Media Administrator instead of Station QuickStart wizard to create a station.


How to. . .

This section lists the procedures that are most commonly performed in creating and managing multicasts. Use the procedures to quickly accomplish a task. This procedure list precedes the overview information that explains multicasts in more detail. If you want to learn more about multicasts, continue past the procedures and read the overview information.


To create a multicast station using QuickStart

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. Make sure the Use wizard to create new station check box is selected, click Stations, and then click New.

    Configure and Publish Multicast Broadcast Streams QuickStart wizard appears.

  3. On the Select a station screen, select Create a new station.
  4. On the Create a new station screen, type a name and a description for the station, then select a distribution mode.
  5. On the Specify a program and stream name screen, type a name for the program in Program Name and a name for the stream in Stream Name. You also can activate two program options:
    • Select Start program once wizard is finished to make the program immediately available for viewing after the station is created.
    • Select Replay stream objects once finished (loop) to play the program repeatedly after it is started.
  6. The QuickStart wizard presents you with several screens so that you can select and configure a stream source for the multicast station.
    • On the Specify a source for the stream object screen, select a source for the stream.
    • On the Specify a source URL for the stream object screen, type the URL to the stream source.
    • On the Specify stream format information screen (or screens), specify the path to the stream source so its stream format information is added to the station definition.
  7. Store the multicast station information file (.nsc file) in a location that can be accessed by Microsoft Windows Media Player.
    • On the Export path for the station information file screen, type the path to the .nsc file storage location.
    • On the Station information file URL screen, specify the URL or UNC path that Windows Media Player will use to access the stored .nsc file.
  8. On the Select publishing method screen, select the methods for publishing the stream. For more information about publishing methods, see Publishing station content.
  9. On the Ready to publish screen, review the list of options you have selected. To edit any of these, click Back once or more to return to the appropriate station information.
  10. If you do not plan to send the .asx file to users in an e-mail message, save it to an accessible directory. Save any .htm files created by the publishing methods you selected to directories that users can access either directly or via a Web server.

Note

  • On the Publishing complete screen, you can test the stream from your station. To test the station, click Test .asx, Test .htm w/<HREF>, or Test .htm w/<OBJECT> to begin streaming the station content in Windows Media Player.


To create a multicast station using the advanced method

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. On the Multicast Stations page, clear the Use wizard to create new station check box.
  3. Click Stations, and then click New.

    The New Station page appears.

  4. Enter station property information in the text dialog boxes to create a station.

    For more information about station properties, see Editing station properties.


To enable HTTP streaming for the Windows Media Station service

  1. In the Windows Media Administrator menu frame, click Server Properties.
  2. On the Server Properties page, select the HTTP Streaming and Distribution tab.
  3. On the HTTP Streaming and Distribution tab, select Enable HTTP distribution for Windows Media Station service and click Apply.
  4. Restart the server to enable the change. The service starts automatically and binds to the appropriate port.

Note

  • If Windows Media server components and a Web server exist on the server computer, you can set the Windows Media server components to be dependent on the Web server. This setting ensures that the Web server and Windows Media server components will co-exist on the computer. To set this dependency, see To edit the registry so that the Windows Media Unicast service depends on the Web server.


To edit a station

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. From the list of stations, double-click the station whose properties you want to edit.

    The Edit Station page appears, listing all station properties.

  3. Make the changes you want.

Note

  • A message appears, asking you if you want to save your changes to an .nsc file. To save changes to the .nsc file, you must export the .nsc file to the same directory where the older version of the .nsc file exists.


To export a station

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. On the Multicast Stations page, click the station you want to export, click Stations, and then click Export.
  3. In the Export a station dialog box, find the directory in which you want to store the .nsc file and click Save.

Note

  • Before you can export a station, you must stop any active streams in that station. To stop a stream, you must stop its program. For more information, see To stop a program.


To import a station from an .nsc file

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. On the Multicast Stations page, click Stations, and then click Import.
  3. Select Import a new station from an existing station file (.nsc) and click Import.
  4. In the Windows Media Administrator dialog box, locate the .nsc file and click Open.

Note

  • When you import a station from an .nsc file, only station information is imported. No program or stream information is included. To associate streams with a station, either create new streams whose Destination is the imported station or edit existing streams so that their Destination is the imported station.


To import a station from another Windows Media server

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. On the Multicast Stations page, click Stations, and then click Import.
  3. Select Import a station from a remote Windows Media server.
  4. On the Import New Station From Windows Media Server page, in the Remote Server Name box, type the name of the Windows Media server from which you want to import one or more stations and click Connect.

    A list of stations available on the server appears.

  5. Click one or more stations that you want to import, and then click Copy Station.

    The station is added to the list of stations.

Note

  • When you import a station from a remote Windows Media server, only station information is imported. No program or stream information is included. To associate streams with a station, either create new streams or edit existing streams so that their Destination is the imported station.


To copy a station

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. On the Multicast Stations page, in the list of stations, click the station with the information you want to copy, click Stations, and then click Copy.
  3. In the Copy station dialog box, type a name for the new station.
  4. On the New Station page, type a new port in Port. You also can edit any information in any of the other boxes.

Notes

  • Before you can copy a station, you must stop any active streams in that station. To stop a stream, you must stop its program. For more information, see To stop a program.
  • If the station being copied is a distribution station only, the new station does not require values for IP address and port and it will be added to the list of stations automatically. For more information about editing properties for this station, see Editing station properties.
  • No program or stream information is associated with the new station. To quickly add a program and stream to the new station, see To create a program and stream for a station using QuickStart.


To remove a station

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. On the Multicast Stations page, from the list of stations, click the station you want to remove.
  3. Click Stations, and then click Delete.

Note

  • Before you remove a station file, it is a good idea to export the station. This way, if you decide that you want to use a station that you removed earlier, you can import it again.


To create a program and stream for a station using QuickStart

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page opens.

  2. Make sure the Use wizard to create new station check box is selected, click Stations, and then click New.

    Configure and Publish Multicast Broadcast Streams QuickStart wizard appears.

  3. On the Select a Station screen, select the Select an existing station check box, and from the list of stations, click the station to which you want to add a program and stream.
  4. Follow steps 5 through 10 in To create a multicast station using QuickStart.

Note

  • This procedure assumes that either you have created a station that has no associated programs or streams, or you have imported a station. The station retains its properties, such as distribution mode, IP address, and time-to-live value (TTL).


To create a program

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. In the list of stations, click the station for which you want to create the program.
  3. Click Programs, and then click New.

    The Program dialog box appears.

  4. In Name, type a name for the program.
  5. (Optional) In Description, Author, and Copyright, type the appropriate information for the program.
  6. Under Play Options, type the number of times you want the program to play in the Play time(s) box. If you want the program to loop repeatedly until you stop it, select Play Forever.
  7. Add one or more streams to your program. For more information, see To add streams to a program.

Notes

  • Before you can create a program, you must create at least one station. For more information, see To create a multicast station using QuickStart.
  • If a stream fails to play, the program tries to play the next stream in the series. To stop the program when such an error occurs, in the Program dialog box, select the Stop Program On Error check box.


To add streams to a program

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. On the Multicast Stations page, click the program to which you want to add a stream.
  3. Click Streams, and then click New.
  4. In the Advanced Streaming Format dialog box, click the General tab.
    • In the Name box, type a name for the stream.
    • (Optional) In the Description box, type a description of the stream.
  5. Click the Source/Destination tab.
    • Under Source, in the URL box, type the path to the source of the stream. If Windows Media Encoder is the stream source, and the encoder has been configured to create the connection and deliver an ASF stream to the Windows Media server, type the connection alias in the Alias box.

    For more information about specifying a source for a stream, see Defining sources for streams.

    • Under Station, in the Station box, select the station you want to use for the stream.
  6. (Optional) Click the Advanced tab.

    For information about setting any options for a stream on the Advanced tab, see Editing stream properties.


To edit stream properties

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. Under Multicast ASF Programs and Streams, click the name of the stream you want to edit.
  3. Click Streams, and then click Properties.
  4. Make the changes you want.

    For more information about how to edit the information in each box, see Editing stream properties.

Note

  • This procedure assumes that you are editing the properties of an ASF stream that is associated with a program.


To edit a playlist

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. Under Multicast ASF Programs and Streams, click the name of the stream you want to move.
    • To move the stream up in the order, click Streams, and then click Move Up; or click the up arrow on the far right under Multicast ASF Programs and Streams.
    • To move a stream down in the order, click Streams, and then click Move Down; or click the down arrow on the far right under Multicast ASF Programs and Streams.
    • To remove a stream from the playlist, click Streams, and then click Delete.


To create a program announcement

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. Under Multicast ASF Programs and Streams, click the name of the program that you want to announce.
  3. Click Programs, and then click Announce Program.

    The Save As dialog box appears.

  4. In the File Name box, type the path and file name for the announcement (.asx) file.
  5. Click Save.

Note

  • Be sure to save the announcement file to a location that the user can access, for example, to a shared UNC directory or to a Web server directory. The .asx file enables Microsoft Windows Media Player to access the ASF stream.


To save a program

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. Under Multicast ASF Programs and Streams, click the name of the program you want to save.
  3. Click Programs, and then click Archive Program.

    The Save As dialog box appears.

  4. Locate the directory in which you want to save the program file.
  5. In the File name box, type a name for the file.
  6. Click Save.


To restore a saved program

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. Under Multicast ASF Programs and Streams, click Programs, and then click Restore ASF Programs.
  3. In the Open dialog box, type the full path of the file.
  4. Click Open.


To edit program properties

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. Under Multicast ASF Programs and Streams, click the program whose properties you want to change.
  3. Click Programs, and then click Properties.

    The Program dialog box appears.

  4. Make changes to the properties.

    For more information about program properties, see To create a program.

Note

  • You cannot edit a program that is running. For more information, see To stop a program.


To delete a program

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. Under Multicast ASF Programs and Streams, click the name of the program you want to remove.
  3. Click Programs, and then click Delete.


To start a program

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. Under Multicast ASF Programs and Streams, click the name of the program you want to start.
  3. Click Start Program.


To stop a program

  1. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  2. Under Multicast ASF Programs and Streams, click the name of the program you want to stop.
  3. Click Stop Program.


To create a file transfer program

  1. In the Windows Media Administrator menu frame, click Multicast File Transfers.

    The Multicast File Transfers page appears.

  2. Under Multicast File Broadcasts, click Programs, and then click New.

    The Program dialog box appears.

  3. In Name, type a name for the program.
  4. (Optional) In Description, Author, and Copyright, type the appropriate information for the program.
  5. Under Play Options, type the number of times you want the program to play in the Play time(s) box. If you want the program to loop repeatedly (that is, make the file transfer stream or streams always available to the client) until you stop it, select Play Forever.

    The file transfer program appears in the list of programs.

Notes

  • To complete a multicast file transfer, you must add file transfer streams to the program, and then start the program. A file transfer program can contain only file transfer streams; it cannot contain ASF streams. For information, see To add a file transfer stream to a program
  • If a file transfer stream fails to play, the program tries to play the next file transfer stream in the series. To stop the program when an error occurs, in the Program dialog box, select the Stop Program On Error check box.


To add a file transfer stream to a program

  1. In the Windows Media Administrator menu frame, click Multicast File Transfers.

    The Multicast File Transfers page appears.

  2. Under Multicast File Broadcasts, click the name of the program to which you want to add the stream.
  3. Click Streams, and then click New.
  4. To give the stream a name and description, click the General tab.
    • In the Name box, type a name for the stream.
    • In the Description box, type a description for the stream.
  5. To define the source and destination for the stream, click the Source/Destination tab.
  6. Under Source:
    • Click File to transfer files and directories.

    In the File box, type the path and name of the file or directory you want to transfer.

    To transfer all the files in a directory, type the directory name. Files are transferred to the location specified under Destination unless this destination is overridden by the client.

    To specify multiple files in a directory, use a wild card.

    To transfer the subdirectories and their files in a directory, select the Include Subdirectories check box. Subdirectories are created below the location you enter under Destination. Empty subdirectories are not transferred.

    • Click URL to transfer a file referenced by its URL. In the URL box, type the Internet address of the file you want to transfer. The file is transferred to the browser cache on the client computer.
  7. Under Destination Address:
    • In the IP Address box, type the destination IP address.
    • In the Port box, type the destination port.

    For more information on specifying IP addresses and ports for a multicast file transfer, see Configuring a multicast file transfer.

  8. To specify the scope of the broadcast, select a Time to Live option:
    • Click Local Network to limit the broadcast to the local network node.
    • Click Intranet to limit the broadcast to your site.
    • Click Internet to expand the scope of the broadcast to the Internet.
    • Click Other to type a custom value. Values can range from 1 through 255.

    For more information on setting the scope of broadcasts, see Setting multicast scope.

  9. Under Destination, select a destination for the file transfer:
    • Click Directory and type a directory name in the box to transfer the files and directories you have specified to that directory on the client. You can use environment variables to specify a location on the client. By default, files and subdirectories are transferred to the directory specified by the client temp environment variable.
    • Click File and type a file name in the box to transfer a file and rename it on the client.
    • Click Base URL and type a URL to transfer the files you have specified to the Microsoft Internet Explorer cache on the client. The URL you specify is used as a prefix for each of the files transferred.

    Use this option to load the client cache with files before they are needed. For example, if you are streaming an .asf file that includes URLs of graphics files, you can transfer the graphic files to the client before they are needed for display. Because they are already in the cache, the client can display them quickly.

  10. To display the advanced options, click the Advanced tab.

    For more information about filling out the Advanced tab, see Using the file transfer Advanced tab.

Note

  • Files can be referenced by UNC path or URL. If URL references are used, the files and the URLs are transferred to the client computer. The files are stored in the directory specified by the stream and the URLs are stored in the browser cache. This is called stuffing the cache. Stuffing the cache works only if you are using Microsoft Internet Explorer version 3.0 or later. The browser security settings on a client computer must be set so that it can receive file transfers.


Stations, programs, and streams overview

Station, program, and stream information must be provided before Windows Media server components can multicast ASF streams. Without this information, a Windows Media server can stream only on-demand .asf files.

The following diagram shows how Microsoft Windows Media Player accesses a multicast ASF stream.

Step | Action
1 | The client computer opens an .asx file from an e-mail message, via UNC path, or from a Web page link.
2 | Windows Media Player extracts the URL to an .nsc file from the .asx file. The URL is the path provided by the Station information file URL screen in Station QuickStart wizard or the Station File Path property on the Edit Station page.
3 | Windows Media Player downloads the .nsc file and locates the IP address and port for the multicast. Windows Media Player listens to this IP address and port for data. If the Windows Media server sends data within a certain time interval, Windows Media Player renders the data and plays the stream.
4 | If Windows Media Player does not receive the data within the time limit, it looks up the unicast URL in the .nsc file (from Station properties), connects to the publishing point, and receives a unicast of the ASF stream. It displays an error message if no unicast URL is present.


Understanding multicast stations

A station is used to multicast an ASF stream to a client, specifically Microsoft Windows Media Player. Multicasting minimizes the network bandwidth used. If clients do not use the station to receive the ASF stream, then each client requires its own connection to a server. This quickly consumes network bandwidth and limits the ability of the network to deliver information.

Distribution mode is a station characteristic that defines whether a station is to be used for multicasting, distribution, or both.

  • Multicast stations deliver ASF streams to many clients but use only the bandwidth of a single stream.
  • Distribution stations deliver ASF streams to other Windows Media servers via unicast. A station that is solely a distribution station does not have an IP address or port, so clients cannot view the stream that the station delivers.
  • Stations enabled for multicast and distribution deliver ASF streams to other Windows Media servers via unicast. Clients can also view the ASF content on this station via multicast.

A station contains all the information needed to deliver an ASF stream to Windows Media Player, including IP address, port, stream format, time-to-live (TTL) value, and so on. This information is stored in an .nsc file.

Windows Media Player must be able to access the .nsc file so that it can locate the IP address that the station is using to stream ASF content. The .nsc file is typically made available to Windows Media Player from a shared network directory or from a Web server directory. Windows Media Player extracts the URL to the .nsc file when it opens an announcement that is delivered to it in an email message, via UNC path, or from a Web page link.

The Multicast Stations page in Windows Media Administrator is the access point for creating and managing stations. This page also provides an interface for organizing streams into the programs delivered on the stations you create.


Understanding distribution stations

A distribution station is a helper station. It delivers an ASF stream from Windows Media server A to a station on Windows Media server B so that Windows Media server B can multicast that ASF content. A distribution station provides a way to:

  • Distribute a stream between network segments that are not connected by multicast-enabled routers.
  • Distribute a stream past a firewall.

Other stations access the distribution station by creating a connection to the distribution station .nsc file using the MSBD protocol. For example, if you want Station2 on ServerB to multicast the ASF content from distribution station, Station1 on ServerA, you use Station1 as the stream source. That is, the stream source for Station2 is msbd://ServerA/Station1.

Note

  • When you distribute streams between servers, you must not exceed the distribution limit, the number of MSBD connections that a distribution station can accommodate. By default, a distribution station can support only five MSBD connections to other stations. As you configure stations on remote Windows Media servers to use a distributed ASF stream, you must adjust the distribution station Distribution Limit to accommodate the additional remote connections, or use more than one distribution station as the source for the remote station. For more information about adjusting the Distribution Limit, see Editing station properties.


Delivering streams over a non-multicast-enabled network

If your network does not use multicast routers, you can multicast a stream only within the network segment that contains Windows Media server components. Clients on other segments of the network cannot receive the ASF stream multicast because it does not originate within their segment.

Clients throughout the network can still receive the stream if the ASF content is multicast within the local segment, and distributed to Windows Media servers on the other network segments. The station on the local network segment must have both multicast and distribution capabilities to accomplish this.

For the other network segments on which you want to enable multicast streaming, you must install a separate computer running Windows Media server components. On each Windows Media server, use Station QuickStart wizard to create a station with multicast capabilities that uses the remote distribution station as the stream source. Each of these Windows Media servers then can multicast the ASF stream within its local segment.

Note

  • The stream format that was specified in the remote distribution station must be used for the multicast stations created in each network segment. For more information, see Importing a station.


Delivering streams through a firewall

If you do not have a Web server, but want to stream content across a firewall to a client, you can enable HTTP streaming on Windows Media server components. HTTP streaming is useful for delivering a stream through a firewall because HTTP streaming usually uses port 80 and most firewalls do not block port 80.

Windows Media server components contain two streaming services—Windows Media Station service and Windows Media Unicast service. Windows Media server components can be configured to use HTTP streaming, but only one streaming service (Windows Media Station service or Windows Media Unicast service) can use HTTP streaming at a time. This is because only one service can bind to port 80.

With IIS 4.0 or later, you can specify an IP address that Microsoft Internet Information Services (IIS) can use when it binds to port 80 to serve HTTP streams. The Windows Media Unicast or Windows Media Station service can then use another available IP address to stream ASF content via HTTP through port 80. For more information about using Windows Media Services and IIS on the same computer to stream ASF content via HTTP through port 80, see Using Windows Media server components and IIS on the same computer.

It is possible to configure HTTP streaming to use a different port, allowing Windows Media server components and another HTTP service (for example, Internet Information Services [IIS]) to run on the same computer. The only drawback is that most firewalls, by default, only allow HTTP traffic to pass through port 80.Therefore, this functionality is generally reserved for server-to-server distribution, reserving port 80 for direct server-to-client connections. For more information about configuring HTTP streaming to use a different port, see Using HTTP streaming.


Creating multicast stations with Windows Media Administrator

You can create a multicast station, a distribution station, or a station for multicast and distribution using the Configure and Publish Multicast Broadcast Streams QuickStart wizard on the Multicast Stations page in Windows Media Administrator, or you can use an advanced method to create one of these stations. If you use the wizard to create one of these stations, stream format information is added to the station definition on the Specify stream format information screen.

If you use the advanced method to create a station, it is possible to create the station without adding stream format information to the station definition, and the Windows Media server will play the program for this station. If you create a distribution station, other stations can receive the stream for distribution because stream format information is not required to distribute a stream. However, if you create a multicast station, multicast clients cannot connect to the station because all stream format information is missing.

To enable the multicast clients to render the multicast stream for the station, you must add stream format information for all of the streams in the program to the multicast station definition. If you do not add stream format information for all the streams in the program to the multicast station program definition, then the Windows Media server will not deliver the streams in the playlist for which stream format information was not added and will report the error, "The station does not support the stream format" in the status report for these streams on the Multicast Stations page.

If you create a station enabled for multicast and distribution, and you do not add the stream format information for all the streams in the program to the station definition, both multicast clients and distribution stations receive only the streams in the playlist for which stream format information is included in the station definition and fail to receive the rest of the streams.

For more information, see Adding stream format information.


Selecting stream sources for stations

When you create a station, you must provide the source URL and stream format information for the content that you are streaming. This content can be an .asf file, an .mp3 file, a stream from a Windows Media Encoder, a remote station, or a remote broadcast publishing point. The source URL is provided on the Specify a source URL for the stream object page in Configure and Publish Multicast Broadcast Streams QuickStart wizard. Next, the stream format information in provided on the Specify stream format information screen in the wizard.


Specifying the source URL for the stream object

The format of a URL to an .asf or an .mp3 file in the Home publishing point on a Windows Media unicast server must be <protocol>://<unicast_server>/<filename>. The format of a URL to an .asf or .mp3 file stored in any other publishing point must be <protocol>://<unicast_server>/<publishing_point_alias>/<filename>. MMS protocol or HTTP (if the unicast server has been configured to stream via HTTP) is used.

The format of a URL to an installation of Windows Media Encoder must be <protocol>://<encoder_name>[:port]. MSBD protocol or HTTP (if the encoder has been configured to stream via HTTP) are used. If the encoder does not use the default port (7007), then the correct port must be specified.

The format of a URL to a remote station must be <protocol>://<server_name>/<station_name>. MSBD protocol is used.

The format of a URL to a broadcast publishing point must be <protocol>://<server_name>/<publishing_point_alias>. MMS protocol or HTTP (if the unicast server has been configured to stream via HTTP) is used.


Adding stream format information

Microsoft Windows Media Player uses stream formats to decode a multicast ASF stream. Stream formats are stored in the station .nsc file and can be downloaded to Windows Media Player. A stream format includes information about the stream, the media that the stream contains, and its codec. A stream format is required for every type of stream that plays through a station. If two or more stream objects are defined for a station and are using different codecs, bit rates, or frame sizes for the streams, then stream format information must be specified for both types of streams. If stream format information is either missing or incorrect for a stream in the program for a station, Windows Media Player either cannot start the stream or cannot play some of the streams in the program playlist. For more information, see Creating multicast stations with Windows Media Administrator.

If you use the Configure and Publish Multicast Broadcast Streams QuickStart wizard on the Multicast Stations page in Windows Media Administrator to create a station, stream format information is added to the station definition on the Specify stream format information screen.

If you are using the advanced method to create a station or if you are adding streams to an existing station, you must add stream format information to the station definition. For more information, see Editing station properties.


Creating unicast rollover for a multicast station

Unicast rollover can be used when Microsoft Windows Media Player cannot receive multicast packets from a station. This can occur, for example, because the network routers are not multicast-enabled, or because Windows Media Player is beyond the time-to-live (TTL) radius of the multicast. Unicast rollover will not occur when a multicast station streams no content because a multicast station emits beacon packets even if no program is defined for it. If Windows Media Player is within the TTL radius of the multicast, it binds to the beacon packets, which contain no content.

When Microsoft Windows Media Player opens an .asx file for a multicast station, the .asx file instructs Windows Media Player to download the .nsc file, which can contain a unicast rollover URL. If Windows Media Player cannot receive the ASF stream that is being multicast, it uses the unicast rollover URL to connect to the server and receive the stream from a broadcast unicast publishing point.

If you use Configure and Publish Multicast Broadcast Streams QuickStart wizard to create a station for multicast and distribution, the wizard creates a broadcast unicast publishing point (with an alias that is identical to the station name) that references the station. The wizard adds a unicast rollover URL to this broadcast unicast publishing point in the station definition.

If you use the wizard to create a multicast station, or if you use the advanced method to create a station for multicast and distribution or a multicast station, and you want to enable unicast rollover for your station, you must create a broadcast unicast publishing point that uses the multicast station as the stream source. For more information, see Using broadcast unicast publishing points. Then to enable unicast rollover for the station, you must supply a unicast URL to the broadcast unicast publishing point in the form mms://server_name/alias, where server_name is the name of the server that hosts the broadcast unicast publishing point and alias is the broadcast unicast publishing point alias. For more information, see Editing station properties.


Publishing station content

When you choose a publishing method, the wizard creates that .htm file or copies that HTML code to the Microsoft Windows clipboard, so that you can paste the code into an HTML page. An .asx file that points to the ASF stream is created by default; the following publishing methods provide the Web syntax that links to the .asx file.

Create an .htm file with an <HREF> to the .asx file

Station QuickStart wizard prompts you for a location in which to save the .htm file, and to rename it if necessary. To make this file available to others, save it on a Web server. The default name of the .htm file is station_name_href_tag.htm.

To test the Web page created by this file, click Test .htm w/ HREF on the last screen of the wizard to open the sample Web page, which contains the link to the .asx file. Click the link to open Microsoft Windows Media Player. Windows Media Player accesses the station and plays the stream.

Create an .htm file containing <OBJECT> and <EMBED> tags for Windows Media Player

Station QuickStart wizard prompts you for a location in which to save the .htm file, and to rename it if necessary. To make this file available to others, save it on a Web server. The default name of the .htm file is station_name_object_tag.

To test the Web page created by this file, click Test .htm w/ OBJECT on the last screen of the wizard to open the Web page in the browser. When the Web page opens, the Windows Media Player control appears. Windows Media Player automatically accesses the station and plays the stream.

Copy <HREF> syntax to the Windows clipboard

This option inserts the name of and path to your .asx file in the code that creates a link to your station content. Paste this HTML code from Windows clipboard into any Web page to create a link to your station.

Copy <OBJECT> and <EMBED> syntax to the Windows clipboard

This option inserts the name of the .asx file and the path to the .asx file into the code that embeds the Windows Media Player control. Paste this HTML code from the Windows clipboard into any Web page so that your station content is played automatically when the Web page is opened.


Editing station properties

The New Station page lets you enter individual station properties to create a station without using Station QuickStart wizard. The Edit Station page lets you view and edit the properties of an existing station. These two pages are identical, except that the property boxes in the New Station page are empty.

The station properties are described in the following table. The Name, Port, TTL, and Station File Path properties are required; you cannot create an .nsc file without filling in these boxes. The other properties are optional.

Property | Definition of property | Example
Name | Text that appears on the Microsoft Windows Media Player Station tab. | Action News!
Description | Text that appears on the Windows Media Player Station tab. | All the news for the greater tri-state area.
Contact Address | Text that appears on the Windows Media Player Station tab. | www.action**news.com
Contact Phone | Text that appears on the Windows Media Player Station tab. | (123) 456-7890
Contact E-Mail | Text that appears on the Windows Media Player Station tab. | action**news@msn.com
Distribution Mode | Distribution mode used by the station, either Multicast, Distribution, or Both. |
Multicast IP | IP address used by the station. | For more information, see Setting multicast destination IP address and port.
Adapter Address | Number of the adapter address (or network card). If you have only one network card, use Default. | Default
Port | Port used by the station. | 27125
TTL | Number that represents the scope of the multicast—any number from 1 through 255. | For more information, see Setting multicast scope.
Distribution Limit | Maximum number of distribution servers that can connect to this server. When the source server reaches the distribution limit, no other servers can connect until another distribution server disconnects. Used only if the station is distributed to other Windows Media servers. | 5
Unicast URL | Windows Media server and publishing point to which clients automatically connect to receive unicast streams if they cannot receive a multicast. | For more information, see Creating unicast rollover for a multicast station
Station File Path | Network location where clients retrieve the .nsc file. Before you create a station, decide where to store station files. Typically, this storage location is a directory on a HTTP server. You must create the directory and its storage location. Windows Media Administrator asks you to export the .nsc file that contains the station property information. Export the .nsc file to the directory that you stated in the Station File Path dialog box. | http://server/dir/file.nsc or \\server\share\file.nsc
Logging URL | URL to the .dll file that the server uses to generate logging files. This URL must be an HTTP path. If you want to log station information, make a logging component available on either an HTTP server or a shared directory. | For more information, see Logging multicast client information.
Enable Auto Archive | Option that creates an .asf file that stores a copy of all the stream information that is delivered on the station. Once you enable auto-archiving, you can choose whether or not to limit the size of the .asf file that is created. In the Archive Directory box, specify the directory where the .asf file is to be created. Make sure that the directory that you specify physically exists on the destination drive; Windows Media Administrator does not create this directory for you. |
Add/Remove Stream Format | Formats in the list of stream formats that the station can deliver. | To add the stream format for an .asf file to the list, a UNC path to the .asf file to be streamed must be provided. If Windows Media Encoder is the stream source, and the encoder was not set up using a template stream format (TSF), then a UNC path to the .asd file, which describes the configuration for the encoder, must be provided.


Setting multicast destination IP address and port

A multicast program is directed to its destination by the station IP address and port. Clients receive the multicast program by instructing their network cards to listen for packets arriving at that IP address and port.

For ASF content, the destination IP address and port are set when you create the station in Windows Media Administrator using the Stations page. Clients learn which address and port to listen to by downloading the .nsc file.

You can create multiple programs destined for the same IP address; however, you must avoid multicasting programs to the same IP address simultaneously. For example, sending a file to the same destination as an audio multicast can interfere with the audio stream.

Multicast IP addresses range from 224.0.0.0 through 239.255.255.255. An IP address in the 239.*.*.* range is recommended for intranets. Avoid using addresses in the 224.*.*.* range. These are reserved for low-level protocols.

IP port numbers range from 1 through 65535.

Note

  • For file transfer streams, the destination IP address and port are set for each stream in a program when you add streams using the Multicast File Transfers page in Windows Media Administrator. In order for a client to receive the multicasts, the IP address and port you set for the file transfer stream must match the IP address and port specified by the client network card. For more information, see Configuring a multicast file transfer.


Setting multicast scope

You can limit the reach of a multicast to the immediate subnet or expand the scope to the entire Internet. The scope is set by specifying a time-to-live. This value, sometimes called the number of hops, decreases each time the multicast passes through a network router. When the value reaches 1, the router stops forwarding the multicast. Values can range from 1 through 255.

Windows Media Services provides the following default values for scope.

Option | Value
Local Network | 5
Intranet | 32
Internet | 127

Because the number and configuration of routers in a network actually determine the value that must be used to limit the scope, you can set a custom value. Your network administrator can determine the value to use to limit the scope to your intranet.


Exporting a station

Exporting a station saves the station information as an .nsc file in a shared directory or Web directory that Microsoft Windows Media Player can access.

The .nsc file contains all the information that Windows Media Player needs to find and render the ASF stream. Typically, the player downloads this file from an HTTP server or a network share by opening an .asx file in email, on a Web page, or from a shared directory. The .asx file points to the .nsc file, which is downloaded to the client computer. Users must have at least read-access to any .nsc files stored on a network share.


Importing a station

Importing a station is the easiest way to make sure that the server can distribute a station. If you are setting up Windows Media server components to multicast streams that originate from a Windows Media distribution server, the stations you use to multicast must contain identical stream format information. Depending on your network configuration, the stations can use the same destination IP address and port for the multicast—for example, you can use the same address if it causes no conflict when the station multicasts to clients on an isolated subnet. Rather than recreate each station, you can import the .nsc file for each station, or you can import the station information directly from another Windows Media server.

Importing a station from a remote server

To import a station from a remote server, you connect to that server and the stations are listed for you; you do not need to know the location of the .nsc files. The .nsc file for a station on a remote server is not imported to a local directory. These files usually are stored on Web servers, and even though you have imported the station, the server is referencing the station information from its source.


Understanding programs and streams

As you configure Windows Media server components to deliver streaming media content to users, you must set up or configure three items: a station, a program, and a stream. After a station has been created, your next task is to create a program, a container that allows you to organize, group, and control ASF streams. Then, you must either create the streams for the program or use existing streams that are associated with other programs. You can associate more than one .asf file or stream with a program.

Sometimes you cannot control when a stream is started and stopped. For example, you cannot control when a remote installation of Windows Media Encoder starts and stops a live ASF stream. To control this live stream, you must associate it with a program that you can control. When you start and stop the program, you start and stop the encoded ASF content that is streaming over the network from the station.

Programs control streams in other ways. For example, a program can control how long and the number of times a stream can play.

Clients do not receive any streaming media until the program is started. Streams play in an order specified by the program. If a stream is not ready when the program reaches it, the program either waits for the stream or stops, depending on the setting of the Stop Program on Error check box for the program. If the program stops, the client eventually stops trying to access that stream.


Adding streams to a program

When you add a stream to a program, you must define the source URL or the alias of the stream content that you want to add and specify the station to be used to deliver the stream. Before you create a program and add streams to it, create a station that supports the appropriate formats for the streams you want to add to the program.

After you create a program, you can associate as many streams with it as needed. Often you can group streams because they logically go together. For example:

  • Electoral candidate Number 1 presenting a live speech.
  • An advertisement stored as a .asf file.
  • Electoral candidate Number 2 presenting a live speech.
  • An advertisement stored as a .asf file.
  • Electoral candidate Number 3 presenting a live speech.
  • Live closing comments from an election official.

To order and control these live and stored events, create a program and then add the streams to the program.


Defining sources for streams

When you add streams to a program, you must provide the source URL or the alias of the stream content that you want to add. The following types of streams can be added to a program:

  • Live streams from Windows Media Encoder
  • .asf, .mp3, or .wav files
  • Windows Media stations
  • Unicast streams from a broadcast unicast publishing point

Live streams from Windows Media Encoder

The source URL must be defined if the Windows Media server is to create the connection to Windows Media Encoder in order to stream ASF content when the program starts. The format of a URL to Windows Media Encoder must be <protocol>://<encoder_name>[:port]. MSBD protocol or HTTP (if the encoder has been configured to stream via HTTP) are used. If the encoder does not use the default port (7007), then the correct port must be specified.

The source Alias must be defined when Windows Media Encoder has been configured to create the connection and deliver an ASF stream to the Windows Media server. The connection from Windows Media Encoder to a Windows Media server has a logical name or alias. Supply the name of the alias and the configuration is complete. The server uses the connection that Windows Media Encoder initiated to receive the ASF stream. You must define an alias on Windows Media Encoder before the program can be started.

.asf, .mp3, or .wav files

The source URL must be defined when adding an .asf, .mp3, or .wav file to a program. The format of an URL to a stored file in the Home publishing point on a Windows Media unicast server must be <protocol>://<unicast_server>/<filename>. The publishing point is omitted.

The format of a Windows Media URL to a stored file stored in any other publishing point must be <protocol>://<unicast_server>/<publishing_point_alias>/<filename>. MMS protocol or HTTP (if the unicast server has been configured to stream via HTTP) is used.

Windows Media stations

The source URL must be defined when adding a station to a program. The format of a URL to a remote station must be <protocol>://<server_name>/<station_name>. MSBD protocol is used.

Unicast streams from a broadcast unicast publishing point

The source URL must be defined when adding a unicast stream from a remote broadcast unicast publishing point to a program. The format of a URL to a remote broadcast publishing point must be <protocol>://<server_name>/<publishing_point_alias>. MMS protocol or HTTP (if the unicast server has been configured to stream via HTTP) is used.


Editing stream properties

After you have added a stream to a program, you can change its properties. You can do so only when the program is not playing. You can edit the properties on the Advanced tab while you are adding a stream to a program. The following table describes the properties of an ASF stream.

Tab | Property | Definition
General | Name | Name of the ASF stream. A stream is referenced in a list of streams by its name. The name appears in the Clip box of Microsoft Windows Media Player.
General | Description | Description of the ASF stream. The description is only for use on a Windows Media server. This information is not displayed on Windows Media Player.
Source/Destination | URL | URL to an .asf or .mp3 file, or ASF stream. For more information, see Defining sources for streams.
Source/Destination | Alias | Alias of the installation of Windows Media Encoder used as the source for the stream. For more information, see Defining sources for streams.
Source/Destination | Station | The station that the ASF content streams over. An ASF stream can be assigned to only one station.
Advanced | Save To ASF | Option that creates an .asf file from the ASF stream.
Advanced | ASF File | Path and a name for the .asf file created by Save to ASF.
Advanced | Maximum Size | Size limit of the .asf file created by Save to ASF. Type a number for the maximum size of the .asf file in megabytes (MB).
Advanced | Duration | Option that sets a time limit for how long the ASF stream is to be delivered over the network. If you select this option, specify the maximum time limit in hh:mm:ss (where hh=hours, mm=minutes, and ss=seconds).
Advanced | Open Timeout | Option that sets a time limit for how long the server is to wait (on an error) before attempting to play the next stream in the list.
Advanced | Ignore Source From Station Stop | Option that ensures that a stream continues to play, even if the source stream stops temporarily. Select this option if the source for the stream is another station.


Editing program playlists

The streams in a program are played in the order shown in the playlist. When one stream ends, the next begins. You can change the order of streams in the list, and you can remove streams from the list when the program is not playing.


Announcing programs

Microsoft Windows Media Player requires a program announcement file to find the station on which the program is playing. Program announcements created by using Windows Media Administrator are files stored with an .asx extension. An announcement points to the .nsc file, which contains station information for the program, including the IP address, port, and stream format information. Windows Media Player uses the announcement to find the .nsc file and retrieve the station information.

After you create an announcement, you can distribute it in a variety of ways:

  • Store it on Microsoft Internet Information Services (IIS) where users download the .asx file via HTTP.
  • Store it in a public directory on a local area network where clients can access the .asx file using a UNC path.
  • Distribute it through e-mail to clients. Users can run the .asx file directly from their e-mail program or save it to disk and run it later.

Note

  • Announcements are not used when multicasting file transfer streams. In those cases, a Microsoft ActiveX control (Nsfile.ocx) must be configured to receive the broadcast.


Saving a program

You archive a program to save a copy of the program properties. A program is archived as an .nsp file. When you archive a program, the station and streams associated with the program are not saved.

When you quit and then restart Windows Media Administrator, the programs you have created remain in the program list. If you want to save a copy of the program and use it again later (restore it), or you want to use it on a different server, archive it. When you archive a program, it is saved as a Windows Media program file with an .nsp file name extension. The streams associated with that program also are saved. Archiving a program does not remove it from the program list.

You can restore any archived Windows Media program. Restoring a program adds it to the list of programs and restores the streams associated with that program.


Editing program properties

You can change the properties of a selected program, including its name and play options. Stop the program before you change its properties. Streams associated with the program are not considered a property, and you cannot edit a stream via the Programs button.


Deleting a program

Deleting a program removes it from the list of available broadcast programs; the streams associated with the program also are deleted. You must stop a program before you can delete it.


Starting and stopping a program

Starting a program starts the first stream in the program. When the first stream ends, the next stream begins. The program ends when the last stream finishes. If you set the program to repeat, when the last stream ends, the first stream restarts automatically.

Stopping a program ends the broadcast. Clients that are listening stop receiving the stream. A program stops after the number of times specified in Play Options unless Play Forever is selected. You also can stop a program by clicking the Stop Program button on the Multicast Stations page.


Creating Welcome to Windows Media Services

As an exercise, this section contains instructions for creating the program Welcome to Windows Media Services. This program will contain three files installed with Windows Media server components: Welcome1.asf, Welcome2.asf, and Welcome3.asf.

In this exercise, you also will create a station that will stream the Welcome to Windows Media Services program. At the end of the exercise, you will open Microsoft Windows Media Player and receive a multicast or unicast of Welcome to Windows Media Services.


Creating the Welcome to Windows Media Services program

  1. Create two shared directories, ASXfiles and NSCfiles, in the root drive on the local server. These directories will store .asx and .nsc files. For this procedure, anyone must be able to access these directories.
  2. Enter the information below while following the steps in To create a multicast station using QuickStart. Use default values for all other options.

    On the Create a new station screen:

    • For Name, type Welcome.
    • For Description, type A multicast and unicast station for delivering ASF files.

    On the Specify a program and stream name screen:

    • For Program Name, type Welcome to Windows Media Services.
    • Clear Start program once wizard is finished.
    • For Stream Name, type Welcome.

    On the Specify a source URL for the stream object screen, append welcome1.asf to the URL for Source URL.

    On the Specify stream format information screen, for Path, type the path to welcome1.asf in your Home publishing point.

    On the Export path for the station information file screen, for Path, type \\server_name\NSCfiles\Welcome.nsc where server_name is the name of the local server, or type SystemDrive\NSCfiles\Welcome.nsc.

    On the Station information file URL screen:

    • Select the Use a network share path to the station information file check box.
    • Type \\server_name\NSCfiles\Welcome.nsc where server_name is the name of the local server.

    In the Save .asx file dialog box, for File name, type \\server_name\ASXfiles\Welcome where server_name is the name of the local server.

  3. To add the stream welcome2.asf to the program Welcome to Windows Media Services, follow the steps in To add streams to a program. Enter the following information during this procedure; use default values for all other options.
    • In the Name box, type Welcome2.
    • In the Source/Destination URL box, type mms://server_name/welcome2.asf, where server_name is the name of the local server.
  4. Repeat step 3 for Welcome3.asf.
  5. Add the stream formats of the additional welcome*.asf files to the station Welcome.
    • On the Multicast Stations page, double-click the station Welcome in the list of stations.
    • On the Edit Station page, in Stream Formats, click Add.
    • In the Add Stream Format File dialog box, find the welcome*.asf files that are stored in the Home publishing point (typically SystemDrive\ASFRoot). Select welcome2.asf and welcome3.asf, and then click Open. If the .asf files are not displayed, set the Files of type to ASF Files (*.asf).
  6. On the Multicast Stations page, under Multicast ASF Programs and Streams, select Welcome to Windows Media Services from the list of programs and click Start Program.

    A green arrow appears in the Status column in the list of programs and the list of streams.

  7. Open Microsoft Windows Media Player on a separate computer.
    • On the player File menu, click Open and type \\server_name\ASXfiles\welcome.asx, where server_name is the name of the server computer.

    Windows Media Player buffers the information and then begins playing the first .asf file in the program Welcome to Windows Media Services . You can view the Status of the .asf files as they are streamed on the Multicast Stations page. Clients that use the .asx file to receive the .asf streams are receiving a multicast. If you want to view Welcome to Windows Media Services via unicast, open Windows Media Player, click File, click Open, and type mms://server_name/welcome, where server_name is the name of the Windows Media server computer.


Configuring a multicast file transfer

To create a multicast file transfer you must configure Windows Media server components to transfer the files and a file transfer ActiveX control (Nsfile.ocx) to receive the transferred files.

The server and client computer must be configured to use the same IP address; otherwise, the files cannot be transferred from the server to the client computer. The Windows Media server streams files to a multicast IP address in the range from 224.x.x.x to 239.x.x.x, where x is any number between 1 and 255. Physical devices cannot use an IP address in this range; therefore, data can be delivered to any of these addresses to be received by multicast clients.

To configure Windows Media server components to deliver a multicast file transfer, you must create a multicast file transfer program and then add one or more file transfer streams to the program. Programs and streams created for delivering ASF content cannot be used. The Multicast File Transfers page in Windows Media Administrator is used to create and edit the programs that transfer files.

The file transfer ActiveX control (Nsfile.ocx) is designed to monitor a specific IP address so that it can receive files transferred over a network. For more information, see Configuring Nsfile.ocx to receive a multicast file transfer.


Adding a file transfer stream to a program

Adding a file transfer stream to a program broadcasts a specified file, or files, to clients listening on the network. When adding a file transfer stream, you can:

  • Transfer all files in a directory.
  • Transfer a directory and all of its subdirectories and their files.
  • Use wildcard characters to specify groups of files.
  • Specify a file to be transferred by its URL.
  • Specify a destination directory on the client by name or by environment variable.
  • Rename a file when it is transferred.
  • Transfer files with an appropriate URL to the cache in Microsoft Internet Explorer.


Using the file transfer Advanced tab

When creating a new file transfer program or editing an existing one, use the Advanced tab on the File Transfer page to set the following options:

  • In the Multicast Adapter Address box, select the address of the network adapter to use for multicasting on your server. If your server has only one adapter, do not change the default selection. On computers with multiple adapters, use this option to multicast separate programs simultaneously by entering a different adapter address for each program.
  • In the Maximum Bandwidth box, enter the maximum amount of bandwidth to be used to multicast the file.

    When multicasting to clients that are connected to the network via modem, entering values ranging from 10 kilobits per second (Kbps) to 20 Kbps are recommended.

    When multicasting to clients on a typical Ethernet local area network, entering values of less than 1,000 Kbps is recommended.

  • In the Redundancy box, set the amount of error correction to be used when broadcasting the program.

    The value that you type in the Redundancy box is rounded up to the next percentage. The setting for redundancy can range from 0.4 percent through 100 percent.

    While higher percentages of error correction help to ensure that the client receives the file correctly, they also increase the time it takes to send the file. For example, 100 percent redundancy doubles the time it takes to send a file.

  • In the Duration box, type the length of time for which the stream is to run. Use the format hh:mm:ss, where hh represents hours, mm represents minutes, and ss represents seconds
  • In the Logging box, create a log of the multicast file transfer. Type the path and file name for the log file in the File Path box. When the file transfer occurs, a log file containing a list of the files transferred and the destination information for each file is created.
  • Click Fully Reliable to enable fully reliable file transfer.

    Fully reliable file transfer allows clients to request the server to resend data that they failed to receive. After receiving a resend request, the server multicasts the requested data to all clients. Using fully reliable file transfer can increase the network bandwidth used by the system.


Configuring Nsfile.ocx to receive a multicast file transfer

Nsfile.ocx is a file transfer ActiveX control that allows broadcast files to be received over networks. The standard way to use this control is to embed it in a Web page and place that page on a Web server. A user downloads the Web page that contains the embedded control to receive the multicast file transfer.

Setting the properties of the control so that it can receive files is not within the scope of this documentation. The Windows Media Technologies Software Development Kit (SDK) provides samples that show how to program the control in HTML and Microsoft Visual Basic, Scripting Edition (VBScript). Nsfile.ocx and the Windows Media Technologies SDK can be downloaded from the Windows Media Technologies page at the Microsoft Web site.


Managing station connections

MSBD connections made by Windows Media server components, Windows Media Encoder, and Microsoft Windows Media Player to a station can be monitored using the Station Connections page in Windows Media Administrator. This page displays all connections to the server, including recent connect and disconnect events. These connections count against the station distribution limit.

Station connections do not include clients that connect to on-demand or broadcast unicast publishing points. Also, a station connection does not refer to clients that receive an ASF stream via multicast.

You also can specify a period of time before the list of station connections is refreshed, clear the list of recent connect and disconnect events, and terminate MSBD connections to the Windows Media server.

Refresh the station connections list

By default, the Station Connections list is refreshed every 30 seconds. You can edit the time interval at which the list is refreshed by entering a new value in the seconds box for Auto-refresh. To refresh the list of clients manually, disable Auto-refresh and then click Refresh.

Clear the list of connect/disconnect events

You can clear all entries from the list showing recent connect and disconnect events. Clear the list of events when the existing list is outdated or too long.

Terminate MSBD connections to a station

Because other servers or clients that connect to a station count against the distribution limit of that station, you sometimes must terminate those connections.

To terminate a single connection, on the Station Connections page, select the connection you want to terminate, and click Terminate selection. To terminate all connections, click Select All, and then click Terminate selection.


Managing station streams

The ASF streams that a station uses as its source can be monitored using the Station Streams page in Windows Media Administrator. You also can use this page to terminate the ASF stream connection. To view the ASF streams that stations are using, click Station Streams in the Windows Media Administrator menu frame. The Station Streams page appears and automatically displays the active stations and the streams that are being delivered.

The Station Streams page provides the following information about the station streams.

Column label | Description
Stream ID | A unique number that identifies the ASF stream.
Station | The name of the station.
State | The four states of the station: Open, Closed, Streaming, and Restarting.
Stream Source | The URL that the station uses to receive the stream source.

Terminating station streams

Close a station connection to an ASF stream by clicking the station in the list, and then clicking Terminate Selection.

Refreshing the list of station streams

The Station Streams list is refreshed every 30 seconds by default. You can change the refresh interval by entering a new value in Auto-refresh. To refresh the list of station streams manually, disable Auto-refresh, and then click Refresh.


Troubleshooting stations

Some common problems that can occur while creating or using stations are listed in the following table.

Problem | Possible solution
You do not know what to type in a box on the New Stations page. Use wizard to create new station was not selected when you started creating a new station. If you use Station QuickStart wizard, many of the station properties are set for you, and the properties that you must set are described in detail.

For more information about station properties, see Editing station properties.
You have created a station that references a live stream from Windows Media Encoder, but the stream does not start. Verify that Windows Media Encoder still is encoding.

Verify that the station is using the correct stream reference (.asd file). The station must reference the same .asd file that the encoder is using.

No streams appear in the list of streams after you have finished creating a station, program, and stream. | Click the program that you created. The stream should appear.
Clients cannot access a multicast stream. Clients cannot access the .asx file. You must provide the .asx file to users either in an e-mail message, embedded in the document, or in a directory.

Clients cannot access the .nsc file. You must store the .nsc file on an HTTP server or a shared directory. If the HTTP server is not running or the directory where the .nsc file is located is not shared to all, then the client cannot access the .nsc file and receive the multicast.

Stream format information is missing from the multicast station definition. For more information, see Adding stream format information.

Network routers are not multicast-enabled. Routers must be multicast-enabled for the stream to pass from subnet to subnet.

A firewall separates the client from the server. Firewalls must be configured to allow multicast streaming.

The time-to-live (TTL) value is not set high enough to allow the stream to travel to the client.
The station audio or video is distorted or missing. | To verify that it is not a problem with the station, use Microsoft Windows Media Player to connect directly to Windows Media Encoder to test the stream. You should see or hear the same problems.


Windows Media event monitors

Event monitors are used to display overall system activity, including client connections, server status and limits, and administrative functions.


How to. . .

This section lists the procedures that are most commonly performed while using Windows Media Unicast Event Monitor and Windows Media Station Event Monitor. Use the procedures to quickly accomplish a task. This procedure list precedes the overview information that explains Windows Media event monitors in more detail. If you want to learn more about Windows Media event monitors, continue past the procedures and read the overview information.


To start Windows Media Unicast Event Monitor

  • In the Windows Media Administrator menu frame, click Publishing Point Events.


To filter unicast event messages

  1. In the Windows Media Administrator menu frame, click Publishing Point Events.

    The Publishing Point Events page appears.

  2. On the Publishing Point Events page, click Properties.

    The Properties dialog box appears. By default, all Filter Events are selected so that all events are displayed.

  3. Clear the Filter Events check boxes for the types of event messages you do not want to receive.


To limit unicast event messages that are displayed

  1. In the Windows Media Administrator menu frame, click Publishing Point Events.

  2. On the Publishing Point Events page, click Properties.
  3. In the Properties dialog box, enter the number of unicast event messages that you want to remain available for display in the Set maximum buffer size box.


To control scrolling of unicast event messages

  1. In the Windows Media Administrator menu frame, click Publishing Point Events.

    The Publishing Point Events page appears.

  2. To stop the scrolling of events in the display, on the Publishing Point Events page, click Pause; to restart scrolling, click Resume Trace.


To clear unicast event messages from the display

  1. In the Windows Media Administrator menu frame, click Publishing Point Events.

    The Publishing Point Events page appears.

  2. On the Publishing Point Events page, click Clear.

    All event messages are removed from the event monitor display.


To open a new Windows Media Unicast Event Monitor window

  1. In the Windows Media Administrator menu frame, click Publishing Point Events.

    The Publishing Point Events page appears.

  2. On the Publishing Point Events page, click New Window.

    You can move and resize this window.


To start Windows Media Station Event Monitor

  • In the Windows Media Administrator menu frame, click Station Events.


To filter station event messages

  1. In the Windows Media Administrator menu frame, click Station Events.

    The Station Events page appears.

  2. On the Station Events page, under Configure Monitor Options, select the type of events that you want to monitor.


To set station event message colors

  1. In the Windows Media Administrator menu frame, click Station Events.

    The Station Events page appears.

  2. On the Station Events page, under Configure Monitor Options, click the event message type for which you want to set a color.
  3. In the Color dialog box, click the color you want to use.


To control scrolling of station event messages

  1. In the Windows Media Administrator menu frame, click Station Events.

    The Station Events page appears.

  2. To stop the scrolling of events in the display, on the Station Events page, click Pause Scrolling; to restart scrolling, click Scroll.


To clear station event messages from the display

  1. In the Windows Media Administrator menu frame, click Station Events.

    The Station Events page appears.

  2. On the Station Events page, click Clear All.

    All messages are removed from the window.


To open a new Windows Media Station Event Monitor window

  1. In the Windows Media Administrator menu frame, click Station Events.

    The Station Events page appears.

  2. On the Station Events page, click New Window.

    You can move and resize this window.


Monitoring Windows Media unicast events

Windows Media Unicast Event Monitor in Windows Media Administrator is used to display event activities for a publishing point. To monitor Windows Media server unicast events, you must be a member of the NetShow Administrators group on the server that you want to monitor.


Managing the Windows Media unicast event display

Windows Media Unicast Event Monitor receives Administrator, Alert, Client, and Server events for on-demand and broadcast publishing points. You can choose which of these event types you want to monitor and the number of event messages to be displayed. By default, all four event types are monitored and 200 event messages are displayed. The display buffers event messages up to the number shown in the Set maximum buffer size box, entering each event as it occurs at the top of the display. After the buffer limit is reached, event entries are deleted from the bottom of the display as new ones are entered at the top.

If a Windows Media server is busy, events sometimes are displayed too rapidly to be read. You can pause and restart the scrolling of messages in the display window. Events continue to be recorded while scrolling is stopped. You also can clear old messages from the display window.

You can monitor unicast events on the server while using another Windows Media Services function. You can open a new monitor window that remains open while you perform other Windows Media Services tasks.

Note

  • If the Windows Media server CPU load is near capacity, monitoring a large number of events can cause Windows Media Unicast Event Monitor to backlog events, and can cause virtual memory problems. To alleviate this, you can filter unwanted events. However, the long-term solution is to improve the performance of the server processor so that it can process other tasks while it monitors your unicast events.


Windows Media unicast event messages overview

Windows Media Unicast Event Monitor in Windows Media Administrator monitors and displays messages for Administrator, Alert, Client, and Server events. The date and time of each event is displayed with the message.


Administrator events

Event | Message
OnAdminBandWidthLimit | Administrator set the maximum bandwidth or the maximum bandwidth for publishing point alias to rate in (kilobits per second) Kbps. Reported when you change the maximum aggregate bandwidth for the server or for a publishing point.
OnAdminClientLimit | Administrator set the maximum clients or the maximum clients for publishing point alias to number of clients. Reported when you change the client limit for the server or for a publishing point.
OnAdminFileBitRateLimit | Administrator set the maximum file bit rate to rate in Kbps. Reported when you change the maximum bit rate for a single file.
OnAdminKillClient | Administrator has terminated client client ID. Reported when you terminate a client connection to the publishing point.


Alert events

Event | Message
OnMaxBandwidth | Maximum bandwidth exceeded. Current limit rate in (kilobits per second) Kbps.
OnMaxClients | Maximum allowed clients exceeded or maximum allowed clients for publishing point alias exceeded. Current limit: number of clients. Shows the current setting for the maximum number of clients for the server or for a publishing point, whichever limit was exceeded.
OnMaxFileBitRate | An attempt has been made to play a file that exceeds the maximum bit rate. The current maximum is rate in Kbps.


Client events

The client ID is a number assigned to the client by Windows Media server components.

Event | Message
OnClientConnect | Client client ID connected at IP Address address number and Port port number.
OnClientDisconnect | Client client ID disconnected from IP Address address number and Port port number.
OnClientPlay | Client client ID playing title: file name and path.
OnClientStop | Client client ID stopped playing title: file name and path.
OnClientStride | Client client ID seeking in file: file name and path. The client is seeking a location in an indexed .asf file using either fast forward or rewind.


Server events

Event | Message
OnServerFault | Triggered when a fatal problem has occurred with the Windows Media Unicast service. NSTrace and NSLog need to look up the description for the error.
OnServerOffline | The server is offline. Indicates that the Windows Media Unicast service has stopped.
OnServerOnline | The server is online. Reported after restarting the Windows Media Unicast service. For example, after you apply an authentication package, you must restart the Windows Media Unicast service to enable the changes.


Monitoring Windows Media station events

Windows Media Station Event Monitor in Windows Media Administrator is used to display Windows Media server station events. To monitor station events, you must be a member of the NetShow Administrators group on the server that you want to monitor.


Managing the Windows Media station event display

Windows Media Station Events Monitor receives messages for Client, Stream, and Station events. By default, all message types are selected. You can select which types of messages you want to display. To easily distinguish between message types in the display, you can select a different color for each message type.

If a Windows Media server is busy, events sometimes appear too rapidly to be read. You can pause and restart message scrolling in the display window. Events continue to be recorded while scrolling is stopped. You also can clear old messages from the display window.

You might want to monitor unicast events on the server while using another Windows Media Services function. You can open a new monitor window that remains open while you perform other Windows Media Services tasks.


Windows Media station event messages overview

The following table shows the messages that are displayed when you are monitoring Windows Media server station events. The monitoring tool displays events as text messages. The date and time of each event is displayed with the message.

Event type | Message
Station | New station added. Station name is station name.
Station | Station has been deleted. The station name was station name and the description was station description.
Station | Station property changed. Station name is station name.
Stream | Stream from source stream alias or stream URL on station station name activated.
Stream | Stream from source stream alias or stream URL on station station name deactivated.
Stream | New stream opened. Stream source is stream alias or stream URL.
Stream | Stream closed. The stream source was stream alias or stream URL and the description was stream description.
Stream | Stream has started. Stream source is stream alias or stream URL.
Stream | Stream has stopped. Stream source is stream alias or stream URL.
Stream | Stream property changed. Stream source is stream alias or stream URL.
Stream | Stream archive closed.
Client | Client connected. The client address/port is IP Address/Port.
Client | Client disconnected. The client address/port is IP Address/Port.


Windows Media performance counters

Performance counters for Windows Media server components can be viewed in Windows Media Performance Monitor.

Windows Media Performance Monitor is installed when you install Windows Media component services. It uses the wmtperf.msc file, which contains a customized set of performance counters that are specific to Windows Media server components.


How to. . .

This section lists the procedures that are most commonly performed while monitoring performance counters for the Windows Media Unicast service and the Windows Media Station service. Use the procedures to quickly accomplish a task. This procedure list precedes the overview information that explains the performance counters in more detail. If you want to learn more about performance counters for Windows Media component services, continue past the procedures and read the overview information.


To start Windows Media Performance Monitor

  • Click Start, point to Programs, point to Administrative Tools, and then click Windows Media Performance.

    The Performance Monitor window appears, displaying the wmtperf.msc file settings, which include Windows Media Unicast service and Windows Media Station service performance counters.


Windows Media Unicast service performance counters

The following links describe the Windows Media Unicast service performance counters. The first link points to a table that lists the counters that are enabled in the performance monitor by default; the second link points to table that lists additional counters that you can add to the display in the performance monitor.

  • Default performance counters overview
  • Optional performance counters overview


Default performance counters overview

Performance counter | Description
Active Live Unicast Streams | Number of live unicast streams that are being streamed.
Active Streams | Number of active files or streams being sent to clients. Provides an overall indicator of system activity. Note that a client is connected even if it has stopped playing a file because the Windows Media Unicast service maintains the bandwidth allocation to that client for 60 seconds after the client stops playing (this is called the Client Inactivity Time-out period). When the Client Inactivity Time-out period expires, the server actively checks the status of each client by periodically sending a message to each client. The server keeps a client connection open as long as the client responds to a message within three minutes (this is called the Client Terminal Time-out period ).
Active TCP Streams | Number of TCP streams currently being sent to clients.
Active UDP Streams | Number of UDP streams currently being sent to clients.
Aggregate Read Rate | Sum of the read rates for all files being sent to clients, in bits per second (bps). Indicates the speed at which the server is reading data from the disk. The graph usually appears jagged because the block read time is shorter than the block sends.
Aggregate Send Rate | Sum of the send rates for all files being sent to clients, in bits per second (bps). Indicates the speed at which the server is sending data to the clients. The graph should appear relatively smooth; a jagged graph can indicate that streams are competing for bandwidth.
Connected Clients | Number of clients currently connected. Indicates all Microsoft Windows Media Player connections to the system. This includes clients streaming, clients in paused and connected states, and clients that the server has not yet detected as being disconnected. The latter condition can occur if a client has lost power or has been disconnected from the network and has not been able to notify the server of termination. After the Client Inactivity Time-out period has elapsed (60 seconds), the Windows Media Unicast service actively checks the status of each client by periodically sending a message to each. Clients must reply to the message within three minutes in order to maintain their connection to the server (this is called the Client Terminal Time-out period).
Connection Rate | Rate at which clients are connecting to the server. This is used to gate the number of instantaneous connections being serviced by the server. The default is 25 connections per second. This counter is useful for correlating client connections with use of system resources.
HTTP Streams | Number of active HTTP streams currently being sent to clients.
Late Reads | Number of late read completions per second. A late read is a disk read operation that takes significantly longer than expected to be completed. Typically, this counter is not equal to zero when the server is under a very heavy load. If this counter is often not equal to zero, the system may not be properly configured, or other applications are competing with Windows Media server components for use of the disk.
Pending Connections | Number of clients attempting to connect to the server that are not yet connected. This number can be high if the server is running near maximum capacity and cannot process a large number of connection requests in a timely manner.
Stream Errors | Number of errors occurring per second. Stream errors represent the number of stream data packets discarded by the server. They are introduced by the server when it cannot keep up with the demand for data and must throw some packets away to avoid running behind schedule indefinitely. Stream errors show up most often after late reads occur. They indicate that the system is not configured properly or that other applications are competing for system resources. Heavy network traffic can also contribute to stream errors.


Optional performance counters overview

Performance counter | Description
Allocated Bandwidth | Amount of bandwidth that the server allocates, based on the number of current Microsoft Windows Media Player connections. Generally, clients connected to a Windows Media server that are not receiving streams still are allocated bandwidth. If Windows Media Player has allocated bandwidth but does not send a command during the Client Inactivity Time-out period (60 seconds), its bandwidth is de-allocated.
Authentication Requests | Number of times an authentication plug-in is called to authenticate a client. Depending on the protocol in use, either HTTP or MMS, a single client can be authenticated once or several times when accessing each piece of unicast content. This is a general indicator of how often authentication plug-ins are used.
Authentications Denied | Number of times clients are denied access to unicast content by authentication plug-ins. Clients are denied access by an authentication plug-in when their IDs cannot be verified, no user accounts exist, or the authentication plug-in is not working.
Authorization Requests | Number of times an authorization plug-in is called to authorize a client. Each client action, such as opening or playing unicast content, is separately authorized; therefore, the total number of authorization requests is greater than the number of connected clients. This is a general indicator of how often authorization plug-ins are used.
Authorizations Refused | Number of times clients are denied access to unicast content by authorization plug-ins. Plug-ins will deny access to clients based on their function; for example, a billing plug-in can deny client access to unicast content if the user account contains insufficient funds.
HTTP Streams Reading Header | Number of clients connected to the server via HTTP and reading a file header, but not yet streaming the unicast content. The sum of HTTP Streams Reading Header and HTTP Streams Reading Body is the total number of clients connected to the server via HTTP, as indicated by HTTP Streams.
HTTP Streams Reading Body | Number of connected clients that have read the file header and are actively streaming unicast content via HTTP. The sum of HTTP Streams Reading Body and HTTP Streams Reading Header is the total number of clients connected to the server via HTTP, as indicated by HTTP Streams.
Plug-in Errors | Number of times the plug-ins fail to perform their function. For example, a plug-in cannot reach its user database, the plug-in crashes, and so on.
Plug-in Events | Number of events reported to plug-ins. This is an indicator of how much the server is using external plug-ins.
Scheduling Rate | Rate at which requests are being made for tasks to be scheduled, in tasks per second. Scheduled tasks include reading data from the disk and writing data to the network. The scheduling rate is roughly proportional to the rate at which packets are being sent by the server (this rate does not represent a one-to-one correspondence).
Stream Terminations | Rate at which streams are terminated due to errors. Stream terminations indicate that the system is not configured properly, or that the file being streamed is corrupted. The server unilaterally terminates a stream under certain circumstances—most commonly when the server is running significantly behind schedule. If the server must throw away several packets in a row from a given stream to remain on schedule, it terminates the stream. Streams also can be terminated if invalid data is encountered during file streaming.
UDP Resend Requests | Number of times clients request that the Windows Media server resend data packets that were not received. This value can be high when the server cannot send packets via UDP reliably. This is a good indicator of server or network overload.
UDP Resends Sent | Number of UDP Resend Requests processed by the Windows Media server. Not all UDP Resend Requests are processed if the server is under a heavy load.


Windows Media Station service performance counters

The following table describes the Windows Media Station service performance counters. All of these counters appear in Windows Media Performance Monitor by default.

Performance counter | Description
Stations | Number of station objects that currently exist in the server.
Controllers | Number of controllers currently connected to the server.
Streams | Number of stream objects that currently exist in the server.


Information logs

Windows Media server components stores information about the clients that view ASF streams in information logs. This information can be used to determine which .asf file is watched most often, how long a client receives an ASF stream, the IP address of the client receiving an ASF stream, the Internet service provider (ISP) a client is using, and so on.

Clients that view unicast ASF streams are connected to the Windows Media server. Windows Media Services is installed ready to log unicast client information. For more information, see Logging unicast client information.

Clients that view multicast ASF streams are not connected to the Windows Media server. However, information logs can be generated on clients that receive a multicast ASF stream. The Windows Media server must be configured before a multicast client information log can be generated. For more information, see Logging multicast client information.

Client information is not entered into a log file if the client uses the MSBD protocol to connect to a unicast publishing point or multicast station.


How to. . .

This section lists the procedures that are most commonly performed while logging unicast and multicast client information. Use the procedures to quickly accomplish a task. This procedure list precedes the overview information that explains logging in more detail. If you want to learn more about logging, continue past the procedures and read the overview information.


To log unicast client information

  1. In the Windows Media Administrator menu frame, click Server Properties.

    The Server Properties page appears.

  2. On the Server Properties page, click the Publishing Point Logging tab.
  3. To enable logging, select the Enable logging check box.
  4. Under Period, select an interval (Daily, Weekly, or Monthly) or a maximum size for the log file.
  5. In the Log file directory box, enter the location where the log file will be stored.
  6. Click Apply to begin logging unicast client information.

Note

  • A unicast client information log file name has the format NetShow.yymmddiii.log, where yy is the year, mm is the month, and dd is the day. The iii extension specifies the version of the file if more than one log file is generated in a calendar day.


To log multicast client information

  1. Verify that the directory containing the Windows Media Internet Server Application Programming Interface (ISAPI) extension (Nsiislog.dll) is shared as a Web directory. Network clients must be able to access this file.
  2. In the Windows Media Administrator menu frame, click Multicast Stations.

    The Multicast Stations page appears.

  3. Under Stations, click the station for which you want to create the logging file, then click Stations, and then click Properties.

    The Edit Station page appears.

  4. On the Edit Station page, in Logging URL, type the URL to Nsiislog.dll and then click OK.

    For example, type http://server_name/scripts/Nsiislog.dll, where server_name is the name of the Microsoft Internet Information Services (IIS) computer. You are not required to have Nsiislog.dll on the same computer as the Windows Media server; however, Nsiislog.dll must be installed in a directory that is Web-accessible.

  5. When you are prompted, save the changes to the .nsc file.

Notes

  • This procedure assumes that you have installed Windows Media server components on a computer on which IIS already is installed. For more information, see Logging multicast client information.
  • A multicast client information log file name has the format NetShow.yymmddiiii.log, where yy is the year, mm is the month, and dd is the day. The iiii extension specifies the version of the file if more than one file is generated in a calendar day.


Logging unicast client information

Windows Media Administrator can log information on activities generated by clients that connect to your unicast publishing points. The unicast client information log file is a text file that contains fields delimited by a space. If you do not have an application designed to read log files, you can open the log file with Microsoft Notepad. If you want to arrange the information in rows and columns, you can also open the file in Microsoft Excel. For a description of the content that is stored in a log file, see Windows Media log file reference.

The unicast client information log file stores entries over a period of time that you select, or until it reaches a size that you specify. It is stored in a location that you choose on the Windows Media server being administered. For more information about setting the following options, see To log unicast client information.

Option | Description
Enable logging | This option starts or stops logging. By default, Enable logging is disabled.
Period | This option generates new logs using the specified frequency. The service closes the log file and creates a new one with a different name in the same folder when the appropriate interval or file size is reached. For the Daily, Weekly, or Monthly options, the log file is closed the first time a log record is generated after midnight on the last day of the current log file. The log file name is NetShow.yymmddiii.log, where yymmdd is the year, month, and day when the log file is created and iii is a number that starts at 000 and increases by one for every log generated on the current date. If you prefer to generate log files by size, select When file size reaches and enter a value between 8 kilobytes (KB) and 1,000,000 KB inclusive. A new log file is generated each time the service starts, regardless of this setting.
Log file directory | This option specifies the server directory containing the log file. By default, the directory used is SystemRoot\system32\logfiles.

Notes

  • If you are using a remote administrator computer, the path referenced in the Log file directory dialog box is the path on the server computer, not the administrator computer.
  • Client information is not entered into the log file if the client uses the MSBD protocol to connect to a unicast publishing point.


Logging multicast client information

Logging multicast client information lets you view information about the client that is receiving the ASF stream and the client connection. Use the Windows Media Internet Server Application Programming Interface (ISAPI) extension (Nsiislog.dll) for logging multicast client information. If Windows Media server components are installed on a computer where Internet Information Services (IIS) is already installed, Nsiislog.dll is installed in both the SystemDrive\SystemRoot\system32\Windows Media\Server directory and the SystemDrive\Inetpub\scripts directory. If IIS is not installed on the server computer, then Nsiislog.dll is installed in the SystemDrive\SystemRoot\system32\Windows Media\Server directory only. For information on how to add logging to a station, see To log multicast client information.

You also can write a Common Gateway Interface (CGI) script to generate a log.

When logging is enabled on a station, a log file is saved to SystemRoot\system32\logfiles. The log file name is NetShow.yymmddiiii.log, where yymmdd is the year, month, and day when the log file is created and iiii is a number that starts at 0000 and increases by one for every log generated on the current date.

The log file is a text file that contains fields delimited by a space. If you do not have an application designed to read log files, you can open the log file with Microsoft Notepad. If you want to arrange the information in rows and columns, you can also open the file in Microsoft Excel. For a description of the content that is stored in a log file, see Windows Media log file reference.

Note

  • Client information is not entered into the log file if the client uses the MSBD protocol to connect to the multicast station.


Analyzing Windows Media log files

The user experience is defined as all actions a user performs on the client while viewing a stream. If the client is connected to an on-demand unicast publishing point, a single user experience can include multiple entries in the unicast client information log file. For example, if a user plays an .asf file for one minute, rewinds it, plays the .asf file again for 10 seconds, fast-forwards it, and then plays the rest of the file, those actions (play, rewind, play, fast-forward, play, and stop) generate five entries in a unicast client information log file. If other clients are connected to the Windows Media server and other client activities are being logged, the entries for one user experience might not appear together in the log.

If the client is connected to a broadcast unicast publishing point or to a multicast station, the user experience recorded in the unicast client information log file or the multicast client information log file contains just one entry because the user cannot fast-forward, rewind, or pause a live stream; the user can only stop a live stream. The log file entry is generated when the user stops the client that is streaming the live content.

A client does not physically connect to the Windows Media server to stream a multicast; therefore, entries in a multicast client information log are blank for fields that store information about the client-server connection. For more information, see Scenario 3: the user experience for a multicast.

Notes

  • The log file is a space-delimited text file that you can import into a Microsoft Excel spreadsheet. Then you can sort the log file entries in the Excel spreadsheet by field types. For more information, see Finding the user experience in a Windows Media log file.
  • Additional Windows Media Technologies software, including log analysis tools, is available from third parties. For more information, see the Windows Media Technologies page at the Microsoft Web site.


Finding the user experience in a Windows Media log file

To view a user experience in a Windows Media log file, you can rearrange the rows based on the fields c-dns or c-playerid (user) and cs-uri-stem (stream) in Microsoft Excel. The c-dns field identifies the client computer according to the domain name system (DNS) and can be useful in identifying a user; however, it is possible for a user to stream content using more than one client on the client computer. The c-playerid field is unique; therefore, entries with the same c-playerid were generated by the same client. The field cs-uri-stem contains information about the content that was streamed: an .asf file for an on-demand unicast, a unicast URL for a broadcast unicast, or an .asx file for a multicast. A log file arranged in this manner shows the user experience: a list of users or clients, the content that was streamed, and the sequence of events each client took to stream the content. For more information, see Understanding the user experience in a Windows Media log file.

Note

  • Before sorting the log file, remove the #Fields: heading in the Excel spreadsheet by selecting the cell and, on the Edit menu, using the Delete command with the Shift cells left option. This matches the field headings with their values.


Understanding the user experience in a Windows Media log file

Three fields in a Windows Media client information log file show the sequence of events that each client performed to view a stream: c-starttime, x-duration, and c-rate.

For an on-demand .asf file, the value for c-starttime is the timestamp (in seconds) of the on-demand .asf file when an action (stop, pause, fast-forward or rewind) was performed on the client. For a broadcast unicast or multicast stream, c-starttime is always zero.

The value for x-duration is the time (in seconds) that the client viewed the stream. Clients are considered to be viewing the stream even while fast-forwarding or rewinding the stream; therefore, the time (in seconds) that is skipped when a client fast-forwards or rewinds through an indexed .asf file is logged for x-duration.

The value for c-rate is a code for the client event that generates a log file entry. When a user views a broadcast unicast or multicast stream, c-rate is always 1 because the client cannot pause, fast-forward, or rewind a live stream; it can only stop the stream. When a user views an on-demand unicast stream, c-rate can take on several values:

C-rate | Definition
1 | The user viewed the stream for x-duration.
-5 | The user viewed the stream for x-duration while rewinding.
5 | The user viewed the stream for x-duration while fast-forwarding.

When two consecutive entries for a user experience in a unicast client information log contain c-rate equal to 1, the user viewed the content for a length of time equal to the value of x-duration in the first entry before either stopping or pausing the client. The action performed can be determined from the second entry:

  • If c-starttime in the second entry is zero, then the user stopped the client.
  • If c-starttime in the second entry is the sum of c-starttime and x-duration in the first entry, then the user paused the client.

If the last entry for a user experience in a unicast client information log contains c-rate equal to 1, then the user viewed the content for a length of time equal to the value of x-duration for that entry before either stopping or closing the client.

Note

  • When two consecutive entries for a user experience in a unicast client information log contain c-rate equal to 1, but c-starttime in the second entry is either greater than or less than the sum of c-starttime and x-duration in the first entry, then the user used the Seek bar on the client to fast-forward or rewind the on-demand unicast stream. Using the Seek bar to fast-forward or rewind an on-demand unicast stream does not generate fast-forward or rewind information in the unicast client information log.


Scenario 1: the user experience for an on-demand unicast

Jim connects to a Windows Media server, begins streaming a 60-second .asf file (an .asf file with a filelength value of 60), and performs the following activities on the client:

  • Pauses the .asf file after it streams for ten seconds.
  • Presses Play.
  • Presses REW when the .asf file reaches 40 seconds and rewinds the .asf file back to 20 seconds.
  • Presses FF when the .asf file reaches 30 seconds and fast-forwards up to 40 seconds.
  • Allows the stream to play until it stops at one minute (60 seconds).

A portion of the unicast client log file entries for this user experience is shown in the following table.

c-starttime | x-duration | c-rate | Description
0 | 10 | 1 | Jim plays the .asf file for 10 seconds and then pauses the stream.
10 | 30 | 1 | Jim plays the .asf file for 30 seconds.
40 | 20 | -5 | Jim rewinds the .asf file from 40 seconds to 20 seconds, using the REW button on the client.
20 | 10 | 1 | Jim plays the .asf file for 10 seconds.
30 | 10 | 5 | Jim fast-forwards the .asf file from 30 seconds to 40 seconds, using the FF button on the client.
40 | 20 | 1 | Jim plays the remainder of the .asf file. The client stops streaming at the end of the .asf file.

Jim streamed the entire file (60 seconds) and reviewed the file between the 20- and 30-second timestamps (10 seconds); therefore, Jim viewed the .asf file in normal playback mode for 70 seconds. If you want to consider rewind and fast-forward as part of the viewing experience, you can also add the x-duration value while Jim rewound the file (20 seconds) and the x-duration value while Jim fast-forwarded the file (10 seconds). This brings the total viewing time (the sum of all values for x-duration) to 100 seconds for this user experience. If you do not want to consider rewind or fast-forward as part of the viewing experience, you can ignore all log entries where c-rate contains values of -5 (rewind) or 5 (fast-forward).


Scenario 2: the user experience for a broadcast unicast

Maria connects to a Windows Media server, opens a link to a live multicast stream via unicast (broadcast unicast), and streams it on Microsoft Windows Media Player for five minutes. A portion of the unicast client log file entry for this user experience is shown in the following table.

time | c-starttime | x-duration | c-rate | Description
18:10:57 | 0 | 300 | 1 | Maria connects to a live multicast stream via unicast (broadcast unicast) and plays it for five minutes, then presses Stop on the client.

An entry appears in a unicast client information log file when Maria clicks Stop on the client or closes the client. The actual time that Maria connected to the broadcast unicast can be determined by subtracting the value in x-duration from the value in time in the unicast client information log file.

Maria connected to a broadcast unicast publishing point on the Windows Media server to stream the live multicast; therefore, the fields in the unicast client information log that store information about the client/server connection are filled. For more information, see Scenario 3: the user experience for a multicast.


Scenario 3: the user experience for a multicast

Marsha connects to a Windows Media server, opens a link to a multicast stream, and streams it on Microsoft Windows Media Player for three minutes. A portion of the multicast client log file entry for this user experience is shown in the following table.

time | c-starttime | x-duration | c-rate | Description
21:10:00 | 0 | 180 | 1 | Marsha connects to a live multicast stream at 9:07 P.M. Greenwich mean time and plays it for three minutes, then presses Stop on the client.

An entry appears in a multicast client information log file when Marsha clicks Stop on the client or closes the client. The actual time that Marsha connected to the multicast can be determined by subtracting the value in x-duration from the value in time in the multicast client information log file.

The client does not physically connect to the Windows Media server to stream a multicast; therefore, entries in a multicast client information log are blank for the following fields, which store information about the client-server connection:

  • s-cpu-util
  • s-dns
  • s-ip
  • s-pkts-sent
  • s-totalclients
  • sc-bytes

For more information, see Windows Media log file reference.


Understanding lost packets

Packet loss can occur in a stream from server to client because of network congestion, router problems, and so on. Packets are also considered lost by the client if they arrive too late to be played on time. The following diagram shows how packets that are sent by a Windows Media server can arrive at the client. The Windows Media client information log file fields that appear in the diagram are described below the diagram.

You can use a Windows Media client information log file to determine if any packets were lost, where the loss occurred, and if any packets were recovered. The following log file fields show how many packets were lost, where they were lost, and if an attempt was made to recover the lost packets:

s-pkts-sent | Packets sent by a Windows Media server to a connected client. In a multicast client information log file, this field contains no value because a client does not connect to the server to view a multicast stream.
c-pkts-received | Packets (s-pkts-sent) that are received by the client correctly on the first try. Packets that are not received correctly on the first try can be recovered if they are resent via UDP. UDP resend is available if the MMS protocol is used to stream your content. Packets that are not recovered via UDP resend are considered to be lost in the network and can be recovered if error correction is turned on for an .asf file or a multicast stream.
c-pkts-recovered-resent | Packets (s-pkts-sent) that are not received by the client correctly on the first try but are recovered because the client asked the Windows Media server to resend them via UDP.
c-pkts-lost-net | Packets that are not recovered using UDP resend. These packets are considered lost in the network. These packets can still be recovered if error correction is turned on for an .asf file or a multicast stream.
c-pkts-recovered-ECC | Packets lost in the network (c-pkts-lost-net) that were repaired and recovered at the client layer because error correction was used. Error correction is the only means of packet recovery for multicast streams.
c-pkts-lost-client | Packets lost that were not recovered at the client layer via error correction or at the network layer via UDP resends, during transmission from server to client. These packets are sent by the Windows Media server but never played by the client.
c-pkts-lost-cont-net | Maximum number of packets lost by the network in a row. If the value is high, the network conditions were bad, with long periods of time during which no packets were received at the client.

If neither of the recovery methods succeeds (error correction or UDP resend), then users have no chance to improve their viewing experience, that is, to recover lost packets.


Windows Media log file reference

The log files created when you enable unicast or multicast logging are text files that contain fields delimited by a space. The following table contains a list of each field, a description, and a sample value for each entry that can be found in a log file.

Field | Description | Sample value
audiocodec | Audio codec used in stream. | Voxware_MetaSound
avgbandwidth | Average bandwidth (in bits per second) at which the client was connected to the server. | 24300
c-buffercount | Number of times the client buffered while playing the stream. | 4
c-bytes | Number of bytes received by the client from the server. For a unicast, c-bytes and sc-bytes must be identical. If not, packet loss occurred. For more information, see Understanding lost packets. | 28583
c-cpu | Client computer CPU type. | Pentium
c-dns | Client computer DNS name. | tokyo2.dns.company.com
c-hostexe | Host application. For example, a Web page in a browser (iexplore.exe), a Microsoft Visual Basic applet (vb.exe), or stand-alone Microsoft Windows Media Player (mplayer2.exe). | iexplore.exe
c-hostexever | Host application version number. | 4.70.1215
c-ip | Client computer IP address. A client that is not connected properly provides a client proxy server IP address, not the client IP address. | 157.56.219.146
c-os | Client computer operating system. | Windows_NT
c-osversion | Client computer operating system version number. | 4.0.0.1381
c-pkts-lost-client | Number of packets lost during transmission from server to client and not recovered at the client layer via error correction or at the network layer via UDP resends. | 5
c-pkts-lost-cont-net | Maximum number of continuously lost packets on the network layer during transmission from server to client. | 2
c-pkts-lost-net | Number of packets lost on the network layer. Packets lost at the network layer can be recovered if the client recreates them via forward error correction. The difference between c-pkts-lost-net and c-pkts-lost-client is c-pkts-recovered-ECC. | 2
c-pkts-received | Number of packets from the server (s-pkts-sent) that are received correctly by the client on the first try. | 50
c-pkts-recovered-ECC | Number of packets repaired and recovered on the client layer. Packets repaired and recovered at the client layer are equal to the difference between c-pkts-lost-net and c-pkts-lost-client. | 3
c-pkts-recovered-resent | Number of packets recovered because they were resent via UDP. | 5
c-playerid | Globally unique identifier (GUID) of the player. | {c579d042-cecc-11d1-bb31-00a0c9603954}
c-playerlanguage | Client language-country code. | en-US
c-playerversion | Version number of the player. | 6.2.5.415
c-quality | The percentage of packets that were received by the client, indicating the quality of the stream. If cPacketsRendered is all packets received by the client, including packets recovered by error correction and UDP resend (c-pkts-received + c-pkts-recovered-ECC + c-pkts-recovered-resent), then c-quality can be calculated as: [cPacketsRendered / (cPacketsRendered + c-pkts-lost-client)] * 100. | 96
c-rate | Mode of Windows Media Player when the last command event was sent. 1 = Windows Media Player was paused or stopped during a play, fast-forward, rewind, or marker jump operation. -5 = Windows Media Player was rewound from a play, stop, or pause operation. 5 = Windows Media Player was fast-forwarded from a play, stop, or pause operation. | 1
c-resendreqs | Number of client requests to receive new packets. This field contains a value only if the client is using UDP resend. | 5
c-starttime | Timestamp (in seconds) of the stream when an entry is generated in the log file. | 0
c-status | Codes that describe client status. Mapped to HTTP/1.1 and RTSP client status codes described in Request for Comments (RFC) 2068 and RFC 2326. Windows Media Services includes the extensible client status codes 480 (simultaneous client connections exceeded the maximum client limit of the server) and 483 (stream exceeded maximum file bit rate limit of the server). | 200
c-totalbuffertime | Time (in seconds) the client used to buffer the stream. If the client buffers the stream more than once before a log entry is generated, c-totalbuffertime is the total amount of time the client spent buffering the stream. | 6
channelURL | URL to the .nsc file. A unicast client information log file records a “-“ for this field. | http://tampico/channel.nsc
cs(Referer) | URL to the Web page in which Windows Media Player was embedded (if it was embedded). | http://www.company.com
cs-uri-stem | Name of the file that is playing, an .asf file for a unicast and an .asx file for a multicast. | mms://zanzibar/sample.asf
cs(User-Agent) | Browser type used if Windows Media Player was embedded in a browser. | Mozilla/4.0_(compatible;_MSIE_4.01;_Windows_98)
date | Date (in Greenwich mean time) when an entry is generated in the log file. | 1999-04-19
filelength | Length of the file (in seconds). This value is 0 for a live stream. | 60
filesize | Size of the file (in bytes). This value is 0 for a live stream. | 86000
protocol | Protocol used to access the stream: mms, http, or asfm (multicast protocol). | mms
s-cpu-util | Average load on the server processor (0%-100%). If multiple processors exist, this value is the average for all processors. | 40
s-dns | Server DNS. | media.server.company.com
s-ip | Server IP address. | 224.24.41.189
s-pkts-sent | Packets sent by the server. | 55
s-totalclients | Clients connected to the server (but not necessarily receiving streams). | 20
sc-bytes | Bytes sent by the server to the client. | 30000
time | Time (in Greenwich mean time) when an entry is generated in the log file. | 15:30:30
transport | Transport protocol used to deliver the stream (UDP, TCP, or UDP over IP multicast). | UDP
videocodec | Video codec used to encode the stream. | Microsoft_MPEG-4_Video_Codec_V2
x-duration | Length of time a client played content prior to a client event (FF, REW, Pause, Stop, or jump to marker). A log entry is generated whenever one of these client events occurs. | 31


Windows Media administration and security

This section contains information about the administration and security features in Windows Media Services.


How to. . .

This section lists procedures that are commonly performed while administering and securing a Windows Media server. Use the procedures to quickly accomplish a task. This procedure list precedes the overview information that explains Windows Media Services administration and security in more detail. If you want to learn more about Windows Media administration and security, continue past the procedures and read the overview information.


To change the account or password used by Windows Media component services

  1. Open Control Panel.
  2. In Control Panel, double-click Administrative Tools, and then double-click Services.
  3. In Services, right-click the name of a Windows Media service (either the Monitor, Program, Station or Unicast service), and then click Properties.
  4. In Service Properties, click the Log On tab.

    Under Log On As, you can change the account used by the service as well as the password.

Note

  • Perform this procedure for all of the Windows Media component services (Windows Media Monitor service, Windows Media Program service, Windows Media Station service, and Windows Media Unicast service); otherwise, the server may not be able to deliver content to Microsoft Windows Media Player.


To apply an authentication package

  1. In the Windows Media Administrator menu frame, click Server Properties.

    The Configure Server - Server Properties page appears. The content on the General tab appears by default.

  2. Click the Publishing Point Security tab.
  3. Select an Authentication Package from the list.
  4. Click Apply.

    The Windows Media Administrator box opens, and prompts you to confirm that you want to apply the authentication package that you selected.

  5. Click Yes.

    The status of the authentication package you selected is Pending. You must restart the Windows Media Unicast service for this change to take effect. Before proceeding to the next step in this procedure, perform the steps in To restart the Windows Media Unicast service .

  6. Click Refresh.

    The content frame is refreshed. The Status of the authentication package you selected is Active.

Note

  • When an authentication package is Active, you can use access control list (ACL) checking by selecting the Enable Access Control List (ACL) checking check box. For more information, see Restricting access to ASF streams.


To restart the Windows Media Unicast service

  1. Open Control Panel, double-click Administrative Tools, and then double-click Services.
  2. In Services, select Windows Media Unicast Service. Its status is Started.
  3. Click Restart to stop and restart the service.


To set access permissions for on-demand publishing points and .asf files

  1. Activate an authentication package for the Windows Media Unicast service by following the steps in To apply an authentication package.
  2. Select the Enable Access Control List (ACL) checking check box.
  3. Find the publishing point directory or .asf file to which you want to restrict access on the server computer. Right-click the directory or file.

    A Properties page appears.

  4. Click the Security tab on the Properties page.

    The Permissions page for the directory or file opens. By default, everyone has full access to the publishing point directory or .asf file.

  5. Click Remove to remove the Everyone group from the Permissions list.
  6. On the Permissions page, click Add to add Windows Media Services to the Permissions list.
    • On the Add Users and Groups page, select the server computer in the List Names From box, and then click Show Users.
    • Click the Windows Media Services account name in the Names list, and then click Add. This account hosts the Windows Media Unicast, Station, Monitor, and Program services, and has Read access to the publishing point directory or file. The Windows Media Services account NetShowServices is created during installation of Windows Media Services. If you specified a different Windows Media Services account after installation, click that account name in the Names list.
  7. On the Permissions page, click Add to add the user or group of users to the Permissions list.
    • On the Add Users and Groups page, select the domain that hosts the user or group of users that you want to allow access to the directory of file, and then click Show Users.
    • Click the name of the user or group in the Names list, and then click Add. By default, the user or group has Read access to the publishing point directory or file.

Note

  • Access permissions are set for stored content on an NTFS file system partition by assigning an ACL for the .asf file or the physical directory where the file is stored. You can also set access permissions for on-demand content stored on a FAT partition by setting an ACL for the registry key associated with the on-demand unicast publishing point. You cannot use an ACL without enabling an authentication mechanism because unknown users cannot be authorized.


To set access permissions for broadcast unicast publishing points

  1. Start Registry Editor (Click Start, click Run, and then type regedt32).
  2. In Registry Editor, use the tree view to navigate through the following path:

    HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\nsunicast\Parameters\Virtual Roots.

    A virtual root exists for all publishing points, including on-demand publishing points.

  3. Select the virtual root whose permissions you want to set.
  4. On the Registry Editor Security menu, click Permissions.

    The Registry Key Permissions page opens.

  5. Create the permissions for the broadcast publishing point.

Notes

  • You can set permissions based on individual user, group, or domain. For more information on providing permissions, click Help in the Registry Key Permissions dialog box.
  • Your ability to make changes to the registry by using Registry Editor depends on your access permissions. Incorrectly editing the registry can severely damage your system. Before making changes to the registry, back up any valued data on the computer.


To add an IP address to an access list

  1. Start Registry Editor (Click Start, click Run, and then type regedit).
  2. In Registry Editor, use the tree view to navigate through the following path:

    HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\NetShow\AccessLists.

  3. To work with one of the access lists, click the appropriate registry key:
    • AllowDistribution
    • AllowUnicastClients
    • DisallowDistribution
    • DisallowUnicastClients
  4. On the Edit menu, point to New, and click String Value.
  5. Type the value of the IP address you want to add to the list in the Name column, and press Enter.

Notes

  • After you have added an IP address to an access list, you can add a mask to it to specify a range of IP addresses.
  • Your ability to make changes to the registry by using Registry Editor depends on your access permissions. Incorrectly editing the registry can severely damage your system. Before making changes to the registry, back up any valued data on the computer.


To specify a range of IP addresses in an access list

  1. Start Registry Editor (Click Start, click Run, and then type regedit).
  2. In Registry Editor, use the tree view to navigate through the following path:

    HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\NetShow\AccessLists.

  3. To work with one of the access lists, click the appropriate registry key:
    • AllowDistribution
    • AllowUnicastClients
    • DisallowDistribution
    • DisallowUnicastClients
  4. In the Name column, click the IP address.
  5. On the Edit menu, click Modify.

    The Edit String dialog box appears.

  6. In the Value Data box, type the mask value.

    The mask value is added to the Data column.

Notes

  • Like an IP address, the mask is a 32-bit value. To set a range of addresses, each bit in the mask is compared to the corresponding bit in the IP address. Where the value in the mask is 1, the corresponding bit in the IP address is included in the list. Where the value in the mask is 0, any value is acceptable. For example, in decimal notation, if the IP address in the list is 134.123.123.20 and the mask is 255.255.255.0, all IP addresses from 134.123.123.0 to 134.123.123.255 are included in the list. If the mask is 255.255.255.128, all IP addresses from 134.123.123.0 to 134.123.123.127 are included in the list. If you specify an invalid mask, the mask is ignored.
  • Your ability to make changes to the registry by using Registry Editor depends on your access permissions. Incorrectly editing the registry can severely damage your system. Before making changes to the registry, back up any valued data on the computer.


To edit an IP address in an access list

  1. Start Registry Editor (Click Start, click Run, and then type regedit).
  2. In Registry Editor, use the tree view to navigate through the following path:

    HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\NetShow\AccessLists.

  3. To work with one of the access lists, click the appropriate registry key:
    • AllowDistribution
    • AllowUnicastClients
    • DisallowDistribution
    • DisallowUnicastClients
  4. In the Name column, click the IP address.
  5. On the Edit menu, click Rename.
  6. Edit the value in the Name column, and press Enter.

Note

  • Your ability to make changes to the registry by using Registry Editor depends on your access permissions. Incorrectly editing the registry can severely damage your system. Before making changes to the registry, back up any valued data on the computer.


To remove an IP address from an access list

  1. Start Registry Editor (Click Start, click Run, and then type regedit).
  2. In Registry Editor, use the tree view to navigate through the following path:

    HKEY_LOCAL_MACHINE\SOFTWARE\MICROSOFT\NetShow\AccessLists.

  3. To work with one of the access lists, click the appropriate registry key:
    • AllowDistribution
    • AllowUnicastClients
    • DisallowDistribution
    • DisallowUnicastClients
  4. In the Name column, click the IP address.
  5. On the Edit menu, click Delete.
  6. In the Confirm Value Delete dialog box, click Yes.

Note

  • Your ability to make changes to the registry by using Registry Editor depends on your access permissions. Incorrectly editing the registry can severely damage your system. Before making changes to the registry, back up any valued data on the computer.


To modify the Membership Server Instance used by the HTTP-BASIC authentication and Membership Service account database authentication package

  1. Start Registry Editor (Click Start, click Run, and then type regedit).
  2. In Registry Editor, use the tree view to navigate through the following path:

    HKEY_LOCAL_MACHINE\Software\Microsoft\NetShow\Servers\Default\Authentication\HTTP Basic-Membership.

  3. Add a string value (reg_sz) with the name VirtualServerInstance and a data value that corresponds to the instance number of your Membership server.

    To determine the instance number of the Membership server you want to use, open a command prompt, change directories to \Siteserver\bin\P&M, and type:

    PMAdmin list instance

  4. Enter the number associated with the instance of the Membership server you want to use in the Data field for the VirtualServerInstance value just created.

Note

  • Your ability to make changes to the registry by using Registry Editor depends on your access permissions. Incorrectly editing the registry can severely damage your system. Before making changes to the registry, back up any valued data on the computer.


Managing the Windows Media component services account

Windows Media server components consists of the Windows Media component services (the Windows Media Monitor service, Windows Media Program service, Windows Media Station service, and Windows Media Unicast service) and the Windows Media Administrator.

The Windows Media component services use a Windows 2000 Server user account created for them when Windows Media server components are installed to log on to the system when the Windows Media server starts. The installation process creates the NetShowServices user account by default. The user account is added to the local NetShow Administrators and Administrators groups, and it is assigned administrative privileges on the Windows Media server.

Windows Media server components cannot stream files if the account used by the component services is not an Administrator equivalent. The account must have at least Read rights to the publishing point directory (unless it is a disk drive on the same computer), network share, or remote location, so that ASF content can be read from this location for streaming.

Note

  • When the default NetShowServices user account is created, a randomly generated password is assigned to it and to each of the Windows Media component services. If you change the account password, you also must change the passwords for the component services, or they fail to log on and function. If you are using a domain account for the Windows Media component services, you must change the password for the component services on every computer where Windows Media server components is installed. For more information, see To change the account or password used by Windows Media component services.


Managing the Windows Media component services account in a multiple-server environment

When Windows Media server components is installed on servers in a multiple-server environment, a NetShow Administrators group is created in the local account database on each server, thus making the account unique to that server. The Windows Media component services on each server log on using the rights assigned from this group.

Even if you use the default NetShowServices account and change the password for the Windows Media component services on each server so that the passwords are identical, the local component services cannot interact with the component services on another server because the account for the component services is not a member of the NetShow Administrators or Administrators group on the remote server. Therefore, you must use a domain account for the Windows Media component services, which is added to the NetShow Administrators group on each server. Or you can add the local account used by the Windows Media component services to the NetShow Administrators group or Administrators group on each server in the multiple-server environment.

You must use a domain account if you plan to store on-demand unicast content on remote servers. The Windows Media Unicast service must have at least Read rights to the directory defined as the location of a publishing point. The domain account used for the Windows Media component services also must belong to a local group on the server where the content is stored for on-demand streaming, or have rights assigned at the share level.


Administering Windows Media server components

Windows Media Administrator is installed with Windows Media Services. You can run Windows Media Administrator on Microsoft Windows 2000 Server or Microsoft Windows 2000 Professional. Users with administrator-equivalent rights on the computer where Windows Media server components is installed can administer that Windows Media server.


Administering Windows Media server components locally

If you plan to administer Windows Media server components by logging on to the computer where it is installed, it is recommended that you add your account to the Administrator or Power Users (in Windows 2000) group on that computer. Users that have these rights can run Windows Media Administrator and fully configure Windows Media server components.

Logging on locally with a local account does not give you access to any network resources; you only can create publishing points that point to a directory residing on a storage device controlled by the local computer. The NetShow Administrators group does not give permissions to the file system, so you also must have rights to create directories and place files on the disk drive in that computer.


Administering Windows Media server components remotely

If the Windows Media server is a member of a domain, a user can log on to any computer in the domain (or fully trusted domain) using a domain user account, and administer Windows Media component services. Windows Media Administrator must be installed on the remote computer. The domain user account must be a member of a local group on the Windows Media server that has administrative rights to the Windows Media component services. The NetShow Administrators group and the Administrators group grant sufficient rights to administer Windows Media component services. To create domain user accounts that can administer Windows Media component services, you must have administrative rights for the domain.

You also can create a domain group account for administering Windows Media component services, and add the group to the local NetShow Administrators group. You can perform Windows Media administrative tasks both locally and remotely by logging on to a domain with an account that is a member of a domain group belonging to the local NetShow Administrators group.

Making a domain user or group account a member of the NetShow Administrators group does mean a user has full control of the Windows Media server. The NetShow Administrators group grants only the rights necessary for Windows Media Services tasks, which include creating publishing points for on-demand unicast streams, enabling or disabling authentication packages, managing stations, and so on. Domain users that do not have Write rights to a physical directory on that computer cannot create directories to define as publishing points.

If the Windows Media server or the remote computer is not a member of a Microsoft Windows domain, you still can administer the Windows Media server from the remote location. To administer Windows Media component services from the remote computer, you must create an account, including the password, on the remote computer that is identical to an account on the Windows Media server. You also must be able to access the Windows Media server (for example, both computers must be connected to the Internet if you want to perform remote administration over the Internet). You must install Windows Media Services administration components on the remote computer and connect to the server where Windows Media server components are installed by supplying the IP address of the Windows Media server.


Administering Windows Media component services remotely with DCOM

The distributed Component Object Model (DCOM) can be used for remote administration of Windows Media component services. If you want to use DCOM for remote administration through a firewall, you must enable ports on the firewall that allow DCOM packets to pass through. Due to the number of ports required for DCOM, remote administration through a firewall is not recommended.

In order for successful remote administration of Windows Media component services to occur, you must open the ports used by DCOM on your firewall server. If you have problems streaming information through a firewall, you can open different ports on your firewall. Consult your firewall vendor to decide if you need to adjust your firewall to allow DCOM traffic for remote administration of Windows Media server components. DCOM requires all ports in the range from 1024 through 5000 and port 135 for remote procedure call (RPC) end point mapping to be open to communicate with Windows Media component services.

When using DCOM for remote administration of Windows Media component services, a computer outside of the firewall must be able to access the computer inside the firewall by its real IP address. Address translation and proxying are not supported.


Restricting access to ASF streams

Windows Media Services can be configured to restrict access to a stored on-demand .asf file by requiring that users be authenticated before the file is streamed to the user. Windows Media Services also uses access control list (ACL) checking in Windows 2000 Server to set access permissions on individual .asf files stored in on-demand and broadcast unicast publishing points. Access to live streams from a broadcast unicast publishing point can be restricted by applying access permissions to the registry key associated with the publishing point. Access to Windows Media stations can be restricted by assigning an ACL to the .nsc file stored on a Web server.

Perhaps the simplest method of controlling access to ASF streams is to block client and server connections to the Windows Media server. You can control client and server connections to the Windows Media server based on the IP address of the client or server attempting to connect.


Setting up unicast publishing point security

Windows Media component services can require that clients be authenticated before accessing a stream. Authentication is not enabled by default when Windows Media component services is installed; however, you can enable one of the three authentication packages installed with Windows Media Administrator for on-demand unicast streaming:

  • HTTP-BASIC Authentication and Membership Service Account Database
  • HTTP-BASIC Authentication and NTLM Account Database
  • Microsoft Windows NTLM Authentication and Account Database

HTTP-BASIC authentication provides a standard way to validate HTTP users by using encoded clear-text passwords and user names. To play ASF content from a publishing point, the client must supply a user name and password. HTTP-BASIC authentication is ideal for Internet applications.

NTLM authentication uses an encrypted challenge/response scheme to authenticate the user who is logged on to the client computer. Challenge/response authentication is performed without transferring user credentials, so that the Windows Media server cannot access the user name or password. Challenge/response uses established user logon information; therefore, it requires the client and server to be on the same or trusted domains and is better suited for intranet applications.

Only one type of authentication can be presented to the client at a time, so the type must be determined before any attempt is made to authenticate the client.

As part of unicast publishing point security, you can enable access control list (ACL) checking for any of the authentication packages. You cannot use ACL checking without enabling an authentication mechanism because unknown users cannot be authorized. The account used by the Windows Media services may also need to be added to the ACL. For information on ACL checking, see Using access control list (ACL) checking.


Using HTTP-BASIC Authentication with the Membership Service Account Database

When this authentication package is enabled, the authentication mechanism verifies the client by checking client credentials against user accounts stored in the Microsoft Membership Services database. Microsoft Membership Services must be installed and running on the server; otherwise, the authentication package will fail to load. If you use the HTTP-BASIC and Membership Service Account Database authentication package, you cannot configure the Microsoft Membership service to use a Microsoft Windows NTLM account database for user authentication.

Note

  • If HTTP-BASIC Authentication and Membership Service Account Database is used for authentication, the second virtual server instance of the Membership server is used by default; therefore, a second virtual server instance must be created or the registry key for the virtual server instance must be modified so that the first virtual server instance is used. If you are using a Membership database for authentication in an Internet scenario, you must use a database other than the local Microsoft Windows NTLM database because Internet users do not have a domain account on your computer. For more information, see To Modify the Membership Server Instance used by the HTTP-BASIC Authentication and Membership Service Account Database


Using HTTP-BASIC Authentication with the NTLM Account Database

When this authentication package is enabled, the Windows Media server looks for user account information on the local computer. If you want to check another domain, that domain must be specified. For example, you must supply a user name of domain\username where domain is the new domain that you want to check and username is the user name found in that domain.


Using access control list (ACL) checking

Using access control list (ACL) checking, you can set permission restrictions on individual .asf files and on directories. You can restrict access to multiple files simultaneously by assigning an ACL to the directory where the files are stored. You can set an ACL for stored content on an NTFS file system partition by assigning an ACL for the .asf file or the physical directory where the file is stored. You can also set an ACL for on-demand content stored on a FAT partition by setting an ACL for the registry key associated with the on-demand unicast publishing point. You cannot use ACL checking without enabling an authentication mechanism because unknown users cannot be authorized.

Note

  • If the source of a broadcast unicast publishing point is a live stream, the content is never stored on a physical storage device. If a file is not stored, you cannot assign an ACL to it. To restrict access to a broadcast unicast stream, you must use Registry Editor to apply access permissions to the registry key associated with the broadcast unicast publishing point. You can also restrict access to Windows Media stations by assigning an ACL to the .nsc file stored on a Web server.


Restricting connections to Windows Media server with access lists

You can control client and server connections to Windows Media server components based on the IP address of the client or server attempting to connect. This method allows you to distribute your content stream to selected servers when performing multicast distribution. Connections are controlled by creating a list of allowed IP addresses in an access list registry key of Microsoft Windows Server.

The following access list registry keys control access to the Windows Media server. By default, all connections are allowed.

Registry key | Description
AllowDistribution | Server computers using IP addresses in this list are allowed to connect to the Windows Media server or to Windows Media Encoder. Client computers using IP addresses in this list are allowed to connect to Windows Media Encoder and to the Windows Media server to receive a distribution stream. If no addresses exist in the list, any computer can connect unless its address is in the DisallowDistribution list.
AllowUnicastClients | Client computers using the IP addresses in this list are allowed to connect to the Windows Media server to receive unicasts. If no addresses exist in the list, any client can connect unless the address of the client is in the DisallowUnicastClients list.
DisallowDistribution | Server computers using IP addresses in this list are not allowed to connect to the Windows Media server or to Windows Media Encoder. Client computers using IP addresses in this list are not allowed to connect to Windows Media Encoder or to the Windows Media server to receive a distribution stream.
DisallowUnicastClients | Client computers using the IP addresses in this list are not allowed to connect to the Windows Media server to receive unicasts. If an address is included in both the disallow and allow lists, the connection is not allowed.


Windows Media server components authorization overview

A server can be configured to implement authorization as a service or via plug-in components. Delegating such tasks to dedicated plug-in components gives service providers the flexibility to implement different authorization schemes to meet different business needs. A plug-in component is responsible for carrying out the business policy and responding to event notifications. Windows Media server components supports any number of plug-in components running simultaneously. Each component can specify a unique set of events for notification and authorization.

To learn more about custom authorization components, see Windows Media Technologies Software Development Kit (SDK) on the Windows Media Technologies page at the Microsoft Web site.


Authorizing Windows Media clients

You can authorize Windows Media Player based on its Globally Unique Identification (GUID) number. This number is unique to each computer where Windows Media Player is installed.

To learn more about using client authorization, see Windows Media Technologies Software Development Kit (SDK) on the Windows Media Technologies page at the Microsoft Web site.


Creating distribution authentication

So that Windows Media servers can communicate securely with one another, the Server Properties page in Windows Media Administrator contains a Distribution Authentication tab on which you can enable server authentication proxy settings. If you attempt to distribute a unicast stream from this server to another Windows Media server and the connection is challenged by a proxy server, you can supply the following information to pass the proxy check:

  • Proxy. The server that must be used to check this information.
  • User ID. The account or name for which information is stored in the database.
  • Password. The information you must enter to verify your User ID.


Windows Media Codecs

The tools for creating ASF content use compression/decompression algorithms (codecs) to compress audio and/or video media, either from live sources or other media formats, to fit on a network's available bandwidth. Microsoft Windows Media Player then uses the same codec to decompress the ASF information prior to playing it. Separate codecs are applied to the audio and video portion of the ASF stream.

Codecs are designed to compress their source files to a certain bit rate, so not all codecs can be used to compress a file to a particular size. The difference in compression ratio also means a difference in playback quality. The codecs that do not compress their sources as much usually sound and look richer and more dynamic.

Windows Media Encoder can use any codec installed on your computer; however, the computer on which Windows Media Player is installed must also have the codec to play the .asf file or ASF stream. Windows Media Encoder does not come with the same number of codecs as Windows Media Player.


Codecs installed with Windows Media Encoder

Windows Media Encoder installs several audio and video codecs onto your computer. Codecs are also installed as part of the operating system and are sometimes added when you download files from the Internet. Windows Media Encoder can use any codec installed on your computer to encode ASF content; however, Microsoft Windows Media Player must have access to the same codec to decode your content. To ensure that your content can be decoded by Windows Media Player, choose codecs that are installed with Window Media Encoder.


Audio codec table

The following codecs are installed with Windows Media Encoder. The Windows Media Audio codec is recommended for most content because it usually produces the best sound quality in a media file with mixed media types and music-based content. However, if you are creating a low bandwidth stream (below 20 Kbps) that has voice-only audio content, better results may be obtained by using the Sipro Labs ACELP.net codec.

Codec | Description
Windows Media Audio Codec version 2 The Windows Media Audio codec is a highly scalable codec that provides high quality mono and stereo audio content over a wide range of bandwidths. You can use the Windows Media Audio codec to encode audio content at bandwidths ranging from 5 kilobits per second (Kbps) to 160 Kbps. The audio sampling rate ranges from 8 kilohertz (kHz) to 48 kHz. This allows you to choose the best combination of bandwidth and sampling rates for your content.

This codec is also very loss tolerant, so it is excellent for use with streaming content. It has superb clarity and tonal depth to provide better sounding music content than comparable codecs.

In addition, this codec can be used to remove an audio track from a piece of content by selecting the 0 kilobits per second (Kbps) audio format. If you are creating audio files for download, the Windows Media Audio codec is a great choice because it provides near CD-quality sound at half of the datarate required by most codecs.

Windows Media Audio Codec version 1 | This codec was also known as MSAudio. It is provided to support playback of existing content but should not be used to encode content.
FhG MPEG Layer-3 | Moving Picture Experts Group (MPEG) Layer-3, which is created by FhG, is a high-fidelity mono audio codec that is particularly good for CD-quality audio for an intranet or the Internet. MPEG Layer-3 comes with several formats depending on the network bandwidth you choose.
Sipro ACELP.net | ACELP is a low bit-rate codec that provides excellent voice compression. ACELP comes with several audio formats depending on the network bandwidth you choose.
Voxware | Voxware provides high-quality sound using low- to mid-range bit rates. It comes with a variety of mono and stereo audio formats to choose from depending on your network bandwidth. It is also suitable for encoding mono voice-only content at extremely low bit-rates.


Video codec table

The following video codecs are installed with Windows Media Encoder. When possible, use the Microsoft MPEG-4 Video Codec version 3 for encoding video content.

Codec | Description
Microsoft MPEG-4 Video Codec version 1 | The Microsoft MPEG-4 codec is a low to high bit-rate video codec. The advantage of this codec is that it meets the standards set by the Moving Picture Experts Group (MPEG). Use version 1 if you provide content to version 2.0 servers or players.
Microsoft MPEG-4 Video Codec version 2 | The Microsoft MPEG-4 codec is a low to high bit-rate video codec. Version 2 of the codec is provided for compatibility with content and encoder configurations created with version 3.0 of Windows Media Tools.
Microsoft MPEG-4 Video Codec version 3 | The Microsoft MPEG-4 codec is a highly scalable video codec that supports a wide range of network bandwidths. The latest version of the Microsoft MPEG-4 video codec has been optimized for the Intel Pentium III processors. Using this codec provides faster on-demand encoding and higher data rates, resolution, and frame rates for live encoding. If you are using an Intel Pentium II processor you will still experience much faster video encoding performance. Version 3 of the codec also supports multiple bandwidth and high bandwidth encoding. Additionally, it includes the video de-blocking filter which improves the video quality of your content by removing the blockiness caused by video compression - especially at low data rates like 28.8Kbps.
Microsoft H.263 | H.263 is good for providing low to mid bit-rate video. This codec is optimized for video conferencing, so it is a good choice for presentations and other low-motion video content.


Codecs installed with Windows Media Player

There are two Microsoft Windows Media Player installations: a full installation and a core installation. The full installation contains all the codecs that Microsoft is licensed to provide, but it is large and takes a relatively long time to download. The core installation contains a minimal set of codecs and can be loaded much more quickly. The following sections list the codecs that are part of each installation. If you are not sure that a client computer has the necessary codec to render an .asf file or ASF stream, you can use the Microsoft ActiveX codebase feature. This forces a Web page to check whether the client computer contains the codecs necessary to play the .asf file or ASF stream.


Windows Media Player full-install codecs

The following codecs are installed as part of the full installation of Microsoft Windows Media Player:

  • Microsoft MPEG-4 version 1, and version 2, and version 3 video codecs
  • FhG MPEG Layer-3 audio codec
  • Voxware audio codec
  • Windows Media Audio codec version 1 and version 2
  • Sipro ACELP.net


Windows Media Player core codecs

The following codecs are installed as part of the Microsoft Windows Media Player core installation:

  • Voxware audio codec
  • FhG MPEG Layer-3 audio codec
  • Windows Media Audio codec version 1 and version 2
  • Microsoft MPEG-4 video codec


Windows Media Encoder

Windows Media Encoder encodes live or stored audio and video into an ASF stream, an .asf file, or both. Windows Media Encoder is the tool of choice when:

  • You are using a live source.
  • You need to compress the video source (live or stored) so that the resulting ASF stream or .asf file fits in a target bandwidth.
  • You want to create content that can span several target bandwidths.
  • You are converting content from an .avi, .mp3, or .wav file, and you want to use a different codec or select the size of the video display.

Note

  • This documentation is intended to give you an overview of the concepts involved in creating ASF content with Windows Media Encoder. For procedural help in using Windows Media Encoder, open Windows Media Encoder, then click Help, Contents to view the online help.


Concepts

Windows Media Encoder is used to create audio and video ASF content for broadcast over a computer network. Windows Media content can be a live content stream or a stored .asf file.

You can create an .asf file from stored media, such as sound, picture, and movie files, or from live streams. After an .asf file has been created, it can be modified by using the ASFChop command-line utility.

This section discusses the underlying concepts behind creating Windows Media content. It does not cover the preliminary process of preparing and editing multimedia files.


Understanding ASF streams

Windows Media Encoder takes source information in either live or stored form and turns it into Windows Media content that can be streamed by a Windows Media server. Live information sources are anything you can input into your audio or video card, including a CD player, microphone, VCR, or video camera. Stored information sources include movie, picture, or sound files. Once the media has been converted to ASF, you can deliver it to a Windows Media server for streaming. An ASF stream can also be saved as an .asf file.


Understanding .asf files

An .asf file is a streaming multimedia file that is scaled to fit within a network's available bandwidth.

You can create .asf files from a variety of sources, including:

  • Video. A .mov or .avi file.
  • Images. Any image in the .bmp, .dib, .rle, .jpg, or .gif format.
  • Audio. Any .wav or .mp3 files that use any ACM codec; that is, any audio file you can play on your computer (Microsoft Windows operating systems contain several ACM codecs).
  • Microsoft PowerPoint presentations. Depending on the version of PowerPoint that you are using, you can either save your PowerPoint presentation as an .asf file, or save your PowerPoint slides as .jpg images and then use Windows Media Author to incorporate these images into an .asf file.
  • Live audio and video. Using Windows Media Encoder, you can turn any live event that can be captured with a microphone or a video camera into an .asf file.


Streaming Windows Media content

ASF content is designed to be streamed from a Windows Media server to a Microsoft Windows Media Player client. The Windows Media server and Windows Media Player client can be used either on the Internet or an intranet, and they can be separated by a firewall. As a content creator, your first concern is the amount of network bandwidth available for content delivery.

Bandwidth and bit rate are essentially the same thing in terms of streaming Windows Media content. Bandwidth often is used to describe the size of a network, and bit rate is used to describe the rate at which the Windows Media content is delivered. Content created to stream over a network with a 28.8 kilobits per second (Kbps) bandwidth cannot stream at more than 28.8 Kbps. This means that no more than 28,800 bits of information are traveling across the network each second. A user cannot receive content streamed at a higher bandwidth than the network connection supports.

Intranets can handle content that streams at a much higher bit rate than on the Internet. In the intranet environment, the network administrator or the network bandwidth enforces restrictions on the available bandwidth for content streaming. The network administrator can set the Windows Media server to restrict the amount of information that it streams. This restriction keeps the server, during periods of high use, from streaming so much information that it slows down the overall flow of information on the network. If the network administrator does not set a limit on the amount of information that a Windows Media server can stream, the network bandwidth is the limiting factor for content delivery.


Bandwidth considerations

Before you begin creating ASF content, check the maximum bandwidth allowed on your server.

Once you know the maximum bandwidth of the Windows Media content that you can create, you can begin. Other than Windows Media Encoder and Windows Media Author, the tools you use to create Windows Media content do not force you to scale your source files to fit a certain bandwidth. The Windows Media Tools command-line utilities, WavToASF and VidToASF, convert source files directly into ASF. Windows Media content that is created from another file type retains the bandwidth requirements of the original source.

A quick way to find out how much bandwidth your content requires is to play the content with Microsoft Windows Media Player. Once the file is playing, from the View menu, click Statistics. In the dialog box under Network is an entry labeled Bandwidth. The value displayed tells you how many kilobits per second (Kbps) are required to stream the content. There are many ways to reduce amount of bandwidth required by an .asf file, including editing the source files or using codecs to compress the source files.

If you are creating content with a tool that monitors the amount of bandwidth used, the tool automatically reserves a portion of the bandwidth for other types of network traffic. For example, when you set the target bandwidth to 28.8 Kbps, you use an actual bandwidth of approximately 22 Kbps. If you are using a tool that forces you to keep track of the bit rate of the content, you must monitor the amount of information based on the actual bit rate required to deliver the content.


Placing .asf files on a Windows Media server

To stream .asf files after you create them, you must place them on a Windows Media server or an HTTP server. It is suggested that you place them on a Windows Media server because only there do you receive all the ASF functionality. Although an HTTP server can stream .asf files, it cannot duplicate all the functionality of a Windows Media server.

To create Web-page links to the .asf files, it is suggested that you place your .asf files in the Windows Media server content directory. For example, SystemDrive\ASFRoot is the default content directory on a Windows Media server. The Windows Media server searches its content directory for the .asf file to stream when it receives a request. To determine which directory on the Windows Media server is the content directory, open Windows Media Administrator and click Unicast Publishing Points; the content directory path is listed next to the <Home> publishing point.


Placing .asf files on a Web server

If you have a Web server that you want to use to stream ASF content, you can place the .asf files in a Web directory, link to them from your Web page, and then use HTTP to stream the content to your users. In this scenario, the streaming is managed by the Web server, and the installation of Windows Media Services or Windows NT is not required. When streaming .asf files from a Web server, be aware of the following limitations:

  • Web servers cannot use multiple bit rate video and intelligent streaming to negotiate the bandwidth available to the user.
  • Content must be encoded using single stream video configuration, such as the Web server template stream formats or a custom configuration.
  • Content streamed via HTTP does not have the same ability to correct streaming errors. If you use this method, the same stream will be lower in quality than if you stream it using Windows Media Services.
  • Content published by a Web directory can be directly downloaded by the user instead of streamed.


Multiple bit rate video

Whether you are creating content for live broadcast or on-demand distribution, you can use multiple bit rate video to make your content accessible by users that have a network connections that range from 28.8 Kbps dial-up modems to high bandwidth LANs. Encoding content with multiple bit rate video creates multiple video streams along with the audio steam and script command stream (if selected). The video streams are encoded at different target network bandwidths. For example, if you choose to use multiple bit rate video with a single target bandwidth of 56 Kbps, two video streams will be created that use greater and lesser amounts of that bandwidth, but it will not create a video stream that is low enough to make the content accessible by users with a 28.8 Kbps network connection. To supply content to users with 28.8 Kbps connections, choose a template that lists both target networks or specify both target audiences when you create a custom configuration.

When you create a custom configuration with multiple bit rate video, you first select whether to support target audiences with low bandwidth network connections (18 Kbps to 300 Kbps) or high bandwidth (81 Kbps to 10 Mbps) network connections. In each category, Low Bandwidth and High Bandwidth, you can select up to five target audiences for your content. Each target audience supports a different range of network bandwidths. You can also specify the same target audience multiple times within the category and then specify greater or lesser amounts of bandwidth for each. The following table details the bandwidth ranges available and the default category for each target audience.

Target Audience | Default Category | Bandwidth range
28.8 Modem | Low Bandwidth | 18 - 27 Kbps
56 Dial-up Modem | Low Bandwidth | 28 - 37 Kbps
Single Channel ISDN | Low Bandwidth | 38 - 55 Kbps
Dual ISDN | High Bandwidth | 56 - 120 Kbps
Intranet | High Bandwidth | 121 - 250 Kbps
High Speed Internet | High Bandwidth | 251 - 500 Kbps
LAN | High Bandwidth | 501 - 700 Kbps
High Speed LAN | High Bandwidth | 701 Kbps - 10 Mbps

Using multiple bit rate video allows Microsoft Windows Media Player to continue rendering content when network bandwidth is reduced. If the server detects a reduction in the amount of network bandwidth available during the playback, the lower bandwidth video stream will be sent to the player. The user will experience a slightly lower quality stream during the time when the bandwidth is reduced, but the stream will not be interrupted or need to be buffered to recover from the loss of bandwidth.

When you encode a multiple bit rate stream, make sure that there is enough bandwidth available to transfer the full ASF stream between the encoding computer and the Windows Media server. Because additional data is being encoded and all of the encoded video streams must be sent to the server, multiple bit rate streams have a higher aggregate bandwidth requirement for live stream distribution from an encoder to a Windows Media server. The Windows Media server determines the appropriate stream to send to each individual client.

The following table shows the aggregate requirements for the default multiple bit rate template stream formats. The target bandwidths column represents the bandwidths at which the client computer can connect to the server and receive the content. Aggregate bandwidth is the amount of bandwidth necessary for distributing the stream from the encoder to the server. The numbers provided are approximate; actual numbers vary slightly depending on your content.

Template | Target bandwidths (Kbps) | Audio bandwidth (Kbps) | Aggregate bandwidth (Kbps)
Dial-Up Modems - ISDN Multiple Bit Rate Video | 57, 37, 34, 29, 22, 17 | 8 | 204
Intranet - High Speed LAN Multiple Bit Rate Video | 700, 500, 300, 150, 120 | 10 | 1780
28.8, 56, and 100 Multiple Bit Rate Video | 100, 35, 22, 17 | 8 | 174
28.8 Video Voice | 22, 17 | 5 | 34
28.8 Video Audio Emphasis | 22, 17 | 8 | 30
56 Dial-up Modem Video | 37, 22, 17 | 10 | 52

The lowest bandwidth is an automatic "insurance" bandwidth that is created when multiple bit rate encoding is enabled. This insurance bandwidth is created every time you use multiple bit rate encoding, even when a custom configuration is created.

If you are using a custom encoding configuration you can estimate the aggregate bandwidth requirement by adding the following values:

  • Bandwidths specified per target audience selected
  • Audio bandwidth selected
  • Insurance bandwidth

Calculate your insurance bandwidth as a percentage of the lowest target audience bandwidth you have selected. The following table provides the percentages used for each target audience.

Target audience | Percentage
28.8 Modem | 80%
56 Dial-up Modem | 70%
Single Channel ISDN | 66%
All High Bandwidth Audiences | 66%

Finally, be aware that only a single audio stream is encoded for all of the video bandwidths selected. So you must subtract the amount of audio bandwidth required for the audio stream from each of the target audience(s) you selected before performing the addition.


Enhancing Windows Media content

When you are creating and hosting Windows Mediacontent you can choose to add features and functions to your content. The following items are some of the options available:

  • Indexing and markers. Makes content seekable, providing fast forward, rewind, and search functions to .asf files unicast from a Windows Media server.
  • Script commands. Makes the user experience more interactive through Web links and related content topics.
  • Playlists. Show multiple pieces of Windows Media content in a specific order. A common use is to intersperse commercials with your content.


Markers

A marker is a pointer to a specific time in a Windows Media file. Microsoft Windows Media Player uses markers to seek directly to a point in a Windows Media file. A user can skip ahead or skip back to a previous marker to view a portion of the file again. Markers are used only with stored Windows Media files. You can use a script file with the command-line utility ASFChop to place markers.

To create a marker with a script file, specify the time where you want to set the marker and name the marker. You can name the markers anything you like. A marker script file looks like this:

; Sample Marker script.txt
start_marker_table
8 Marker 1
1:00 Marker 2
1:15 Marker 3
3:00:03 Marker 4
end_marker_table


Script commands

Script commands instruct Microsoft Windows Media Player to perform additional tasks, called scripts, along with rendering the content stream. Script commands can be used with both live streams and stored files. Script commands can be added to live streams through Windows Media Encoder and added to stored files through either Windows Media ASF Indexer or the command-line utilities.

Script commands can be appended to an existing file by using a script file with the command-line utilities provided with Windows Media Tools. You can create these script files using a text editor. Insert script commands into an .asf file using the -script option and the text file.


Script command table

The following script types are supported by Microsoft Windows Media Player.

Script type | Function
URL | The player sends the specified URL to the browser for display to the user. If you are using an embedded player control, you can add a specific frame reference to the URL by using the &&framename syntax.
FILENAME | A URL to another media file to be played.
TEXT | A text string that is displayed in the captions area of the media player. This type supports standard HTML formatting, so the text can be formatted as you wish. An example of use is closed captioning.
EVENT | The name of an event that is to occur. The EVENT type supports customization for your own uses. The code for the specified event must be defined in the .asx file for the stream in order for the player to perform the specified event. An example of use is ad insertion.
OPENEVENT | This script precedes the actual EVENT. The OPENEVENT allows the players to pre-buffer the content so that when the event occurs the switch between streams appears close to seamless.


Script files

The following rules apply when creating script files:

  • Lines that begin with semicolons are treated as comments.
  • Blank lines and extra white space generally are ignored.
  • Specify the time for markers and URLs in the hh:mm:ss.t format, where h equals hours, m equals minutes, s equals seconds, and t equals tenths of seconds.
  • Specify times in terms of the source file timeline.

ASF Script Builder can help you build script files. For more information, see ASF Script Builder Utility in the Windows Media Technologies Solutions Samples section of the Windows Media Technologies Software Development Kit (SDK). Download the Windows Media Technologies SDK from the Windows Media Technologies page at the Microsoft Web site.


Scripting examples

The following items are examples of scripting uses:

  • URL flipping
  • Captioning

URL flipping works well by itself, but other script commands require client-side assistance. The captioning in the second example requires some client-side assistance. For information on how to provide client-side assistance for script commands, see the ScriptCommand Event in the Microsoft Windows Media Player documentation at the Microsoft Web site.

; This is how you put content information into your .asf
; file when using VidToASF or WavToASF.
Title: This is the title
Author: ASF Maker
Copyright: 1998
Description: text that describes the .asf file
Rating: PG

; Demonstration of URL flipping and captioning
start_script_table
1.0 URL http://Windows Media/images/austr1.html&&Display
5.0 Caption Sydney Opera House
12.0 URL http://Windows Media/images/austr2.html&&Display
15.0 Caption A nice beach north of Sydney
32.0 URL http://Windows Media/images/austr3.html&&Display
35.0 Caption Australia's rain forest
end_script_table

Note

  • In the preceding example, && is used to indicate the frame in a Web page in which the URL is supposed to appear. For this to work properly, the browser must be able to access the URL. If you include a URL that does not exist, the browser returns an error message.


Playlists

Playlists are pointers to Windows Media files or streams. Each file or stream is referenced by a URL—for example, mms://server/sample.asf or mms://server/alias. In Windows Media Services, there are two types of playlists—client-side and server-side.

Client-side playlists

Client-side playlists are lists of files and streams in an .asx file. Playlists are created using a text editor and standard Extensible Markup Language (XML) syntax to create a list of Windows Media file references in an .asx file.

Sometimes you may wish to create playlist based on user requests or demographics data. You can use Active Server Pages to dynamically create personalized .asx files based on user responses. Also, content producers can create .as In addition, using the Membership Server and Ad Server features of Microsoft Site Server version 3.0, you can create Web pages that dynamically build a playlist of live stream URLs intermixed with personalized commercial .asf files that target the personal tastes of viewers

Server-side playlists

Server-side playlists are the lists of .asf files and streams in a Windows Media program. Use server-side playlists to set looping and stream durations. Server-side playlists cannot be generated by .asp pages, but can be streamed via unicast and multicast.


Understanding Windows Media Audio Files

Windows Media Audio (.wma) files are a specialized form of Advanced Streaming Format (.asf) files. These files contain audio data that is compressed by using a new high-quality lossy audio compression scheme (codec) called Window Media Audio. Windows Media Audio files are meant to be used with high quality audio-only content.

A .wma file can be distributed using Windows Media Services. When a user requests a .wma file, Windows Media Services automatically creates a special type of announcement file (.wax) that directs the player to the content.

The .wma and .wax extensions can be registered to the default player chosen by the user. Thus, if you are using Windows Media Tools to create audio-only .asf files, renaming them with the .wma extension will increase their portability to different players.

Currently, Windows Media Player is the only player that has the decoding keys for the Windows Media Audio codec. For more information about distributing decoding keys, see the Windows Media Audio Software Development Kit.

Note

  • A .wma file can be encrypted with Windows Media Packager.


Using Windows Media Encoder

Windows Media Encoder must be configured prior to use. There are three wizards you can use to configure Windows Media Encoder:

  • QuickStart. A template stream format (TSF) is used to configure the ASF stream. QuickStart assumes that you are encoding from a live source and delivering the content to a Windows Media server.
  • Template with I/O Options. This method uses TSFs to enter codec and bandwidth settings, but you select the input devices and output locations.
  • Custom. You have full control over the encoder’s settings.

Windows Media Encoder does not deliver ASF streams to clients (except for testing). It delivers the ASF stream to a Windows Media server, which then can multicast or unicast the ASF stream over the network. If Windows Media Encoder creates an .asf file, that file is saved to a folder specified during configuration. To test an .asf file created by Windows Media Encoder, use Microsoft Windows Media Player to open the .asf file.


QuickStart configuration

If you are unsure of which codecs to use to configure Windows Media Encoder to encode live content for a Windows Media server to broadcast, use QuickStart, and select one of the template stream formats (TSFs) to set the codecs.

Note

  • QuickStart uses the default input devices on your computer to capture the live audio and video content. To find out which capture device is considered the default, look at multimedia devices in control panel. To select different input devices than the default, configure Windows Media Encoder using the Template with I/O Options method.


Template with I/O options configuration

When you select Template with I/O Options, you first choose a template stream format (TSF), the same as you do for QuickStart. However, after you select the TSF, you then advance through the configuration screens and specify the audio and video inputs, the IP port or a Windows Media server that receives the ASF stream, and whether or not you want the encoder to output the ASF stream to an .asf file. The screens you see will differ depending on the TSF you select. When you finish creating the configuration, you can save all settings as an .asd file.


About template stream formats

Template stream formats (TSFs) are preconfigured settings for Windows Media Encoder. The TSFs identify the configuration of standard ASF streams to the Windows Media component services and Microsoft Windows Media Player. The TSFs contain information on the following parameters:

  • Target network bandwidth. This value identifies the minimum bandwidth of the user’s network connection. If the user’s network connection does not support the target bandwidth, the user cannot receive the stream. Windows Media TSFs range in bandwidth from 28.8 kilobits per second(Kbps) to 3 megabits per second (Mbps). If your users range over a variety of bandwidths, consider using a multiple bit rate video template to create a stream that supports multiple bandwidths.
  • Content type. The type of content you plan to stream has a great impact on the audio and video codecs used and the video settings that provide optimal performance. There are a variety Windows Media TSFs for audio only streams as well as multimedia streaming templates.
  • Multiple bit rate video. Multiple bit rate video templates encode multiple video bands into a single ASF stream or file so that the content can stream over variable network bandwidths. This provides for the best client experience at higher bandwidths while still supporting lower bandwidth network connections. It is also useful for times when available network bandwidth is constrained, and the stream needs to adapt to different conditions. When encoding multiple bit rate video at Internet bandwidths, the minimum processor required is a Pentium II 266 MHz. To encode multiple bit rate video on higher bandwidths, a dual Pentium II 400 MHz is required.
  • Web server video. Web server video templates are designed for ASF content that is destined to be streamed from a Web server without using Windows Media Services. These templates provide a simple audio and video stream suitable for HTTP streaming.

Note

  • Windows Media Services can also be used for HTTP streaming and provides a more reliable HTTP transport for streaming media than the streaming methods used by a Web server. If you use Windows Media Services for HTTP streaming, you can use any of the encoding templates. For more information on enabling and using Windows Media services for HTTP streaming, see Using HTTP streaming.


Producing content for version 2.0

If you still have users that are using version 2.0 of NetShow Player or are providing content to a server using version 2.0 of the Windows Media services, you will need to use the custom configuration method to create version 2.0 compliant .asd files or use the version 2.0 .asd files that you already have to create the content.

If you decide to create new version 2.0 compliant .asd files, use the following guidelines:

  • Select the Microsoft MPEG v1 video codec.
  • Select the MPEG Layer-3 audio codec.
  • Do not use multiple bit rate video.
  • Do not use Windows Media Services current version announcement (.asx) files.


Custom configuration

When you custom configure Windows Media Encoder you must identify the bandwidth of the network you are using, the media that make up the ASF stream, the codecs that you use to make your media fit within the network bandwidth, and other details of the encoding process.

After you configure the encoder, click Start to begin streaming ASF information. However, if the Windows Media server is going to use the output from Windows Media Encoder, you must save the configuration as an .asd file. The .asd file contains all the settings and specifications for the ASF stream. To broadcast this ASF stream, make the .asd file available to the system administrator who is setting up the Windows Media server. In setting up the broadcast, the system administrator imports configuration data from the .asd file. When you create a configuration using a template stream format (TSF), the Windows Media component services are pre-configured with the setting and specifications of the ASF stream, so an .asd file is not required.

Note

  • The custom configuration method is provided for advanced users and assumes detailed knowledge of bandwidth capacity, media settings, and codec usage. We recommend the Windows Media Audio codec version 2 for audio content and Microsoft MPEG 4 version 3 for video content. The format bit rate that you select with the audio codec determines how much of your bandwidth is left for video content. If you increase the bandwidth you devote to your audio content, your audio quality will improve but will be offset by a decrease in video quality.


Editing properties

Once you have created a configuration (.asd) file for Windows Media Encoder, you can make changes to that configuration by editing its property pages. The property pages available differ depending on whether you use a template stream format (TSF) or a custom configuration.

The properties available when using TSFs are:

  • Template. Controls which TSF is used by the .asd file.
  • Input. Controls the source of the content; either Live or an AVI/WAV/MP3 file.
  • Output. Controls where the .asf file or ASF stream is sent, either to a Windows Media server, a local .asf file, or both.

The properties available when using a custom configuration are:

  • Input. Controls the source of the content; either Live or an AVI/WAV/MP3 file.
  • Bandwidth. Controls the bandwidth at which the content streams.
  • Compression. Controls the audio and video codecs used to compress the content. Also provides access to advanced settings for image size, number of frames per second, number of seconds per I-frame, pixel format, delay buffer, and image quality.
  • Output. Controls where the .asf file or ASF stream is sent, either to a Windows Media server, a local ASF file, or both.

Note

  • If your source is an .mp3 file with ID3 properties, those properties will be preserved in an .asf file. These properties can be edited using Windows Media ASF Indexer.


Using the Windows Media Audio codec

Windows Media Audio is a new audio codec created by Microsoft. Windows Media Encoder included in Windows Media Services version 4.1 contains the latest version of this codec, Windows Media Audio codec version 2.The codec is designed to handle all types of audio content, from low-bandwidth 8-kilohertz (kHz) speech to 48-kHz stereo music. This codec is very resistant to degradation due to packet loss because it does not use interframe memory. This loss tolerance makes it excellent for use with streaming content. In addition, by using an improved encoding algorithm, this codec encodes and decodes much faster. The improved compression algorithm creates audio files that need much less disk space for storage than the same content created with other codecs. Content created using the Windows Media Audio codec is easily distributed over the Internet because the files can be downloaded more quickly. Therefore, if you are creating audio files for download, the Windows Media Audio codec is a great choice because it provides near-CD-quality sound at half of the bandwidth required by most codecs.

During tests against comparable codecs, the Windows Media Audio codec provided much clearer sound with greater tonal distinction than the others. The combination of superb clarity and tonal depth produces better sounding music content across all supported bandwidths. The Windows Media Audio codec is a highly scalable codec that provides high-quality mono and stereo audio content over a wide range of bandwidths. This allows you to choose the best combination of bandwidth and sampling rates for your content. Thus, Microsoft has chosen to make it the default audio codec for most of the Windows Media Encoder configuration templates.


Viewing statistics

Windows Media Encoder provides a variety of statistics to help you assess the effectiveness of your encoding. These statistics are useful when trying to track the effect of changes to codecs and bit rate settings so you can get the best rendering of content. Also, if you use multiple bit rate video, you can view and compare statistics from the available video streams.

The statistics available are:

  • ASF statistics. Includes the amount of data sent, the amount of padding sent, and the bit rate used to transmit the data.
  • Audio statistics. Includes the amount of data sent and the bit rate used to transmit the data.
  • Script commands. Provides a measure of the number of bytes of script commands sent and how many commands that represents.
  • Video statistics. Provides a measure of the amount of data sent and the amount of data lost. Provides summary statistics of the bit rate and number of frames per second transmitted.
  • Current connections. Displays the IP address of computers currently connected to the encoder.


Starting the encoder

Once Windows Media Encoder is configured, it is ready to start encoding the ASF content. Select Start from the Encode menu or press the start button.

You are presented with the start window after a configuration is completed and when you open Windows Media Encoder from the Start button after saving a configuration file. The start window is composed of a toolbar and three information panels. The toolbar contains shortcuts to common menu commands, such as starting and stopping the encoder, preview video, and help. The panels contain the following information:

  • The Summary Statistics panel provides information about the encoding session, how long it has been encoding, how much data has been encoded in the session, the current bit rate of the content currently being encoded, and the number of frames per second that are being encoded. This gives you a quick means of seeing whether or not the encoding session is providing good quality content.
  • The Summary Settings panel provides information about the configuration you are using. It shows which codecs are being used, which input sources are being used, the output file (if any) , and the name of the template stream format (TSF) , if used.
  • The Connection Information panel provides the stream reference for the encoder. This is the information that is used for connecting a Windows Media server or a Microsoft Windows Media Player client to the Windows Media Encoder content stream.

If you have enabled script commands, the script command box is at the bottom of the start window. To send a script command, type the script command in the box, for example:

URL HTTP://www.example.microsoft.com

and then click the Send icon at the point in the content stream that you want the specified action to occur. Once sent, the script command is embedded into the ASF stream and is carried out by the Windows Media Player client during viewing.

Once you start the encoder, statistics will start to accrue in the Summary Statistics panel, and the camera icon will change from Off Air to On Air.


Using HTTP streaming with Windows Media Encoder

If your Windows Media server is protected by a firewall, you can still receive source content from a Windows Media Encoder located outside of the firewall using a feature called HTTP streaming.

This option is designed to enable a Windows Media Encoder on the Internet to distribute an ASF stream to a Windows Media server located within a firewall. Standard firewall configurations do not allow distribution of a stream from Windows Media Encoder inside a firewall out to a Windows Media server installation on the Internet.

HTTP streaming is enabled by default for QuickStart configurations. The port reference for HTTP connections is listed in the stream reference box of the encoder. To change the port or to disable HTTP streaming, clear the checkbox for HTTP streaming on the output properties page of your encoder configuration.

If you use the Template or Custom configuration methods, you can select HTTP streaming from the Output Settings, Transmissions page of the configuration wizard.

Note

  • Check with your network administrator to avoid HTTP port conflicts or to open the port in your firewall.


Enabling remote connections to Windows Media Encoder

Windows Media Encoder supports remote connections through dial-up networking. Windows Media Presenter for Microsoft PowerPoint 97 uses this connection to send start, stop, and script commands to Windows Media Encoder during the presentation.

By default, Windows Media Encoder accepts remote connections, unless the computer that Windows Media Encoder is installed on has an active dial-up networking connection at the time of installation. In that case, after the computer restarts, a dialog box is displayed asking you if you want to enable remote connections.

If you do not choose to enable remote connections initially, you can enable them later by running the file Enable_Remote_Connection.reg. This file is in the SystemDrive\Program Files\Windows Media Components\Tools directory. Also in this directory is Disable_Remote_Connection.reg, which is used to disable remote connections.

Note

  • This section applies only to Windows Media Encoders running on computers using the Microsoft Windows 95 or Microsoft Windows 98 operating system.


Stopping the encoder

Stopping Windows Media Encoder causes the content stream to stop encoding. Any computer that is receiving the content stream stops receiving content. After stopping the encoder, it can take a few seconds for the capture cards to be reset. If you try to restart the encoder before they have been reset, a message appears telling you that the video device could not be started. Wait a few seconds, and then try to start the encoder again.

Windows Media Encoder can be stopped by clicking the Stop button or by placing limits on the encoding session, such as limiting the file size or file duration.


Testing ASF streams

After configuring and starting Windows Media Encoder, it is a good idea to test it before providing content to users.

To test the encoder, use Microsoft Windows Media Player to receive the ASF stream from both Windows Media Encoder and the Windows Media server.

The stream originating from Windows Media Encoder is not a multicast stream, so do not use more than fifteen clients to test the encoder.


Publishing to the World Wide Web

Once you have created ASF content with Windows Media Encoder, how can you distribute it effectively to the widest audience? Microsoft has created the Windows Media Service Provider Program to provide content creators with a set of service providers that are qualified to deploy and maintain Windows Media Services-based streaming media solutions.

From the Windows Media Encoder File menu, select Publish to Web to view the list of currently approved Windows Media Service Providers that can publish your content on the Web.


ASFChop

ASFChop is a command-line tool that you can use to delete parts of an .asf file and to add indexing, script commands, markers, and general properties to an .asf file. Deleting parts of a file reduces the length of time required to stream the file. ASFChop creates an index for that file so that you can seek (similar to fast forward) through the file. Windows Media Encoder can also be used to create seekable .asf files. An .asf file must have at least 10 seconds of content to be indexed.


ASFChop command-line options

The command-line options allow you to specify a particular setting or include additional files in the .asf file. To view an online listing of the options, from the Windows Start menu, point to Programs, and then click Command Prompt, type the name of the utility, and press ENTER.

Option name | Option argument | Description
-duration | time | Provides the duration of the output .asf files. Note: Use either the -duration or -end options.
-eccspan | on|off | Turns error correction on or off. If this option is not supplied, the error correction setting from the input file is maintained.
-end | time | Specifies the time when you want the .asf file to end.
-in | filename.asf | Specifies the .asf file that you want to edit.
-out | filename.asf | Specifies a name for the output file. If you do not give the output file a name, ASFChop will output the new file with the same name as the input file.
-script | filename | Specifies the name of the script file to use in adding URLs, script commands, content information, or markers to your output file.
-start | time | Cuts off the beginning of an .asf file. When you set a start time, ASFChop removes all content before that time. When the .asf file is saved, that time becomes the beginning of the .asf file.

Note

  • Times for any of the options must be specified as hh:mm:ss.t, where h equals hours, m equals minutes, s equals seconds, and t equals tenths of seconds. For example 04:12:28.9 is 4 hours, 12 minutes, 28 and 0.9 seconds.


To use ASFChop on your .asf file

  1. From the Windows Start menu, point to Programs, and then click Command Prompt.
  2. In Command Prompt, locate the directory that contains the input source file, and enter the following command (substituting the names of your .asf files):
     ASFChop -in filename.asf -out filename.asf
  3. Append the desired options after the -out option, such as -duration, -end, and -script. Then press enter.

Note

  • The -out option is optional. If you do not specify this option, ASFChop creates an output file with the same name as the input file and appends the .asf extension.


Windows Media Player

Microsoft Windows Media Player is the client software application used to receive ASF streams from a Windows Media server. A user can use Windows Media Player to access streams directly, or Windows Media Player can be started by opening an ASX file. Windows Media Player is used to play many other types of content. To learn about using Windows Media Player for other applications, see Windows Media Player Help.


Using Windows Media Player

There are three ways of using Microsoft Windows Media Player to deliver ASF content to a user. Windows Media Player can be used as a stand-alone program, started from a hyperlink, or embedded within a Web page.

ASF content can be in the form of either .asf files or ASF streams. Saved .asf files can be opened and played by Windows Media Player but are not streamed to it. Only content directly delivered to a client from a Windows Media server is streamed to Windows Media Player.


Accessing content from the stand-alone Windows Media Player

When you install Windows Media Player, it configures your computer to make associations with specific types of media, based on the protocol and file extensions. This means that you can use Windows Media Player to access any type of file that helps you receive ASF content.

To access content with Windows Media Player, from the File menu, click Open, then type a location into the Open dialog box.

You can use many different protocols and open many different types of content using Windows Media Player. For more information on opening content from applications other than Windows Media Services, see Windows Media Player Help.

Playing stored .asf files

To play a stored .asf file from a Windows Media server, in the Open dialog box type:

mms://server/file.asf

If the Windows Media server is configured to stream using HTTP, you would type:

http://server/file.asf

The server streams the file from the ASF content folder (for example, SystemDrive\ASFRoot) to the client. When a Windows Media server has HTTP streaming enabled, the server still uses the ASF content folder as its Home directory; the server does not use the HTTP virtual root (i.e., SystemDrive\wwwroot) as the Home directory.

Playing content via ASX files

You use ASX files to access .asf files from a Windows Media server, broadcast unicast publishing points, or multicast stations. The ASX file is a pointer to ASF content. To use ASX files with a stand-alone player, you must know the path to the ASX file. The most common way of accessing ASX files using the stand-alone player is to type the path to the file in the Open dialog box. This path can be a shared folder or a Web site. For example, to access a shared folder, type:

\\server\share\file.asx

Or, to access a Web site type:

http://server/file.asx

Windows Media Player downloads the ASX file, parses out the path to the ASF content, and then streams the content from the server.

Playing content from HTML pages

When an HTML page contains an embedded player (the Microsoft ActiveX control), you do not need to use the stand-alone player to access the Web page. If you choose to use this method, you can, but the preferred method is to open your Web browser and access the HTML page. To access Web pages with Windows Media Player, in the Open dialog box type:

http://Webserver/page.htm

Windows Media Player passes the URL to the local browser which opens and finds the Web page. Once you load the HTML page, the embedded Windows Media Player appears and begins rendering the ASF content associated with it.


Starting Windows Media Player from a link

There are two ways to start Microsoft Windows Media Player from a link on a Web page or Web application and receive content streamed from a Windows Media server:

  1. You can enable HTTP streaming and use HTTP links to the ASF content directly. You must use HTTP streaming to stream content through a firewall.
  2. You can use HTTP links to .asx files, which contain instructions that Windows Media Player uses to access ASF content. The .asx file must reside on an HTTP server, such as Internet Information Services (IIS), in a directory accessible to the user.

To launch Windows Media Player from a link in a Web page or Web application using an .asx metafile, create a URL in the HTML code similar to the following example:

<A HREF=http://server/file.asx>

This link will send the client to the .asx file which will in turn direct the player to the access point for your content.


Embedding Windows Media Player ActiveX control

You can embed the Microsoft Windows Media Player ActiveX control in a Web page or other application container that supports ActiveX so that Windows Media Player is not started as a separate application. Instead, the content stream you specify in the control properties is played in the browser frame after the page is rendered. This allows you more control over how the user receives the streamed content and is also an easy way of providing Windows Media Player to users who do not have it installed on their computers.

When a user accesses a page in which the control is embedded, a certificate identifying the publisher of the control appears. The certificate prompts the user either to agree to have the control downloaded or to continue rendering the page without downloading the control. Content is not delivered if the control is not installed.

You can set the properties of the control through the HTML <OBJECT> tag, to define which .asf file, publishing point, or station to open, as well as how to play it. You also can use Microsoft Visual Basic scripting to define the properties of the control, such as which buttons are displayed. The following HTML <OBJECT> tag shows the control’s Class ID of Windows Media Player and some of its properties.

<OBJECT CLASSID="clsid:22d6f312-b0f6-11d0-94ab-0080c74c7e95F"
HEIGHT=240
WIDTH=320
NAME=Msshow1
ID=Msshow1
>
<PARAM NAME="FileName" VALUE="mms://MSserver/Msshow1.asf">
</OBJECT>

To learn more about the Windows Media Player control and its properties, see the Microsoft Windows Media Player Control SDK at the Microsoft Web site.

How you set the properties determines how Windows Media Player works. The FileName parameter identifies the .asf file that is played. You set the value for this parameter to be a URL as if you were going to play the .asf file from the Open option on the Windows Media Player File menu.


ASX Metafile Reference

ASX metafiles or .asx files, are text files that, in their simplest form, contain information about the URL for a stream. This information is processed by Microsoft Windows Media Player, which then opens the content defined in the .asx file.

This section contains information about the key features of .asx files that can be used to deliver a stream. For more information about .asx files, see the topic Using ASX Metafiles in the Microsoft Windows Media Player Control SDK in the Microsoft Platform SDK.


Understanding ASX metafiles

An .asx file is a metafile that provides information that Microsoft Windows Media Player uses to receive unicast streams, multicast streams, and other supported media from an intranet or the Internet. These files are loaded quickly by Windows Media Player and contain information for the following purposes:

  • To transfer control from the HTTP browser to the Windows Media Player control so that streams can be directed to Windows Media Player. If you do not have Microsoft Internet Explorer, you cannot define hyperlinks in a Web page using the MMS protocol because the MMS protocol is not recognized. You can link to an .asx file on a Web server that then points Windows Media Player to the Windows Media server via the MMS protocol.
  • To provide an announcement that Windows Media Player can use to access a program on a Windows Media station.
  • To provide references to streams and the rules for protocol rollover that Windows Media Player uses to process them.
  • To provide a playlist that defines the order in which streams are streamed to Windows Media Player.


Using ASX files for seamless stream switching

Normally, when a stream ends, buffering occurs for the next stream before it opens (if it is content received from a streaming media server). Windows Media Services features allow you to implement seamless stream switching, eliminating this buffering time and streaming the next piece of content almost immediately. Seamless stream switching can only be implemented by using an .asx file.

For seamless stream switching to occur, the encoder must include a script command in the stream of type OpenEvent with the event name defined in the Event element in the .asx file. When Microsoft Windows Media Player receives the script command from the encoder, it looks to the Event element in the .asx file and begins opening the stream defined in the Event element. Windows Media Player then holds this information until the event of the same name, in the format Event eventname, is received. When the named event is received, Windows Media Player seamlessly switches to that stream because it has already been opened and buffered.


Using ASX files to create playlists

A playlist consists of multiple Entry elements in an .asx file. Microsoft Windows Media Player plays each Entry element in the .asx file in the order that it appears as though the user had manually opened each clip.

A simple playlist

<ASX version = "3.0">
    <Title>Most requested titles of the day</Title>
    <Entry><Ref href = "mms://nsserver/content/title1.asf" /></Entry>
    <Entry><Ref href = "mms://nsserver/content/title2.asf" /></Entry>
    <Entry><Ref href = "mms://nsserver/content/title3.asf" /></Entry>
    <Entry><Ref href = "mms://nsserver/content/title4.asf" /></Entry>
</ASX>


Windows Media Technologies Glossary

This glossary contains many terms that are helpful in understanding Microsoft Windows Media Technologies.

  • A—B
  • C—H
  • I—O
  • P—T
  • U—Z

A—B

access control list (ACL) checking
A part of Microsoft Windows security that Windows Media Services uses to verify that a client has permission to access a particular file or directory. Using ACL checking, a system administrator can set permission restrictions on an .asf file and on directories.
ActiveX
A Microsoft technology that enables different programs to share information. ActiveX extends Microsoft Windows-based architecture to include Internet and corporate intranet features and capabilities. Developers use it to build user interactivity into programs and World Wide Web pages.
ActiveX controls
Controls that use ActiveX technology. These controls can be downloaded automatically from a Web page and executed by a Web browser.
Advanced Streaming Format (ASF)
A data format for streaming audio and video content, images, and script commands in packets over a network. ASF content can be an .asf file or a live stream generated by Windows Media Encoder. ASF content that is in the process of being delivered over a network is called an ASF stream.
Advanced Streaming Format (.asf) file
An audio or video file that is formatted in ASF.
alias
A name that is substituted for a URL. For example, when creating a station, you can use an alias to specify the information that defines the connection between the Windows Media server components and Windows Media Encoder. For example, Stream1 is the alias for the URL, msbd://server:port. When you are creating a station, you can type Stream1 in the Alias dialog box. The server components resolve this alias by checking it against the definition on the encoder. The benefit of using aliases is that you do not have to remember constantly changing URLs. As long as you know the alias name, the URL can be resolved correctly.
announcement
A simple .asx file that contains information about the URL for a stream. Announcement files are created by Windows Media Administrator when a unicast publishing point or multicast station is created. The client quickly loads the announcement file, then opens the ASF stream in the unicast publishing point or extracts the URL to the ASF stream from an .nsc file and plays a program at the multicast station.
ASFCheck
A command-line utility for detecting and fixing some of the problems that are commonly found in ASF version 1.0 files.
ASFChop
A command-line utility for trimming the beginning or end of an ASF stream that has been stored by Windows Media Encoder.
ASFEditor
See Windows Media Author.
ASF root directory
See Home publishing point.
ASF Stream Descriptor (.asd) file
A configuration file created and read by Windows Media Encoder. The file contains Encoder settings that describe the characteristics of a multimedia stream. The file also is read by the Windows Media Station service to define the stream format supported by a given station.
ASF Stream Redirector (.asx) file
An ASX metafile that provides information that Microsoft Windows Media Player uses to receive unicast streams, multicast streams, and other supported media from an intranet or the Internet. These files are loaded quickly by Windows Media Player and contain information for the following purposes:
  • To transfer control from the HTTP browser to the Windows Media Player control so that streams can be directed to Windows Media Player.
  • To provide an announcement that Windows Media Player can use to access a program on a Windows Media station.
  • To provide references to streams and the rules for protocol rollover that Windows Media Player uses to process them.
  • To provide a playlist that defines the order in which streams are streamed to Windows Media Player.

attribute
In an .asx file, a qualifier that describes a property of an ASX element. For example, an .asx file can include the element Repeat that contains the attribute Count. This particular element and attribute define the number of times the client repeats the playback of the piece of content or the playlist.
Audio Compression Manager (ACM)
A device driver manger that controls which applications are required to play or record sounds. The ACM manages the following types of drivers:
  • Compressor and decompressor (codec) drivers
  • Format converter drivers
  • Filter drivers

If a source file was created on a non-Windows computer, it may not use an ACM codec and thus can not be used by Windows Media Technologies.

authentication
The process of verifying logon information for a client. A Windows Media server can be set to authenticate clients before they are given access to ASF content or streams.
authorization
The process of granting or denying access permissions to clients. A Windows Media server can be set to authorize client requests for ASF content.
bandwidth
The amount of data that can be transmitted in a fixed amount of time. On computer networks, higher bandwidth indicates faster data transfer. Network bandwidth is expressed in bits per second (bps).

In the Windows Media Services environment, Windows Media Administrator can specify bandwidth constraints for a variety of functions, including maximum aggregate bandwidth unicast from a server, maximum bandwidth for a single unicast stream from a server, and continuous bandwidth used by a multicast file transfer from a server.

bit rate
The speed at which binary content can be streamed across a network. It usually is measured in kilobits per second (Kbps)—for example, 28.8 Kbps. Windows Media Encoder and Windows Media Administrator have settings for the bit rate of ASF content.
broadcast
Describes how a client experiences receiving a stream. A broadcast stream can be multicast or unicast. In a broadcast connection, the client is passive and does not control when the stream starts or stops. In contrast, in an on-demand connection, the client is active and controls when the stream is started or stopped.
broadcast multicast
Delivery of one stream by a Windows Media server to many clients, which listen to it by monitoring the IP address over which the stream is multicast. From the client perspective, a broadcast multicast is a connectionless experience because the client never connects to a Windows Media server.
broadcast unicast
A point-to-point connection that a client initiates to a publishing point on a Windows Media server.
buffer
An area of memory reserved for use as an intermediate repository in which data is temporarily held while waiting to be transferred between two locations. A buffer ensures that there is an uninterrupted flow of data between computers.

C—H

Caption
A feature that sends a Synchronized Accessible Media Interchange (SAMI) file (a file in closed-caption format) with an ASF stream. Captioning is an accessibility feature that displays captions along with the video and audio, much like the closed-captioning that accompanies some television programs. It also can be used to display subtitles in a foreign language.
channel
See station.
client
Typically, the software that makes requests in client/server communications. Client software requests connections and communicates with servers.
codec
Short for compressor/decompressor. An algorithm or scheme used when recording digital video or audio. A codec is used, for example, when video is transmitted over the Internet; the video is compressed on the sending end and decompressed on the receiving end. Windows Media Tools provides a choice of codecs for ASF content. Users can select a codec based on the audio or image quality, and image size preferred.
content
Data that servers stream to a client or clients via unicast or multicast. Content can originate from live audio or live video presentation, stored audio or video files, still images, or slide shows. The content needs to be transformed from its original state into ASF in order for a server to stream it. Windows Media servers can stream live ASF streams or stored .asf files as content.
destination address
An IP address and port, from which a listening client can receive a multicast. A client instructs its network card to listen for packets arriving at the destination address and port.
distributed Component Object Model (DCOM)
An extension of the Component Object Model (COM). DCOM enables software components to communicate directly with each other across networks, including the Internet and intranets, in a reliable, secure, and efficient manner.
distribution
Delivering an ASF stream from one server to another. Distribution serves many purposes, such as:
  • Distributing a stream to another server, which then unicasts the stream, allowing clients in a part of the network that is not enabled for multicasts to receive the stream.
  • Distributing a stream to a server that is enabled for HTTP streaming. This allows users behind a firewall to receive a stream that they otherwise would not be able to receive.
  • Distributing a stream from one Windows Media server to another Windows Media server, in order to create more unicast streams. For example, if you have reached the maximum number of unicast streams for a server, you can send a stream to another server, which then can unicast that stream to more clients.

distribution mode
A setting of Windows Media server components that indicates whether Windows Media server components are going to multicast the ASF stream, distribute the ASF stream (via unicast), or do both. If the distribution mode is set to multicast only, then the server broadcasts the ASF stream via multicast and unicast. If the distribution mode is set to distribution only, then the server delivers the ASF stream if requested by another server that is going to broadcast the ASF stream. If the distribution mode is set to both, then the multicast mode and the distribution mode are functional.
element
In an .asx file, an entity that defines a particular setting or action to the client. Elements can be modified by attributes. For example, a ref element has attributes that define the URL that points to particular content.
encoder
See Windows Media Encoder.
error correction
A method for controlling data transfer errors in a unidirectional communication system. Extra information is sent, along with the data, that the receiver uses to check and correct the data.
Error Correction Code (ECC)
The method of error correction used in an earlier version of Windows Media Services. Redundant data is sent with the data stream to detect and control single bit errors in the data stream. In the current version of Windows Media Services, streaming errors are corrected through UDP resend.
File Transfer service (FTS)
A feature of Windows Media Services that multicasts files over a network to an ActiveX control (Nsfile.ocx) on a client computer.
firewall
A system or combination of systems that enforces a boundary between two or more networks, and keeps unauthorized users out of private networks. A firewall system checks all incoming and outgoing messages to make sure they meet predetermined security criteria.
frame
One static image of many sequential images that make up a video title.
frame rate
The speed at which individual frames change. High frame rates generally produce better quality images.
home directory
See Home publishing point.
Home publishing point
The root directory for publishing ASF content. Microsoft Windows Media Player can stream any .asf files placed in this directory or its subdirectories. A home publishing point is also an on-demand publishing point. Unlike other publishing points, a home publishing point does not have an alias. Instead, the computer name is used in a URL for access to the home publishing point. Also called the ASF root directory.

I—O

illustrated audio
A stream that combines audio content with synchronized images to make up an online slide show that runs at low bandwidths.
image color matching (ICM)
An application interface that communicates the color information of each device so that applications can accurately display, print, and pass colors on to other users and applications. Other operating systems may use different color matching schemes. Video content created using non-ICM data does not render correctly on Windows based computers.
Integrated Services Digital Network (ISDN)
A completely digital telephone/telecommunications network for carrying voice, text, images, and video traffic at high speed by sending digitally-encoded signals.
Internet Protocol address (IP address)
A 32-bit number that is the unique IP address of each computer or device on the Internet. This number specifies a physical location, or node, on the network.
Internet Server API (ISAPI)
A framework for creating a dynamic link library (DLL) to provide Internet server-side functionality. Windows Media Services uses ISAPI to provide one of the options for security.
intranet
A network belonging to an organization. Only members of that organization have access to it. An intranet that is connected to the Internet usually is protected by a firewall or other device.
listen
To monitor a specific multicast IP address. Microsoft Windows Media Player monitors a multicast IP address for data that is being streamed from a server.
local
Close at hand or restricted to a particular area. In communications, a local device is one that can be accessed directly rather than by means of a communications link. In information processing, a local operation is one performed by the computer at hand rather than by a remote computer. For example, the server computer on which Windows Media Services is installed is the local computer with respect to that server.
log
To collect and store data about Windows Media Services events. Windows Media Administrator can log information about unicasts, multicasts, and clients.
marker
A pointer to a specific place, measured in time, in an .asf file. Microsoft Windows Media Player uses markers to go directly to a point in an .asf file. Markers in an .asf file allow viewers to skip ahead to a marker or skip back to a previous marker in order to see a particular part of the .asf file again.
Media Stream Broadcast Distribution protocol (MSBD protocol)
A protocol used to reference a Windows Media Encoder, which is the source of a stream, such as msbd://server_name. It also is used when streaming from the Windows Media Station service to a content-storage server. In addition it is used for server to server distribution.
metadata
In a Windows Media Technologies system, information about content, such as the title, author or copyright. The information is contained in an .asx file.
metafile
In a Windows Media Technologies system, a text file that contains information, for media content. Windows Media Services use three kinds of metafiles: .asd file metafiles, .asx file metafiles, and .nsc file metafiles.
Microsoft Internet Explorer
A Windows-based Web browser produced by Microsoft Corporation. Microsoft Internet Explorer version 5 is used by Windows Media Services in several ways. For example, Windows Media Administrator uses Internet Explorer to display its Web pages. Content creators can embed the Microsoft Windows Media Player ActiveX control in an HTML page that is viewed with Internet Explorer.
Microsoft Media Server protocol (MMS protocol)
A protocol used to reference and stream .asf files from a Windows Media server.
Microsoft Windows Backup
A utility that helps you protect data from accidental loss if your system experiences hardware or storage failure.
Microsoft Windows Media Player
A client program or control that receives streaming media from a Windows Media server. This control either can run as a stand-alone client executable program or can be embedded in a Web page, C++ program, or a Microsoft Visual Basic program that uses the client ActiveX control. Microsoft Windows Media Player is the first version that is a universal player.
multicast
A one-to-many connection in which multiple clients can receive the same stream from a server. To receive a multicast, a client must have access to a multicast-enabled network. In contrast, a unicast is a one-to-one connection in which one client receives a distinct stream from a server.
multicast-enabled network
A network that has routers that can interpret Class D IP addresses.
multiple bit rate video
A feature of Windows Media Technologies that supports the creating and streaming of six encoded video streams within one ASF stream. Using multiple bit rate video in Windows Media Encoder creates ASF content that has a variety of video streams at variable bandwidths for either low or high bandwidth target audiences. When creating multiple bit rate content for low bandwidth audiences, the video streams can range from 18 Kbps to 300 Kbps. Alternatively, high bandwidth target audiences include video streams that range from 81 Kbps to 10 Mbps. Both target audiences include a separate encoded audio stream. When encoding multiple bit rate video, an additional insurance video stream is also encoded that is based on a percentage of the lowest selected bandwidth. After receiving this multiple encoded stream, the server determines which bandwidth to stream based on the network bandwidth available. Multiple bit rate video is not supported on generic HTTP servers.
.ocx
Frequently used as a synonym for an ActiveX control, .ocx is the file name extension for a control.
on-demand
Describes stored media content that is available for streaming on a Windows Media Services system. Windows Media Services can stream either stored content from a publishing point, or live content using Windows Media Encoder.
on-demand unicast
A point-to-point connection that a client initiates to a publishing point. In an on-demand unicast, the server streams stored content to the user.

P—T

packet
A unit of data transmitted over a network. A packet is of fixed size, and is routed between a source and a destination. It contains binary information that represents both data and a header containing an ID number, source address, and destination address.
padding
Empty space that is appended to individual packets in a content stream to keep packet size constant. Windows Media Services supports variable packet length. However, Windows Media Encoder limits packets to a fixed length to ensure compatibility with earlier versions of Windows Media Services.
payload
A data unit that contains one or many stream data objects.
player
A client program or control that receives content streamed from a Windows Media server. Throughout the online Help, this refers to Microsoft Windows Media Player.
playlist
A list of streams that Microsoft Windows Media Player plays sequentially. Windows Media Services supports both server-side and client-side playlists.
  • A server-side playlist is played as part of a program over a station. You use the Streams button on the Stations page of Windows Media Administrator to create the playlist. A server-side playlist can include URLs that point to streams, including .asf files.
  • A client-side playlist is an .asx file that contains multiple Entry elements. Windows Media Player plays the Entry elements in the order in which they appear in the .asx file.

port
A location on a server from which content streams to a client. A port is represented by a number that is part of a URL. Windows Media server components, when in use, bind to ports. By default, the Windows Media Unicast service binds to port 1755 and the Windows Media Station service binds to port 7007. If HTTP streaming is enabled for a service, then that service switches to use port 80, which is the preferred port for any HTTP streaming. You can change the ports that any of the Windows Media server components use by editing the registry.
program
One or more streams that Windows Media server components manage as a single entity. The program can be thought of as a container holding streams.
property
A characteristic of an object, such as a stream. For example, Windows Media Encoder displays stream properties, such as the bandwidth and the codec used, on a properties page.
protocol
A set of formats and procedures that enable computers to exchange information. Protocols that Windows Media Services use include HTTP, MMS, and MSBD.
protocol rollover
A procedure that allows switching from one protocol to another when a Windows Media server fails to make a connection using a particular protocol. For example, if a client uses MMS protocol to request ASF content, the server attempts to stream the ASF content using UDP. If that protocol fails, then the server attempts to stream the content using TCP, and then if that fails, the server attempts to use HTTP, if it has been enabled. Protocol rollover is not utilized if either MMSU protocol (MMS over UDP) or MMST protocol (MMS over TCP) is used to request ASF content.
proxy server
A server computer that controls Web-based traffic between local area networks and the Internet or other intranets.
publishing point
A virtual directory used for storing content that is available to clients, or for accessing a live stream. Clients reach a publishing point through its URL.
Publishing Point Events Monitor
A tool that monitors and displays server unicast events. Specifically, the Publishing Point Events Monitor displays unicast server (publishing point) event activities.
QuickStart
A group of wizards in Windows Media Technologies that are used for such tasks as configuring Windows Media Encoder and creating stations or publishing points.
remote
Not in the immediate vicinity or not directly accessible. A computer or other device located in another place (room, building, or city) and accessible through some type of communications link. For example, Windows Media Administrator can be run on a computer (a remote computer) other than the Windows Media server, so that a remote administrator can administer the server. Windows Media Encoder also can be run from a remote computer.
router
A device that connects two or more networks, and carries data forward. A router determines where the destination computer is located, and then finds the best way to transmit the data there.
scope
In multicasting, the reach of a stream. Windows Media Administrator enables the user to define the scope of a multicast. The scope of a multicast stream can be set to reach only an immediate subnet, or it can be set to reach the entire Internet. Scope is also equal to time-to-live (TTL).
script commands
Special instructions that are included in ASF data streams and delivered to the client. Microsoft Windows Media Player passes script commands to a device or an application that interprets them. Script commands are used for such tasks as calling specific files or navigating to a specific Web site.
security
The process of controlling access to resources based on user credentials and permissions. In a Windows Media Services environment, security means restricting and controlling access to Windows Media server components, Windows Media Administrator, and Windows Media content, both stored and streamed. Windows Media Services has built-in security mechanisms that integrate with Microsoft NTLM. Windows Media Services supports both server-side and client-side authentication.
station
A defined location from which a player can receive streams. In effect, it is an IP address and a port. Windows Media server components use stations with ASF streams only, and save station information as a file with an .nsc extension.
stream
Data transmitted across a network and any properties associated with the data. Streaming data allows the player to begin rendering the data immediately instead of waiting for the entire file to be downloaded.
stream data object
Data that represents an individual data type within the ASF stream, for example, a compressed video frame.
stream format
Information about the correct settings necessary for a player to render a stream properly. This information contains such settings as the bit rate, the size of the image, and the codec. Stream formats can be template stream formats or custom stream formats. Stream formats are contained in .nsc, .asd, and .asf files.
template stream format (TSF)
In Windows Media Technologies, a predefined group of settings that match content type and bit rate with appropriate audio and video codecs. Windows Media Encoder uses this feature to assist the user in quickly configuring the encoder to create ASF content.
time-to-live (TTL)
In multicasting, a value that defines the number of routers through which a multicast can pass before a router stops forwarding the multicast. TTL is equivalent to scope.

U—Z

unicast
A client/server connection in which a client receives an on-demand stream of stored content from a server, or receives a broadcast of live content. No other client has access to this stream. In contrast, a single multicast stream is available to multiple clients.
unicast rollover
A procedure that Microsoft Windows Media Player follows if it cannot receive a multicast from a station on a Windows Media server. Windows Media Player sometimes cannot receive a multicast for several reasons, including the absence of multicast-enabled routers on the network. If Windows Media Player cannot receive the multicast, it uses the unicast rollover URL contained in the .nsc file to connect to a server and request a unicast of the stream.
Universal Naming Convention (UNC)
Also called Uniform Naming Convention. A convention for specifying directories, servers, and other resources on a network, using two slashes // or backslashes \\ to indicate the name of the computer, and one slash to indicate path or directory levels within the computer, in this format: \\computer\directory.
URL flips
A set of instructions to the browser to change the content being displayed on a Web page, regardless of the state of the display. This is what enables the user to link from one page to another without waiting for the content on the first page to be completely rendered.
URL rollover
A rollover method used to specify different Windows Media servers that contain the same content. For example, if the first REF tag in a .asx file specifies an .asf file on a server called hound1 and the second REF tag specifies a copy of the file on hound2, Windows Media Player can reach the file using either server. If hound1 is too busy or fails, Windows Media Player automatically connects to hound2.
User Datagram Protocol (UDP)
A connectionless transport protocol in the TCP/IP protocol stack that, like TCP, runs on top of IP networks.
video capture card
An add-on board for providing digitized images on a computer. With a video capture card, you can provide live camera or VCR input to Windows Media Encoder.
VidToASF
A command-line utility that quickly converts an edited .avi or .mov file to an .asf file so that it can be stored on a Windows Media server and streamed to clients.
WavToASF
A command-line utility that quickly converts an edited .wav audio file to an .asf file so that it can be stored on a Windows Media server and streamed to clients.
Windows Media Administrator
A Web-based administrative application for monitoring real-time usage of Windows Media component services, managing content, and configuring the system.
Windows Media ASF Indexer
A Windows-based utility for deleting portions of an ASF stream that has been stored by Windows Media Encoder. You also can use Windows Media ASF Indexer to edit properties, markers, and script commands.
Windows Media Audio (.wma) file
A special type of advanced streaming format file for use with audio-only content encoded with the Windows Media Audio codec.
Windows Media Audio Redirector (.wax) file
A special type of .asx metafile for use with .wma files. The .wax file includes information about the location of the .wma file on the Windows Media server and the properties of the file.
Windows Media Author
A graphical interface tool for creating and testing illustrated audio. The tool is designed to combine and synchronize audio and image files. Using it, the author can manage objects—sounds, images, and URLs—so that they appear at the correct time during playback. This tool uses technology from Digital Renaissance, Inc.
Windows Media client
The ActiveX control called Microsoft Windows Media Player that receives and renders ASF content from Windows Media server components. The client can be on the same computer as the server, or it can be on another computer.
Windows Media component services
A set of services running on a Windows Media server. These services multicast and unicast live audio and video presentations and stored files to client computers.
Windows Media Encoder
A feature of Windows Media Technologies used to create live ASF streams. Windows Media Encoder turns live audio and video content into an ASF stream and distributes that stream through a port. Windows Media Encoder also can save an ASF stream as an .asf file. Windows Media Encoder can distribute an ASF stream via MSBD protocol or HTTP.
Windows Media Plug-in for Adobe Premiere
A utility that allows a content creator to use Adobe Premiere to produce ASF content for Windows Media Technologies.
Windows Media Presenter for Microsoft PowerPoint 97
A Windows Media Technologies feature, available from within Microsoft PowerPoint 97. It enables PowerPoint to connect to Windows Media Encoder and to send a PowerPoint presentation to a Windows Media server for distribution to client computers.
Windows Media program (.nsp) file
A file that contains information about a Windows Media Services program, used primarily in backing up and restoring Windows Media Services program definitions.
Windows Media server components
Another term for Windows Media Services, which is used to multicast and unicast live audio and video presentations and stored files to client computers. Includes both Windows Media component services, which run on a Windows Media server and Windows Media Administrator, which is used to manage these services.
Windows Media Services
Another term for Windows Media server components, which is used to multicast and unicast live audio and video presentations and stored files to client computers. Includes both Windows Media component services, which run on a Windows Media server and Windows Media Administrator, which is used to manage these services.
Windows Media Station (.nsc) file
A file that describes a station to the player. The player accesses the station file indirectly by way of an .asx file that directs the client to a specific .nsc file.
Windows Media Monitor service
One of the Windows Media component services.
Windows Media Program service
One of the Windows Media component services.
Windows Media Station service
One of the Windows Media component services that provides multicasting, distribution, and storage functions for ASF streams. It can manage multiple stations, with each station having an ASF stream as input, and direct the stream to a multicast address, one or more distribution servers, a disk, or a combination of all three. A similar feature, Windows Media Unicast service, is available for unicasting ASF streams.
Windows Media Technologies
The family of streaming media applications that includes Windows Media Services, Windows Media Tools, and Windows Media Player. Windows Media Tools create ASF content that can be served to client computers using Windows Media Services and played with Windows Media Player.
Windows Media Tools
A set of tools that can be used to create ASF content for Windows Media Services. These tools include Windows Media Encoder, Windows Media Author, and Windows Media ASF Indexer; the conversion utilities VidToASF and WavToASF; and the file utilities ASFCheck and ASFChop.
Windows Media Unicast service
One of the Windows Media component services that provides unicasting functions for ASF streams. This service manages publishing points to which clients connect in order to receive either broadcast unicast streams or on-demand unicast streams. A similar feature, Windows Media Station service, is available for multicasting ASF streams.


Digital Rights Management

Digital Rights Management (DRM) is the technology for securing content and managing the rights for its access. This technology is still being developed and researched; however, the first step toward preventing piracy of digital media content is being taken with the introduction of Windows Media Rights Manager. Windows Media Rights Manager will help you protect and secure your audio and video content through encrypting source .asf , .mp3, and .wav files into packaged .asf files and by providing licenses to your users. By implementing this feature, you will be able to know who has copies of your content and place a digital signature on each piece of content you distribute.

Using Windows Media Rights Manager will have an impact on your entire streaming system. This overview touches on some of the areas of interest for content creators, web-publishers, and end-users. For more detailed information see the Windows Media Technologies page at the Microsoft Web Site or the Windows Media Rights Manager documentation.


Content creators

Windows Media Rights Manager provides a way for you to secure your content before distributing it to internet service providers through use of Windows Media Packager. When you are creating ASF content, if you wish to implement DRM on your .asf file you have two options:

  • Use Windows Media Tools to create the .asf file, then use Windows Media Packager to package the file.
  • Use Windows Media Packager to directly create a packaged file.

Packaging a file does several different things:

  • Encrypts the file with a private key
  • Sets the URL to the license server
  • Sets the URL to the official web site
  • Includes any banners or images into the file
  • Sets the properties for Title, Artist, Copyright, and Genre.

Once a file has been packaged, it can not be modified by the Windows Media Tools. Properties of the file are set and protected from modification. Therefore, if you have a piece of content that you may want to modify later, it is best to create the file with Windows Media Tools first, save a back up copy, and then create the packaged file.


Web publishing

The Windows Media Rights Manager includes a Site Wizard to help you publish packaged content on your web site. Once a piece of content has been packaged, users will need a valid license to play the content. License verification occurs when users try to play the content. If users do not have a valid license on their computer, the browser is launched to take them to your web site to register their content. Once the user has registered with you, a valid license and decryption key will be downloaded to the computer and the content will play.

As the publisher you are required to maintain the databases of licenses and users. Windows Media License Service uses a SQL Server database, so you must have SQL Server installed prior to installation of the Windows Media Rights Manager. Window Media Services is also required to stream packaged content.

Installation of Windows Media Rights Manager includes installation of Windows Media Packager to manage content and licenses on your site:


User experience

Users need Microsoft Windows Media Player 6.2 to play packaged files. Packaged files can be streamed from a Windows Media server or can be downloaded for local play. If the correct version of Windows Media Player is not present on the user's computer when the user attempts to play the protected content, the user's browser opens and navigates to a download site where the user can download Windows Media Player.

Windows Media Player checks if the user has a license to play the content. If the user does not have a valid license, the user's browser opens and navigates to the license registration page on your Web site. A license is issued after the user fills out the registration information, and then Windows Media Player will play the content. The user can play the content until the license expires. The user is informed during license download the terms of the license. A license can be for an unlimited time, a set amount of time, or a set number of playbacks. However, if a registered user copies the content and shares it with another user, that user is required to go through the registration experience. Licenses and decryption keys cannot be copied and shared among different computers.

When Windows Media Player plays protected content, the user sees the following items:

  • The content title.
  • The artist name.
  • A copyright notice.
  • A banner image.
  • Video images.
  • A legitimacy icon, indicating that the content is protected and has not been tampered with.

In addition, clicking different areas of the window opens the user's web browser to a corresponding URL. For example, clicking the banner image might open the distributor's web site, and clicking the title might open the artist's web site.


Finding more information

Windows Media Rights Manager is a new and exciting technology for use with audio and video content. You can obtain the Windows Media Rights Manager Requirements and Installation Guide from the Window Media Technologies page at the Microsoft Web site.

This guide lists the requirements for hardware and software that must be met before you can install Windows Media Rights Manager. It also describes the Windows Media Rights Manager installation process, discusses the required media and image files formats, outlines the encryption process, and discusses watermarking and pre-encoding options for your content.

Use the Quick Start Guide to get your Windows Media Rights Manager Web site up and running quickly.

Windows Media Rights Manager is available for you to download on the Windows Media Technologies downloads page at the Microsoft Web Site.


Legal Notice

Information in this document, including URL and other Internet Web site references, is subject to change without notice. The example companies, organizations, products, people and events depicted herein are fictitious. No association with any real company, organization, product, person or event is intended or should be inferred. Complying with all applicable copyright laws is the responsibility of the user. Without limiting the rights under copyright, no part of this document may be reproduced, stored in or introduced into a retrieval system, or transmitted in any form or by any means (electronic, mechanical, photocopying, recording, or otherwise), or for any purpose, without the express written permission of Microsoft Corporation.

Microsoft may have patents, patent applications, trademarks, copyrights, or other intellectual property rights covering subject matter in this document. Except as expressly provided in any written license agreement from Microsoft, the furnishing of this document does not give you any license to these patents, trademarks, copyrights, or other intellectual property.

Ó 1996-1999 Microsoft Corporation. All rights reserved.

Microsoft, MS-DOS, MS, Windows, Windows Media, Windows NT, ActiveX, FrontPage, JScript, Microsoft Press, NetShow, PowerPoint, Visual Basic, Visual C++, Visual InterDev, Visual J++, Win32 and Win32s are either registered trademarks or trademarks of Microsoft Corporation in the U.S.A. and/or other countries.

Macintosh is a registered trademark of Apple Computer, Inc. used under license.

Premiere is a registered trademark of Adobe Corporation.

Other product and company names mentioned herein may be the trademarks of their respective owners.

The following statements apply only to the Python Language runtime:

Copyright © 1991-1995 by Stichting Mathematisch Centrum, Amsterdam, The Netherlands. All Rights Reserved. Permission to use, copy, modify, and distribute this software and its documentation for any purpose and without fee is hereby granted, provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice appear in supporting documentation, and that the names of Stichting Mathematisch Centrum or CWI not be used in advertising or publicity pertaining to distribution of the software without specific, written prior permission.